;Disassembled by:
;	DASMx object code disassembler
;	(c) Copyright 1996-2003   Conquest Consultants
;	Version 1.40 (Oct 18 2003)
;File:	ti5ds6.bin
;Size:	8192 bytes
;Date:	Mon Nov 09 13:49:29 2015
;CPU:	Intel 8080 (MCS-80/85 family)	

; Command for building binary image using TASM32 assembler:
; tasm -85 -g3 ti5ds6.asm ti5ds6.bin
; g0 selects Intel Hex output format
; g3 selects binary output format

; 1/27/16  Adding optional fix for power-up MIDI channel range

; 	Change default MIDI channel range to be correct for Poly mode
;	#DEFINE	RANGEFIX
				
; I/O addresses used in TI-5:

;	50	;out
;	51	;in, out
;	54
;	55	4345 is shadow?

;	58	441B is shadow
;	59	441C is shadow
;	5A	441D is shadow
;	5B	441E is shadow	
;	5C	441F is shadow
;	5D	4420 is shadow   
;	5E	4421 is shadow		
;	5F	4422 is shadow
;	DS8 code polls 5F if checksum fails (sw row 7), waiting for key press

;	70	in, maybe just using D0?
;		this may be pot debug enable

;	B0,B3
;	B8	in, 8251
;	B9	(8251)

;	EC	;4044 nibble written here
;	ED	;4044 nibble written here
;	EE	;4045 nibble written here
;	EF	;4045 nibble written here

;	We still have 5252 followed by Out 54
;	Reading from 8000-8007 (keyboard)
;	Seems like the arpeggiator always uses voice 1.

MIDItxbufbeg	.equ	04000h	;start of MIDI tx buffer
MIDItxbufend	.equ	0401Fh	;end of MIDI tx buffer
MIDIrxbufbeg	.equ	04020h	;start of MIDI rx buffer
MIDIrxbufend	.equ	0403Fh	;end of MIDI rx buffer
MIDItxrdptrL	.equ	04040h	;low byte of MIDI tx buf rd ptr
MIDItxwrptrL	.equ	04041h	;low byte of MIDI tx buf wr ptr
MIDIrxrdptrL	.equ	04042h	;low byte of MIDI rx buf rd ptr
MIDIrxwrptrL	.equ	04043h	;low byte of MIDI rx buf wr ptr

VceRAM1beg	.equ	04080h	;start of RAM for voice 1

MIDImsg0	.equ	04100h	;seems like MIDI out messages are formed in the next few addresses
MIDImsg1	.equ	04101h
MIDImsg2	.equ	04102h
MIDImsg3	.equ	04103h
MIDImsgtmp	.equ	04104h

UARTcmdshdw	.equ	04105h	;shadow for UART cmd register
actsensctr	.equ	04106h	;paces transmission of act sensing bytes (every 8th inc)
statbyte	.equ	0410Ch	;last MIDI status byte is saved here
				;low 4 bits are adjusted to contain channel offset, so if
				;base channel is 3 and MIDI status channel is 5, it would hold 2
MIDIjmpadL	.equ	0410Fh	;we jump to this address after grabbing a non-status MIDI byte
MIDIjmpadH	.equ	04110h	;high byte

splitpoint	.equ	04114h	;defaults to 047h, MIDI value for B just below middle C
				;C is first note of upper keyboard section		
LstKeyMIDI	.equ	04116h	;seems to be MIDI note number for last key pressed

				;key row data array,
				;holds last value read from hw for each row 
				;0 should mean key is down			
KeyRowDat0	.equ	04121h	;row 0 (first row)
KeyRowDat1	.equ	04122h	;1	
KeyRowDat2	.equ	04123h	;2
KeyRowDat3	.equ	04124h	;3
KeyRowDat4	.equ	04125h	;4
KeyRowDat5	.equ	04126h	;5
KeyRowDat6	.equ	04127h	;6
KeyRowDat7	.equ	04128h	;7

currprog	.equ	0412Fh	;seems to contain current prog number, from 0-255, including the bank info
				;although BankD programs seem to be 0-63

LFOfreq		.equ	04132h	;seems like LFO freq value from patch is placed here
modeval		.equ	04133h	;same as mode, but a 0-3 value, 0:Poly,1:Split,2:Dual,3:Mono
currvce		.equ	04134h	;seems like index of current voice when we are accessing its RAM area (0-7)
SecFcnEn	.equ	04135h	;seems to control normal/second fcn for dual-fcn front panel switches
				;D0 1 Enables mode on Prog Sel 1-4
				;D1 1 Enables mode on Prog Sel 4-7
				;D2 1 for normal fcn, 0 for mode 

row1save	.equ	04138h	;LED row 1 contents saved here when we switch Mode on
row2save	.equ	04139h	;LED row 2 contents saved here when we switch Mode on
moderow1	.equ	0413Ah	;row 1 Mode bits displayed in Prog Sel 1-4 (in upper 4 bits)
moderow2	.equ	0413Bh	;row 2 Mode bits displayed in Prog Sel 5-8 (in upper 4 bits)		
moderow5	.equ	0413Fh	;row 5 Mode bits displayed in Prog Grp 1-4 (in upper 4 bits)
				;D4: Sync
				;D5: Sequ
				;D6: Omni
				;D7: Channel 
moderow6	.equ	04140h	;row 6 Mode bits displayed in Prog Grp 5-8 (in upper 4 bits)
				;D4: Poly
				;D5: Split
				;D6: Dual
				;D7: Mono
moderow7	.equ	04141h	;holds mode bits in normal mode, and normal bits when Mode is enabled
				;row 7 Mode bits displayed in Waveform Edit area (in low 4 bits)
				;D0: MIDI In enable
				;D1: MIDI Out Enable
				;D2: KB1 (MIDI out enable?)
				;D3: KB2 (MIDI out enable?)
				;row 4 Mode bits displayed in Bank area (in upper 4 bits)	
				;D4: MIDI assign Bend
				;D5: MIDI assign Pedal
				;D6: MIDI assign Panel
				;D7: MIDI assign "tembre"

VceRAM2beg	.equ	04180h	;start of RAM for voice 2

vce1kdat0	.equ	04200h
vce1kdat1	.equ	04201h
vce1kdat2	.equ	04202h	;seems to hold MIDI note number assigned to voice 1
				;either from a key press or from the sequencer

vce2kdat0	.equ	04204h
vce2kdat1	.equ	04205h
vce2kdat2	.equ	04206h	;seems to hold MIDI note number assigned to voice 2

vce3kdat0	.equ	04208h
vce3kdat1	.equ	04209h
vce3kdat2	.equ	0420Ah	;seems to hold MIDI note number assigned to voice 3

vce4kdat0	.equ	0420Ch
vce4kdat1	.equ	0420Dh
vce4kdat2	.equ	0420Eh	;seems to hold MIDI note number assigned to voice 4

vce5kdat0	.equ	04210h
vce5kdat1	.equ	04211h
vce5kdat2	.equ	04212h	;seems to hold MIDI note number assigned to voice 5

vce6kdat0	.equ	04214h
vce6kdat1	.equ	04215h
vce6kdat2	.equ	04216h	;seems to hold MIDI note number assigned to voice 6

vce7kdat0	.equ	04214h
vce7kdat1	.equ	04215h
vce7kdat2	.equ	04216h	;seems to hold MIDI note number assigned to voice 7

vce8kdat0	.equ	04214h
vce8kdat1	.equ	04215h
vce8kdat2	.equ	04216h	;seems to hold MIDI note number assigned to voice 8

keyvar1		.equ	04224h	;seems like index of last voice unassigned * 4
keyvar2		.equ	04226h	;possibly index of next voice to assign * 4
keyvar3		.equ	04228h	;seems like index of last voice assigned*4
keyvar4		.equ	04229h	;seems like index of last voice assigned*4

VceRAM3beg	.equ	04280h	;start of RAM for voice 3

keyarray1	.equ	04300h	;seems to hold a value for each key, 8 while key is pressed, then counts
				;down to 0 after key is released, one count for each keybd scan
				;first element is for C0 key, second is for the ninth key, third is for the 18th key, 
				;so the order is the same as the order in the key row bits
keyarray60	.equ	0433Bh	;top key

;			4345	;shadow for hw at I/O addr 55h

VceRAM4beg	.equ	04380h	;start of RAM for voice 4


;			4400	;pot select code

PotVal0		.equ	04404h	;last value read for pot 0   port step size/rate
PotVal1		.equ	04405h	;last value read for pot 1   Seq/arpeggiator rate
PotVal2		.equ	04406h	;last value read for pot 2,  LFO depth
PotVal3		.equ	04407h	;last value read for pot 3   LFO freq
PotVal4		.equ	04408h	;last value read for pot 4,  tune control, always affects all
				;oscillators, 80H seems to be the "tuned" actual pot value
PotVal5		.equ	04409h	;last value read for pot 5,  detune control, 
				;actual pot value=76h seems to be 0 detune 
				;changing detune pot updates value for oscs 
				;enabled by "select 1" or "select 2" combinations  
				;Unselected oscs keep old detune value.
PotVal6		.equ	0440Ah	;last value read for pot 6,  VCA attack rate
PotVal7		.equ	0440Bh	;last value read for pot 7,  VCA decay rate
PotVal8		.equ	0440Ch	;last value read for pot 8,  shape control
PotVal9		.equ	0440Dh	;last value read for pot 9,  VCA attack final level
PotVal10	.equ	0440Eh	;last value read for pot 10, VCA sustain level
PotVal11	.equ	0440Fh	;last value read for pot 11, VCA release rate
PotVal12	.equ	04410h	;last value read for pot 12, Noise level
PotVal13	.equ	04411h	;last value read for pot 13, filter attack final level
PotVal14	.equ	04412h	;last value read for pot 14, filter sustain level
PotVal15	.equ	04413h	;last value read for pot 15, filter idle level
PotVal16	.equ	04414h	;last value read for pot 16, filter resonance
PotVal17	.equ	04415h	;last value read for pot 17, filter attack rate
PotVal18	.equ	04416h	;last value read for pot 18, filter decay rate
PotVal19	.equ	04417h	;last value read for pot 19, filter release rate

PotVal24	.equ	04418h	;last value read for pot 24, pitch wheel
PotVal25	.equ	04419h	;last value read for pot 25, mod wheel
PotVal26	.equ	0441Ah	;last value read for pot 26, pedal

				;LED map is the same as the switch map

LEDrow0		.equ	0441Bh	;value for LED Row 0 at I/O 058h, or 5858
LEDrow1		.equ	0441Ch	;value for LED Row 1 at I/O 059h, or 5859
LEDrow2		.equ	0441Dh	;value for LED Row 2 at I/O 05Ah, or 585A
LEDrow3		.equ	0441Eh	;value for LED Row 3 at I/O 05Bh, or 585B
LEDrow4		.equ	0441Fh	;value for LED Row 4 at I/O 05Ch, or 585C
LEDrow5		.equ	04420h	;value for LED Row 5 at I/O 05Dh, or 585D
LEDrow6		.equ	04421h	;value for LED Row 6 at I/O 05Eh, or 585E
LEDrow7		.equ	04422h	;value for LED Row 7 at I/O 05Fh, or 585F

				;switch row last data array,
				;holds last value read from hw for each row
				;0 means switch is pressed 
SwStateRow0	.equ	04423h	;
				;D0 this maps to Sequencer rate LED, no switch
				;D1 this maps to LFO rate LED, no switch
				;D2
				;D3
				;D4 16'select
				;D5 8' select
				;D6 4' select
				;D7 2' Select

SwStateRow1	.equ	04424h	;	
				;D0 Sequence Record
				;D1 Sequence Step
				;D2 Sequence Loop
				;D3 Playback Transpose		/ Split Point
				;D4 Program Sel 1
				;D5 Program Sel 2
				;D6 Program Sel 3
				;D7 Program Sel 4

SwStateRow2	.equ	04425h	;
				;D0 Select LFO Ramp Up
				;D1 Select LFO Ramp Dn
				;D2 Select LFO Triangle
				;D3 Select LFO Square
				;D4 Program Sel 5
				;D5 Program Sel 6
				;D6 Program Sel 7
				;D7 Program Sel 8

SwStateRow3	.equ	04426h	;
				;D0 Mode
				;D1 Select
				;D2 "1"
				;D3 "2"
				;D4 Portamento Enable
				;D5 Filter Keyboard Tracking Enable
				;D6 Filter Pedal Control Enable
				;D7 VCA Pedal Control Enable

SwStateRow4	.equ	04427h	;
				;D0 Pitch wheel control of osc pitch enable
				;D1 Pitch wheel filter cutoff mod enable
				;D2 Mod Wheel Controls LFO DCO Freq mod amt
				;D3 Mod Wheel Controls LFO Filt cutoff mod amt
				;D4 Bank A			/ BEND
				;D5 Bank B			/ PEDAL
				;D6 Bank C			/ PANEL
				;D7 Bank D			/ "TEMBRE"

SwStateRow5	.equ	04428h	;
				;D0 Play
				;D1 Pause
				;D2 ArpUp
				;D3 ArpDn
				;D4 Program Group Sel 1		/ SYNC
				;D5 Program Group Sel 2		/ SEQU
				;D6 Program Group Sel 3		/ OMNI ON
				;D7 Program Group Sel 4		/ CHANNEL

SwStateRow6	.equ	04429h	;
				;D0 LFO Freq Mod
				;D1 LFO Shape Mod
				;D2 LFO Filter Mod
				;D3 LFO VCA Mod
				;D4 Program Group Sel 5		/ POLY
				;D5 Program Group Sel 6		/ SPLIT
				;D6 Program Group Sel 7		/ DUAL
				;D7 Program Group Sel 8		/ MONO

SwStateRow7	.equ	0442Ah	;
				;D0 Edit Waveform Rise Time     / MIDI In
				;D1 Edit Waveform PW		/ MIDI OUT
				;D2 Edit Waveform Fall Time	/ KB1
				;D3 Chord			/ KB2
				;D4 Edit
				;D5 Patch Read Mode
				;D6 Patch Store
				;D7
		
noiselev	.equ	04432h	;current noise level (complemented pot value)

				;start of 36-byte array of note info used by arpeggiator
notearray0	.equ	04500h	;first byte of every three is MIDI note number
notearray1	.equ	04501h	;second byte of every three is number 3,6,9,C,etc last note has 27h instead
notearray2	.equ	04502h	;third byte of every three is 0,3,6,9,C, etc  first note has 24h instead
notearray3	.equ	04503h
notearray35	.equ	04523h	;last byte, so twelve note positions available		

arpvar1		.equ	04529h	;starts at 0, then increases by three on each new key pressed while ARP enabled
arpvar2		.equ	0452Ah	;starts at 3, then increases by three on each new key pressed while ARP enabled

arponconst1	.equ	0452Bh	;holds a constant 090h value (note on)
arponnote	.equ	0452Ch	;seems like MIDI note number of note playing (C0 is 030h)
arponconst2	.equ	0452Dh	;holds a constant 040h value (default velocity value)

arpoffconst1	.equ	0452Eh	;holds a constant 090h value (probably used for note off)	
arpoffnote	.equ	0452Fh	;seems like MIDI note number of note playing
arpoffconst2	.equ	04530h	;holds a constant 000h value (note off velocity value)

arpseqvar	.equ	04531h	;0F when first key pressed, then changes to 01 when note starts playing
				;switches to 02 at start of second from the top note after changing dir if up/dn enabled
				;then changes back to 01 at start of second from the bottom note after changing to up dir
arpptrL		.equ	04533h	;this seems to be a pointer into the notearray at address 4500h
arpptrH		.equ	04534h	;high byte

row4comp	.equ	04539h	;complement of value read from I/O addr 5C at startup (sw row 4)
				;seems related to pot debug display

vceRAMptr	.equ	0443Fh	;ptr to start of voice RAM for voice we are accessing

VceRAM5beg	.equ	04480h	;start of RAM for voice 5
VceRAM6beg	.equ	04580h	;start of RAM for voice 6

				;24-byte patch buffer:
				;when a patch is read from EPROM, or writted to RAM, it is placed here first
pbuf00		.equ	04600h	;port rate complemented pot value
pbuf01		.equ	04601h
pbuf02		.equ	04602h	;LFO depth complemented pot value
pbuf03		.equ	04603h	;LFO freq/rate complemented pot value
pbuf04		.equ	04604h	;high nibble LFO waveshape, low nibble LFO destination
pbuf05		.equ	04605h	;chord voice 1 value
pbuf06		.equ	04606h	;de-tune value 
pbuf07		.equ	04607h	;chord voice 2 value
pbuf08		.equ	04608h
pbuf09		.equ	04609h
pbuf0A		.equ	0460Ah	;seems to be the value of whatever shape parm is selected for editing
pbuf0B		.equ	0460Bh	;VCA attack rate complemented pot value
pbuf0C		.equ	0460Ch	;VCA decay rate complemented pot value
pbuf0D		.equ	0460Dh	;VCA release rate complemented pot value
pbuf0E		.equ	0460Eh	;VCA attack final level complemented pot value
pbuf0F		.equ	0460Fh	;VCA sustain level complemented pot value
pbuf10		.equ	04610h	;noise level complemented pot value (from 4432)
pbuf11		.equ	04611h	;filter attack rate complemented pot value
pbuf12		.equ	04612h	;filter decay rate complemented pot value
pbuf13		.equ	04613h	;filter release rate complemented pot value
pbuf14		.equ	04614h	;filter attack final level complemented pot value
pbuf15		.equ	04615h	;filter sustain level complemented pot value
pbuf16		.equ	04616h	;filter idle level complemented pot value
pbuf17		.equ	04617h	;filter resonance complemented pot value

;not assigned yet:
;LFO depth
;detune for osc 1
;detune for osc 2
;osc 1 pw value
;osc 1 chord offset value
;osc 2 chord offset value
;Mono bit?
;2'-16' bits
;osc 2 pw value
;osc 2 fall rate
;osc 2 rise rate
;osc 1 fall rate
;osc 1 rise rate 

savearea0	.equ	0461Ah	;start of 40-byte area that is checksummed
				;save area equiv of addr 4141 (rows 4 and 7 mode bits)
				;D0 MIDI In, 1 enables reception of MIDI messages
				;D1 MIDI Out
				;D2 KB1, 1 seems to enable sending note on/off of lower keybd in split mode
				;D3 KB2, 1 seems to enable sending note on/off of upper keybd in split mode
				;D4 Bend, 1 enables sending Bend controller
				;D5 Pedal, 1 enables sending "Change" controller
				;D6 Panel, 1 enables sending pot values as controllers as we move them
				;D7 Tembre
savearea1	.equ	0461Bh	;settings are saved in this area and moved to main area at start-up
				;save area equiv of addr 413F, row 5 mode bits
MIDIInbase	.equ	0461Ch	;seems to hold base channel number for MIDI In, 0-F
MIDInumchans	.equ	0461Dh	;seems to be number of valid MIDI In channels, starting with base
savearea39	.equ	04641h	;end of 40-byte save area 

VceRAM7beg	.equ	04680h	;start of RAM for voice 7

bankDstrt	.equ	04700h	;upper byte of Prog D Bank Address (0xCC)	
bankCstrt	.equ	04701h	;upper byte of Prog C Bank Address (0xC6)	
bankBstrt	.equ	04702h	;upper byte of Prog B Bank Address (0xC0)	
bankAstrt	.equ	04703h	;upper byte of Prog A Bank Address (0x90)

sysctr1valL	.equ	04704h	;seems to hold current 16-bit timer 1 load value, low byte
sysctr1valH	.equ	04705h	;high byte
B2timerval	.equ	04706h	;holds current value of B2 system timer so we can detect a change

seqstate	.equ	04707h	;seems to hold sequencer state:
				;00 when idle
				;04 when record sw pressed, then switches back to 00 and turns on step LED
				;00 when waiting for first key press
				;02 after first key press (while recording)
				;00 when pause pressed to stop recording
				;80 when play is pressed, but pause still on (waiting to play)
				;01 after pause pressed to start playing (playing)

transpoff	.equ	04710h	;seems to be playback transpose offset 

				;Voice RAM allocation:
Vce8RAM00	.equ	04780h	;start of RAM for voice 8
Vce8RAM01	.equ	04781h	;LFO depth value
Vce8RAM02	.equ	04782h	;LFO freq/rate value
Vce8RAM03	.equ	04783h
Vce8RAM04	.equ	04784h	;chord voice 1 value
Vce8RAM05	.equ	04785h	;de-tune pot value/4 for osc 1
Vce8RAM06	.equ	04786h	;chord voice 2 value
Vce8RAM07	.equ	04787h	;de-tune pot value/4 for osc 2
Vce8RAM08	.equ	04788h
Vce8RAM09	.equ	04789h
Vce8RAM0A	.equ	0478Ah
Vce8RAM0B	.equ	0478Bh
Vce8RAM0C	.equ	0478Ch
Vce8RAM0D	.equ	0478Dh	;glide time value low byte
Vce8RAM0E	.equ	0478Eh	;glide time value high byte
Vce8RAM0F	.equ	0478Fh
Vce8RAM10	.equ	04790h	;VCA attack final level
Vce8RAM11	.equ	04791h	;VCA attack rate value ~pot value/16 
Vce8RAM12	.equ	04792h
Vce8RAM13	.equ	04793h
Vce8RAM14	.equ	04794h	;VCA sustain level ~pot value/16 
Vce8RAM15	.equ	04795h	;VCA decay rate ~pot value/16
Vce8RAM16	.equ	04796h
Vce8RAM17	.equ	04797h
Vce8RAM18	.equ	04798h 	;VCA release rate ~pot value/16
Vce8RAM19	.equ	04799h
Vce8RAM1A	.equ	0479Ah
Vce8RAM1B	.equ	0479Bh	;filter attack final level ~pot value/16 
Vce8RAM1C	.equ	0479Ch	;filter attack rate ~pot value/16 
Vce8RAM1D	.equ	0479Dh
Vce8RAM1E	.equ	0479Eh
Vce8RAM1F	.equ	0479Fh	;filter sustain level ~pot value/16 
Vce8RAM20	.equ	047A0h	;filter decay rate ~pot value/16 
Vce8RAM21	.equ	047A1h
Vce8RAM22	.equ	047A2h
Vce8RAM23	.equ	047A3h	;filter idle level ~pot value/16 
Vce8RAM24	.equ	047A4h	;filter release rate ~pot value/16 
Vce8RAM25	.equ	047A5h
Vce8RAM26	.equ	047A6h
Vce8RAM27	.equ	047A7h
Vce8RAM28	.equ	047A8h
Vce8RAM29	.equ	047A9h
Vce8RAM2A	.equ	047AAh
Vce8RAM2B	.equ	047ABh
Vce8RAM2C	.equ	047ACh
Vce8RAM2D	.equ	047ADh
Vce8RAM2E	.equ	047AEh
Vce8RAM2F	.equ	047AFh
Vce8RAM30	.equ	047B0h
Vce8RAM31	.equ	047B1h
Vce8RAM32	.equ	047B2h
Vce8RAM33	.equ	047B3h
Vce8RAM34	.equ	047B4h	;glide interval value low byte
Vce8RAM35	.equ	047B5h	;glide interval value high byte
Vce8RAM36	.equ	047B6h
Vce8RAM37	.equ	047B7h
Vce8RAM38	.equ	047B8h
Vce8RAM39	.equ	047B9h
Vce8RAM3A	.equ	047BAh
Vce8RAM3B	.equ	047BBh
Vce8RAM3C	.equ	047BCh
Vce8RAM3D	.equ	047BDh
Vce8RAM3E	.equ	047BEh
Vce8RAM3F	.equ	047BFh
Vce8RAM40	.equ	047C0h
Vce8RAM41	.equ	047C1h
Vce8RAM42	.equ	047C2h
Vce8RAM43	.equ	047C3h
Vce8RAM44	.equ	047C4h
Vce8RAM45	.equ	047C5h
Vce8RAM46	.equ	047C6h
Vce8RAM47	.equ	047C7h
Vce8RAM48	.equ	047C8h
Vce8RAM49	.equ	047C9h
Vce8RAM4A	.equ	047CAh
Vce8RAM4B	.equ	047CBh
Vce8RAM4C	.equ	047CCh
Vce8RAM4D	.equ	047CDh
Vce8RAM4E	.equ	047CEh
Vce8RAM4F	.equ	047CFh
Vce8RAM50	.equ	047D0h
Vce8RAM51	.equ	047D1h
Vce8RAM52	.equ	047D2h
Vce8RAM53	.equ	047D3h
Vce8RAM54	.equ	047D4h
Vce8RAM55	.equ	047D5h
Vce8RAM56	.equ	047D6h
Vce8RAM57	.equ	047D7h
Vce8RAM58	.equ	047D8h
Vce8RAM59	.equ	047D9h
Vce8RAM5A	.equ	047DAh
Vce8RAM5B	.equ	047DBh
Vce8RAM5C	.equ	047DCh
Vce8RAM5D	.equ	047DDh
Vce8RAM5E	.equ	047DEh
Vce8RAM5F	.equ	047DFh
Vce8RAM60	.equ	047E0h
Vce8RAM61	.equ	047E1h
Vce8RAM62	.equ	047E2h
Vce8RAM63	.equ	047E3h
Vce8RAM64	.equ	047E4h
Vce8RAM65	.equ	047E5h
Vce8RAM66	.equ	047E6h
Vce8RAM67	.equ	047E7h	;high nibble LFO waveshape, low nibble LFO destination
Vce8RAM68	.equ	047E8h
Vce8RAM69	.equ	047E9h
Vce8RAM6A	.equ	047EAh
Vce8RAM6B	.equ	047EBh	;related to shape edit enables for osc 1
Vce8RAM6C	.equ	047ECh
Vce8RAM6D	.equ	047EDh
Vce8RAM6E	.equ	047EEh
Vce8RAM6F	.equ	047EFh
Vce8RAM70	.equ	047F0h
Vce8RAM71	.equ	047F1h
Vce8RAM72	.equ	047F2h	;related to shape edit enables for osc 2
Vce8RAM73	.equ	047F3h
Vce8RAM74	.equ	047F4h
Vce8RAM75	.equ	047F5h
Vce8RAM76	.equ	047F6h
Vce8RAM77	.equ	047F7h
Vce8RAM78	.equ	047F8h
Vce8RAM79	.equ	047F9h
Vce8RAM7A	.equ	047FAh	;resonance value
Vce8RAM7B	.equ	047FBh
Vce8RAM7C	.equ	047FCh
Vce8RAM7D	.equ	047FDh
Vce8RAM7E	.equ	047FEh
Vce8RAM7F	.equ	047FFh

LstKeyMIDI2	.equ	04FF0h	;seems to hold MIDI note number for last key pressed
	

;Exponential look-up starts 1024 samples, or 2K bytes into DS7.   Possibly at address 2800h

;Patch Bank D starts at 0CC00h

	.org	00000h

	jmp	L0040

	.db	000h
	.db	002h
	.db	001h
	.db	000h
	.db	000h
				;same code is repeated, so we don't need int vector				
L0008:				;rst 1 address				
	di
	push	psw
	in	0B8h		;read UART data register
	push	h
	jmp	L05EF

L0010:				;rst 2 address
	di
	push	psw
	in	0B8h		;read UART data register
	push	h
	jmp	L05EF

L0018:				;rst 3 address
	di
	push	psw
	in	0B8h		;read UART data register
	push	h
	jmp	L05EF

L0020:				;rst 4 address
	di			
	push	psw
	in	0B8h		;read UART data register
	push	h
	jmp	L05EF

L0028:				;rst 5 address
	di
	push	psw
	in	0B8h		;read UART data register
	push	h
	jmp	L05EF

L0030:				;rst 6 address
	di
	push	psw
	in	0B8h		;read UART data register
	push	h
	jmp	L05EF

L0038:				;rst 7, this is used for TxRDY interrupt
	jmp	L05BD		;since it doesn't read the UART data register

	nop
	nop
	nop
	nop
	nop


L0040:				;init code, reset jumps here
	lxi	sp,04FFFh

	lxi	h,$4000		;source address
	mvi	m,000h		;put 0 at source address
	xchg			;source in de
	lxi	h,04001h	;dest in hl
	lxi	b,00534h	;# of bytes to zero out
	call	0DF12h		;DS8, copies from [de] to [hl], incs both ptrs, uses bc as byte ctr

	mvi	a,020h		;set system timer 0 to be mode 0, high byte only
	out	0B3h

	mvi	a,0A8h		;load timer 0
	out	0B0h

	mvi	a,0B6h		;set timer 2 to be mode 3, low/high
	out	0B3h

	xra	a		;clear acc
	out	0B2h		;clear timer 2
	out	0B2h

	mvi	a,0FFh
	sta	$4345
	out	055h

	lxi	h,00026h
	shld	$442D

	call	L02DF		;sets up prog bank addresses, does some other stuff
	call	0D202h		;DS8, convert all 20 pots, wheels, and pedal
	call	0271Bh		;DS7 code
	call	L0512		;UART and MIDI vars init
	call	L0488
	call	0DB9Dh		;DS8
	call	0D6A8h		;DS8
	call	L0AC6


L0088:
	call	L19AD
	di
	lxi	sp,04046h
	ret

L0090:				;main loop routine 0?
	lxi	sp,04FFFh
	ei
	call	L0607		;check for rec'd data MIDI, process it
	di
	lxi	sp,04146h
	ret

L009C:				;main loop routine 1?
	lxi	sp,04FFFh
	ei
	call	L1A29
	di
	lxi	sp,04246h
	ret

L00A8:				;main loop routine 2?
	lxi	sp,04FFFh
	ei
	call	L03BD		;call key scan code
	di
	lxi	sp,04346h
	ret

L00B4:				;main loop routine 3?
	lxi	sp,04FFFh
	ei
	call	L1A56	
	call	L1B1F		;read the switches
	di
	lxi	sp,04446h
	ret

L00C3:				;main loop routine 4?
	lxi	sp,04FFFh
	ei
	call	L0607		;check for rec'd data MIDI, process it 
	di
	lxi	sp,04546h
	ret


				;main loop routine 5?
L00CF:				;enable ints, call pot code, disable ints
	lxi	sp,04FFFh
	call	L11D4
	ei
	lda	$4435
	ana	a
	cnz	L1456
	call	L1AA9		;call pot scanning code
	di
	lxi	sp,04646h
	ret



L00E5:				;main loop routine 6?
	lxi	sp,04FFFh
	ei			;enable
	call	0D728h		;DS8, check for B2 timer value change
	di			;disable
	lxi	sp,04746h
	ret



L00F1:				;main loop routine 7?
	lxi	sp,04FFFh
	ei			;enable
	call	L03BD		;call key scan code

	lda	$4432		;get noise value
	mvi	l,000h
	mov	h,a
	shld	$5252		;write it to DAC high byte

	mvi	a,0C0h		;enable noise S&H
	out	054h		;update DAC, select S&H

	lda	$4539		;complement of value read from I/O addr 5C at startup (sw row 4)
	ana	a
	cnz	L01DF		;this routine calls the pot debug code if acc bit 0 is 0
	lhld	$4433
	mov	a,h
	ana	l

	lxi	b,000FDh	;set or clear LFO LED bit based on 4434:3 being 0000
	jz	L0119
	mvi	b,002h
L0119:
	lda	$441B		;LED row 0 shadow
	ana	c
	ora	b
	sta	$441B		;LED row 0 shadow
	out	058h		;update LED row 0

	lxi	h,0413Eh
	mov	a,m
	ana	a
	jz	L0145
	dcr	m
	jnz	L0145
	mvi	m,008h
	lhld	$413C
	xchg
	lhld	$441C		;LED row 1 shadow
	mov	a,l
	xra	e
	mov	l,a
	out	059h		;update LED row 1
	mov	a,h
	xra	d
	mov	h,a
	out	05Ah		;update LED row 2
	shld	$441C		;LED row 1 shadow
L0145:
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	003h		;check MIDI OUT and IN bits
	jz	L01B7		;if neither is enabled, jump

	mov	b,a
	ani	002h		;check MIDI OUT bit
	jz	L017B
				;MIDI OUT must be set
	lxi	h,$4106		;load counter		
	inr	m		;bump it
	mov	a,m
	cpi	008h		;we only send active sensing every 8th time
	jc	L017B
	mvi	m,000h		;wrap counter

	mvi	a,0FEh		;MIDI active sensing status byte
	sta	$4000		;put this at the start of the MIDI tx buffer

	lxi	h,00100h
	shld	$4040		;set tx rd ptr to 00, tx wr ptr to 01

	lda	$4105		;get shadow for UART cmd register
	ori	001h		;set Transmit Enable bit		
	sta	$4105		;update shadow for UART cmd register
	out	0B9h		;enable transmit at UART

	xra	a
	sta	$4104
	jmp	L01B7


L017B:				;MIDI OUT not set, MIDI IN set
	mov	a,b
	ani	001h
	jz	L01B7
	lxi	h,$4422		;LED row 7 shadow
	mov	c,m
	xchg
	lxi	h,$4107
	inr	m
	jz	L01A6
	mov	a,m
	cpi	030h
	jc	L01B7
	mvi	m,000h
	lda	$4108
	ana	a
	cnz	L0932
	xra	a
	sta	$4108
	mov	a,c
	xri	001h
	jmp	L01AC

L01A6:
	mvi	a,001h
	sta	$4108
	ora	c
L01AC:
	mov	c,a
	lda	$441E		;LED row 3 shadow
	ani	001h		;check mode bit
	jz	L01B7
	mov	a,c
	stax	d
L01B7:
	lda	$4422		;LED row 7 shadow
	out	05Fh		;update LED row 7
L01BC:
	in	0B0h		;read system ctr 0
	rlc			;check msbit
	jc	L01BC		;wait for it to clear

	mvi	a,020h		;set ctr 0 to msbyte only, mode 0, stop on timeout
	out	0B3h
	mvi	a,0D8h
	out	0B0h
	jmp	L0088


L01CD:
	lxi	h,$0000		;give interrupts a chance to come in
	dad	sp
	shld	$4537		;save SP at 4537
	lxi	sp,04FFFh	;point sp to top of RAM
	ei			;enable ints
	nop			;wait...
	di			;disable ints
	lhld	$4537		;restore the SP 
	sphl
	ret			;and return



L01DF:
	mov	b,a		;check for acc D0=0
	ani	001h
	jz	L0208		;jump to pot debug code and then do a return?

	lda	$4045
	mov	c,a
	ani	00Fh
	out	0EEh
	mov	a,c
	ani	0F0h
	rrc
	rrc
	rrc
	rrc
	out	0EFh

	lda	$4044
	mov	c,a
	ani	00Fh
	out	0ECh
	mov	a,c
	ani	0F0h
	rrc
	rrc
	rrc
	rrc
	out	0EDh

	ret



L0208:				;this looks like pot debug code
	lda	$453A
	cpi	014h
	jm	L0212
	sui	004h
L0212:
	mov	c,a
	mvi	b,000h
	lxi	h,04404h	;start of pot values array?
	dad	b
	mov	a,m
	ani	0F0h
	mov	e,a
	mov	a,m
	ani	00Fh
	rrc
	rrc
	rrc
	rrc
	mov	d,a
	lxi	h,$441C		;LED row 1 shadow
	mov	a,m
	ani	00Fh
	ora	d
	out	059h		;update LED row 1
	inx	h
	mov	a,m
	ani	00Fh
	ora	e
	out	05Ah		;update LED row 2
	lda	$453A
	mov	b,a
	ani	0F0h
	mov	e,a
	mov	a,b
	ani	00Fh
	rrc
	rrc
	rrc
	rrc
	mov	d,a
	lxi	h,$4420		;LED row 5 shadow
	mov	a,m
	ani	00Fh		;clear prog sel bits
	ora	d		;OR in new value
	out	05Dh		;update LED row 5
	inx	h
	mov	a,m
	ani	00Fh		;clear prog sel bits
	ora	e		;OR in new value
	out	05Eh		;update LED row 6
	ret


L0255:
	lxi	b,00404h
	lda	$4341
	mov	e,a
	lda	$4343
	mov	d,a
	lda	$4345
	ana	e
	mov	e,a
	sta	$4343
	xra	d
	jz	L029C
	mov	d,a
	ana	e
	mov	e,a
	xra	d
	jz	L0285
	lxi	h,05F5Fh
L0276:
	dad	b
	rrc
	jnc	L027D
	mvi	m,03Ah
L027D:
	mov	d,a
	mov	a,h
	cpi	07Fh
	mov	a,d
	jc	L0276
L0285:
	mov	a,e
	ana	a
	jz	L029C
	lxi	h,05F5Fh
L028D:
	dad	b
	rrc
	jnc	L0294
	mvi	m,036h
L0294:
	mov	e,a
	mov	a,h
	cpi	07Fh
	mov	a,e
	jc	L028D
L029C:
	lda	$4342
	mov	e,a
	lda	$4344
	mov	d,a
	lda	$4345
	ana	e
	mov	e,a
	sta	$4344
	xra	d
	rz
	mov	d,a
	ana	e
	mov	e,a
	xra	d
	jz	L02C7
	lxi	h,05F5Fh
L02B8:
	dad	b
	rrc
	jnc	L02BF
	mvi	m,0BAh
L02BF:
	mov	d,a
	mov	a,h
	cpi	07Fh
	mov	a,d
	jc	L02B8
L02C7:
	mov	a,e
	ana	a
	rz
	lxi	h,05F5Fh
L02CD:
	dad	b
	rrc
	jnc	L02D6
	mvi	m,0B4h
	mvi	m,072h
L02D6:
	mov	e,a
	mov	a,h
	cpi	07Fh
	mov	a,e
	jc	L02CD
	ret



L02DF:				;init program bank address upper bytes
	lxi	h,0C6CCh	;64 patches times 24 bytes/patch is 600h (1536d)
	shld	$4700
	lxi	h,090C0h
	shld	$4702
	lda	$C000		;should be the first byte of the first EPROM patch
	cpi	031h		;which is an 08h
	jnz	L02F8		;if not 031h, skip next step
	mvi	a,0D0h		;set bank D start to be 0xD000 instead of 0xCC00
	sta	$4700		;maybe this was for testing patches?
L02F8:
	lxi	d,00359h
	ldax	d		;read 7E byte
L02FC:
	mov	l,a		;move 7E into L
	mvi	h,040h		;hl = 407E
	mvi	b,008h
L0301:
	inx	d		;point to first page 0 code addr low byte
	ldax	d		;grab it
	mov	m,a		;store at 4n7E
	inr	h		;add 100h to addr in hl
	dcr	b
	jnz	L0301		;write 8 page 0 code address low bytes to 8 addresses in RAM, 100h apart

	inx	d
	ldax	d
	ana	a
	jnz	L02FC
	lxi	d,0036Ch
	ldax	d
L0313:
	mov	l,a
	mvi	h,040h
	mvi	b,008h
	inx	d
	ldax	d
L031A:
	mov	m,a
	inr	h
	dcr	b
	jnz	L031A
	inx	d
	ldax	d
	ana	a
	jnz	L0313
	lxi	h,003ADh
	mvi	c,001h
	mvi	a,040h
	call	L0340
	inx	h
	call	L0340
	inx	h
	mvi	c,004h
	mvi	a,060h
	call	L0340
	inx	h
	mvi	c,008h
	xra	a
L0340:
	mov	e,m
	mvi	d,040h
	mvi	b,008h
	push	psw
L0346:
	stax	d
	add	c
	inr	d
	dcr	b
	jnz	L0346
	pop	psw
	mov	b,a
	inx	h
	mov	e,m
	mov	a,e
	ana	a
	mov	a,b
	rz
	inr	a
	jmp	L0340

				;values written to 4n7E seem to be addresses of routines in page 0
				;that get called over and over, as part of the main loop
L0359:				
	.db	07Eh
	.db	090h		;L0090 is an int en/call something/dis routine, written to 407E
	.db	09Ch		;L009C is an int en/call something/dis routine, written to 417E
	.db	0A8h		;L00A8 is an int en/call something/dis routine, written to 427E
	.db	0B4h		;L00B4 is an int en/call something/dis routine, written to 437E
	.db	0C3h		;L00C3 is an int en/call something/dis routine, written to 447E
	.db	0CFh		;L00CF is an int en/call something/dis routine, written to 457E
	.db	0E5h		;L00E5 is an int en/call something/dis routine, written to 467E
	.db	0F1h		;L00F1 is an int en/call something/dis routine, written to 477E

	.db	067h

L0363:
	.db	001h
	.db	002h
	.db	004h
	.db	008h
	.db	010h
	.db	020h
	.db	040h
	.db	080h

L036B:
	.dw	08000h
	.dw	08C2Ah
	.dw	08F19h
	.dw	09221h
	.dw	09624h
	.dw	09928h
	.dw	09D2Dh
	.dw	0A131h
	.dw	0A535h
	.dw	0BC39h
	.dw	0C441h
	.dw	0CA05h
	.dw	0CBFFh
	.dw	0CCF4h
	.dw	0D407h
	.dw	0DC60h
	.dw	0E424h
	.dw	0EE26h
	.dw	0EF45h
	.dw	0F517h
	.dw	0F64Fh

L0395:
	.db	018h
	.db	07Fh
	.db	000h
L0398:
	.db	053h
	.db	0FFh
	.db	054h
	.db	042h
	.db	074h
	.db	05Ah
	.db	07Bh
	.db	052h
L03A0:
	.db	05Fh
	.db	0A6h
	.db	048h
	.db	0B1h
	.db	04Fh
	.db	0B7h
	.db	057h
	.db	0CFh
L03A8:
	.db	068h
	.db	0E7h
	.db	078h
	.db	0FBh
	.db	000h
	.db	075h
	.db	000h
	.db	07Ch
L03B0:
	.db	000h
	.db	06Dh
	.db	072h
	.db	070h
	.db	000h
	.db	06Ch
	.db	06Eh
	.db	071h
L03B8:
	.db	06Fh
	.db	07Ah
	.db	073h
	.db	07Dh
	.db	000h



L03BD:				;keyboard scan code
	lxi	h,04121h	;previous value array 
	lxi	d,08000h
L03C3:
	ldax	d		;read keyboard row
	cmp	m		;has it changed?
	cnz	L03D1		;if yes, call next routine
	inx	d		;bump hw address
	inx	h		;bump previous array index
	mov	a,e
	cpi	008h		;0-7 are valid rows
	jc	L03C3
	ret			;and we're done



L03D1:				;row value doesn't match previous state
	push	d		;push row hw address
	mov	b,a		;save value we read from hw in b
	mov	c,e		;save row number in c
	xra	m		;xor new value with previous one
	mov	e,a		;save result in e
	mov	a,b		;get value we read from hw
	cma			;complement it, pressed keys are 1 now
	ana	e		;AND that with change info to get newly pressed keys
	mov	d,a		;save that in d
	cma			;complement that, so that unchanged keys are 1's
	ana	m		;AND that with previous value
	mov	m,a		;update previous value
	push	h		;push address of previous value
	push	d		;d=newly pressed,e=xor result
	mov	a,c		;get row number 
	adi	030h		;add 30h to it, (MIDI number of the lowest key)
	mov	d,a		;save in d
	mov	a,c		;get row number
	add	a		;*2
	add	a		;*4
	add	a		;*8
	mov	c,a		;save in c
	mvi	b,000h
	lxi	h,04300h	;key array start address
	dad	b
	pop	b		;b=newly pressed,c=xor result
	mvi	e,001h		;starting mask value
L03F1:
	mov	a,c
	ana	e
	jnz	L040A		;exit loop when mask matches xor result
L03F6:
	mov	a,e		;get mask into acc
	add	a		;shift it left 1
	jc	L0404		;jump if mask shifts into cy
	inx	h		;bump ptr into key array
	mov	e,a

	mov	a,d		;add 8 to d each pass
	adi	008h		;probably this is forming the note number
	mov	d,a

	jmp	L03F1		;loop

L0404:
	pop	h		;get address of prev value for this row
	mov	a,m	
	ora	c		;OR in xor result
	mov	m,a		;update prev value
	pop	d
	ret

L040A:
	ana	b
	jz	L0418
	mov	a,c
	xra	e
	mov	c,a
	mvi	m,008h		;set key array for this key to 8
	push	h		;save its address, this should be initial key press
	lhld	$412A		;a bunch of different addresses are stored here		
	pchl			;INFO: index jump

L0418:
	dcr	m		;must be decrementing key array counter
	jz	L0422
	mov	a,c
	xra	e
	mov	c,a
	jmp	L03F6

L0422:				;key array ctr has reached 0
	push	h		;save its address, maybe this is when we make voice available again?
	lhld	$412C
	pchl			;INFO: index jump


L0427:				;one possible address placed at 412A
	lxi	h,04116h
	jmp	L046C

L042D:				;one possible address placed at 412A
	lxi	h,04119h
	jmp	L046C

L0433:
	lda	$4114		;MIDI number of note just below the split point
	cmp	d
	jp	L0427		;if we're in upper half, jump
L043A:
	lxi	h,0411Ch
	jmp	L046C

L0440:
	lda	$4114		;MIDI number of note just below the split point
	cmp	d
	jp	L042D
L0447:
	lxi	h,0411Fh
	jmp	L046C

L044D:				;one possible address placed at 412A
	lxi	h,04116h
	call	L045F
	jmp	L043A

L0456:
	lxi	h,04119h
	call	L045F
	jmp	L0447

L045F:
	mov	m,d		;d seems to hold MIDI note number for key pressed
	dcx	h
	push	b
	push	d
	mvi	b,003h
	xchg
	call	L0851
	pop	d
	pop	b
	ret


L046C:
	call	L045F
L046F:
	pop	h
	jmp	L03F6

				;copied to:
L0473:
	.db	047h		;4114 default MIDI number of note just below split point (B below middle C)

	.db	090h		;4115 possibly Note On w/o the channel
	.db	000h		;4116
	.db	040h		;4117 default velocity

	.db	090h		;4118 possibly Note Off w/o the channel
	.db	000h		;4119
	.db	000h		;411A Note off is 90 with vel=0

	.db	091h		;411B possibly Note On w/o the channel
	.db	000h		;411C
	.db	040h		;411D

	.db	091h		;411E possibly Note Off w/o the channel
	.db	000h		;411F
	.db	000h		;4120

	.db	0FFh
	.db	0FFh
	.db	0FFh
	.db	0FFh
	.db	0FFh
	.db	0FFh
	.db	0FFh
	.db	0FFh
		
L0488:
	lxi	d,00473h
	lxi	h,$4114		;4114 is split point, starting dest for copy
	mvi	b,015h
	call	0DF09h		;DS8, copies from [de] to [hl], incs both ptrs, uses b as byte ctr
L0493:				
	mov	a,b		;if ((b AND 70h) == 70h) and b has D0=0, store de at 412A and return
	ani	070h
	cpi	070h
	jnz	L04A9
	mov	a,b
	rrc
	jc	L04A5
	xchg
	shld	$412A
	ret

L04A5:
	lda	$4129
	mov	b,a
L04A9:				
	ani	040h
	jz	L04D0		;if ((b AND 70h) AND 40h) == 0, jump to 04D0
	mov	a,b
	ani	010h
	mov	a,b
	jnz	L04C3
	mov	a,b
	ani	00Fh
	ori	090h
	sta	$4115
	ani	08Fh
	sta	$4118
	ret

L04C3:
	ani	0F0h
	ori	090h
	sta	$411B
	ani	08Fh
	sta	$411E
	ret

L04D0:
	mov	a,b		;if b == 21h
	cpi	021h
	jnz	L04DE
	mov	a,d
	dcr	a
	sta	$4114		;set split point: MIDI number of note just below the split point
	jmp	L04A5

L04DE:
	mov	a,b
	sta	$4129
	ana	a
	jnz	L04F3

	lxi	h,L0427		;a code address
	shld	$412A

	lxi	h,0042Dh
	shld	$412C
	ret


L04F3:
	cpi	001h
	jnz	L0505

	lxi	h,L0433		;a code address
	shld	$412A

	lxi	h,00440h
	shld	$412C
	ret


L0505:
	lxi	h,L044D		;a code address
	shld	$412A

	lxi	h,00456h
	shld	$412C
	ret


L0512:				;UART/MIDI init
	lxi	h,00607h
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte

	lxi	h,02020h	;set both rx buffer ptrs to 20h
	shld	$4042

	mvi	a,04Eh		;set UART mode
	out	0B9h

	lhld	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
				;also 461B is save area for row 5 mode bits		
	mov	a,l
	ana	h
	inr	a
	jnz	L0545		;skip some init and checksum gen

	mvi	a,012h		;UART cmd reg, disable Tx, Rx, reset errors
	sta	$4105		;update shadow for UART cmd register
	out	0B9h

	lxi	h,$4000
	shld	$461A		;reset save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
				;write 40h to save area for row 5 mode bits (OMNI bit set)

	mvi	a,040h		;enable OMNI mode
	sta	$413F		;row 5 mode bits in upper nibble:D7 Chan, D6:OMNI, D5:Sequ, D4:Sync

				;~~~this looks like a bug, load acc, then save hl?

	#IFDEF	RANGEFIX
	
	mvi	h,001h		;this seems like what they wanted

	#ELSE
				;original code:
	mvi	a,001h		;seems like mvi h,001h would be good here

	#ENDIF
	
	shld	$461C		;to set MIDI range bytes to 00 and 01, for Poly mode		
				;461D:C seems to hold MIDI In channel range
	jmp	0270Dh		;DS7 code, checksums 40 bytes, starting at 461A, saves result at 4618

L0545:
	mvi	b,012h		;this cmd doesn't enable RX at UART
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	001h		;check IN bit
	jz	L0551
	mvi	b,016h		;this cmd would enable RX at UART
L0551:
	mov	a,b
	sta	$4105		;update shadow for UART cmd register
	out	0B9h

	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	sta	$4141		;rows 4 and 7 mode bits: TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN

	lda	$461B		;save area for row 5 mode bits mode bits, in D4-7
	sta	$413F		;row 5 mode bits in upper nibble:D7 Chan, D6:Omni, D5:Sequ, D4:Sync
	ret



L0564:				;send MIDI controller, called with controller # in d, value in e 
	lxi	h,04102h	;probably MIDI string starts at 4100h, 
	mov	m,e		;write data byte to 4102
	dcx	h
	mov	m,d		;controller # to 4101		
	dcx	h
	mvi	m,0B0h		;and status byte to 4100
	mvi	b,003h		;byte count in b
	xchg			;put 4100 addr in de
	jmp	L057F


L0573:				;write byte in acc into MIDI tx buffer, then send it
	mvi	b,001h
	push	d
	lhld	$4041		;MIDI tx buf wr ptr
	mvi	h,040h
	di
	jmp	L059E

L057F:
	lxi	h,$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
L0582:
	lda	$4104
	mov	c,a
	lda	$4103
	add	m
	xchg
	add	m		;looks like we are adding MIDI channel info to B0 in 4100
	sta	$4104
	xchg
	push	d
	lhld	$4041		;MIDI tx buf wr ptr in l
	mvi	h,040h
	di
	cmp	c
	jnz	L059E
	inx	d
	dcr	b

L059D:				;copy b count bytes from de address into MIDI tx buffer
	ldax	d
L059E:
	mov	m,a		;write a byte to MIDI tx buf
	inr	l		;bump tx buf wr ptr
	mov	a,l
	ani	01Fh		;keep it in range
	mov	l,a
	inx	d
	dcr	b
	jnz	L059D

	pop	d
	sta	$4041		;update MIDI tx buf wr ptr

	lda	$4105		;get shadow for UART cmd register
	ori	001h		;set Transmit Enable
	sta	$4105		;update shadow for UART cmd register
	out	0B9h		;enable transmit

	xra	a
	sta	$4106		;clear active sensing tx ctr
	ei
	ret



L05BD:
	push	psw
	push	b
	push	d
	push	h
	lhld	$4040
	mov	a,h
	cmp	l
	jz	L05D9
	mov	c,h
	mvi	h,040h
	mov	a,m
	out	0B8h
	mov	a,l
	inr	a
	ani	01Fh
	sta	$4040
	jmp	L05E9

L05D9:
	lxi	h,$0000
	shld	$4040

	lda	$4105		;get shadow for UART cmd register
	ani	0FEh		;clear Transmit Enable bit
	sta	$4105		;update shadow for UART cmd register
	out	0B9h		;disable transmit at UART
L05E9:
	pop	h
	pop	d
	pop	b
	pop	psw
	ei
	ret


				;interrupt front-ends disable interrupts, push psw, 
				;read a byte from the UART, push h, and jump here
L05EF:				;this just puts rx byte into buffer and returns		
	lhld	$4043		;only using the l value, it seems, this must be the rx buf wr ptr
	mvi	h,040h
	mov	m,a		;save serial data byte in rx buffer
	mov	a,l
	inr	a		;bump ptr low byte
	ori	020h		;ranges from 20h to 3Fh - just 32 bytes
	ani	03Fh
	sta	$4043		;write ptr low byte back out
	pop	h
	mvi	a,0FFh
	sta	$4107		;set some sort of MIDI data flag
	pop	psw
	ei			
	ret



L0607:				;check MIDI rx buffer and start processing any data
	di
	lhld	$4042		;MIDI rx buf rd ptr, low byte
	mov	a,l
	cmp	h		;is buffer empty?
	jz	L0668		;if so, init both ptrs, enable ints, and return

	mvi	h,040h		;rx buffer is not empty, high byte is always 40h
	mov	b,m		;read byte from buffer
	ei
	mov	a,l
	inr	a		;inc low byte of rd ptr
	ori	020h		;keep it in range (wraps automatically)
	ani	03Fh		
	sta	$4042		;update rd ptr
	lxi	h,L0607		;save address of this routine on the stack
	push	h
	mov	a,b		;get MIDI byte
	cpi	0F0h		;is it < 0F0h?
	jc	L0670		;yes, jump
	inr	a
	jz	L0040		;if it's 0FFh (MIDI reset), do a full reset
	inr	a
	rz			;if it's 0FEh (active sensing) just return
	inr	a
	inr	a
	jnz	L0637		;if it's not 0FCh ("Stop"), jump
	mvi	b,002h
	jmp	0DD7Ch		;DS8

L0637:
	inr	a		
	jnz	L0640		;if it's not 0FBh ("Continue"), jump
	mvi	b,000h
	jmp	0DD7Ch		;DS8

L0640:
	inr	a		
	jnz	L064A		;if it's not 0FAh ("Start"), jump
	call	0DCBCh		;DS8
	jmp	0DCE9h		;DS8

L064A:
	inr	a
	inr	a
	jnz	L0667		;if it's not 0F8h ("Timing Clock"), jump to ret

	lda	$461B		;save area equiv of addr 413F, row 5 mode bits
	ani	001h		;check "sync" mode bit?   ~~~ shouldn't this be 10h?
	jz	L0667		;if it's not set, jump to ret

	lda	$4706		;get B2 timer value
	ani	00Fh		;low 4 bits
	dcr	a		;decrement it so it won't match the next time we read the timer
	jnz	L0662		;but is it 0 now?
	mvi	a,00Ch		;if so, set it to 00Ch
L0662:
	ori	0C0h		;no clue what this does!, set upper two bits
	sta	$4706		;maybe just trying to make sure it doesn't match timer
L0667:
	ret



L0668:
	lxi	h,02020h	;set both read and write ptrs to start of rx buffer
	shld	$4042
	ei
	ret


L0670:				;we jump here if MIDI byte is less than 0F0h
	ana	a		;set flags
	jm	L0678		;if it's >= 80h, jump, otherwise
	lhld	$410F		;jump to address stored here
	pchl


L0678:				;MIDI byte is >= 80h, and less than 0F0h
	sta	$410C		;save status byte here
	ani	070h		;just grab low 3 bits of upper nibble
	rar
	rar
	rar
	lxi	h,0068Ch	;and jump on them
	mov	e,a
	mvi	d,000h
	dad	d
	mov	a,m
	inx	h
	mov	h,m
	mov	l,a
	pchl		;INFO: index jump


L068C:			;small jump table
	.dw	L06C5	;8n (note off)
	.dw	L06C5	;9n (note on)
	.dw	L06BD	;An (poly key pressure?)
	.dw	L06F2	;Bn (controllers)
	.dw	L0828	;Cn (program change)
	.dw	L06BD	;Dn (channel pressure?)
	.dw	L0835	;En (pitch wheel change)

L069A:
	mvi	c,000h

	lda	$461B		;save area equiv of addr 413F, row 5 mode bits		
	ani	040h		;check OMNI flag (1=OMNI)
	jnz	L06B3		;if set, skip channel check

	lhld	$461C		;seems like 1C,1D hold range of MIDI channels
				;1C is lower limit, number of valid channels
	mov	a,b		;still holds MIDI status byte, I think
	ani	00Fh		;we seem to be checking for channel in range
	sub	l		;acc = status channel bits - 461C
	jc	L06BD		;bail if status channel < l (461C) value
	cmp	h
	jnc	L06BD		;and bail if status channel-l >= h (461D) value
				;so 461D holds number of valid channels, starting with 461C value
	mov	c,a		;save difference between status channel and base channel
L06B3:
	lda	$410C		;status byte, low 4 bits store offset (channel-base) of last status byte
	ani	0F0h
	ora	c
	sta	$410C		;status byte, low 4 bits store offset (channel-base) of last status byte
	ret			;or 0 if OMNI mode enabled

L06BD:				;An, or Dn MIDI byte
	lxi	h,L06C4		;a code address
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	xra	a
L06C4:
	ret


L06C5:				;8n, or 9n, note on/off MIDI byte
	call	L069A		;check for channel in range/match
	rz
	lxi	h,L06D0		;a code address
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	ret


L06D0:
	sta	$410D		;guessing the MIDI note number is stored here
	lxi	h,L06DA		;a code address
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	ret


L06DA:
	sta	$410E		;guessing the note velocity byte is stored here
	lxi	h,L06D0		;a code address
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
				;this seems to be for running status support
	lxi	h,$410D		;get note number
	mov	a,m
	adi	00Ch		;add 12 to it
	mov	m,a
	dcx	h		;point to status byte at 410C
	xchg			;save that address in de
	cpi	030h		;check for MIDI note # in range?
	jp	L0859
	ret


L06F2:				;Bn controllers message
	call	L069A		;check for MIDI channel in range
	rz
	lxi	h,L06FF		
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	jmp	L1E26

L06FF:
	cpi	044h		;is controller number < 68d?
	jc	L07BE		;if so, jump here

	cpi	04Dh		;is it < 77d?
	jc	L0804		;if so, jump here

	cpi	050h		;is it less than 80d?
	jc	L075A		;if so, jump

	ori	080h
	inr	a		;check for controller #127 (7Fh), should select Poly mode
	jnz	L071F
	inr	a		;if it is, write 1 to 461D
	sta	$461D		;seems to be number of valid MIDI In channels, starting with base
	xra	a
	call	L0CA5		;write 0 to 4133 mode, clear transpose bit, jump based on 4133
	jmp	0270Dh		;DS7 code

L071F:
	inr	a		;check for controller #126 (7Eh)
	jnz	L072A		;should be code to select Mono mode, and turn all notes off
	lxi	h,L079F		
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	ret


L072A:
	inr	a		;check for controller #125 (7Dh)
	jnz	L0733
	mvi	b,010h		;should be turning OMNI mode on, and turning all notes off
	jmp	L0739

L0733:
	inr	a		;check for controller #124 (7Ch)
	jnz	L074C
	mvi	b,000h		;should be turning OMNI mode off, and turning all notes off
L0739:
	lda	$461B		;save area equiv of addr 413F, row 5 mode bits
	ani	0EFh		;~~~clear "sync bit"
	ora	b
	sta	$461B		;save area equiv of addr 413F, row 5 mode bits
	call	0270Dh		;DS7 code
	lxi	h,L06FF
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	ret


L074C:				;check for controller #123 (7Bh) (should be all notes off)
	lda	$410C		;status byte, low 4 bits store offset (channel-base) of last status byte		
	ani	001h
	jz	L09C0
	lxi	h,03034h
	jmp	L09C3

L075A:
	sui	04Dh
	sta	$410D
	lxi	h,L0766
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	ret



L0766:
	lxi	h,L06FF
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	mov	b,a
	lda	$410D
	ana	a
	jz	L078C
	dcr	a
	rrc
	ora	b
	mov	b,a
	lda	$4443
	mov	e,a
	mvi	d,000h
	lxi	h,$4600		;start of voice 1 patch storage?
	dad	d
	mov	m,b
	mov	a,e
	inr	a
	cpi	019h
	rp
	sta	$4443
	ret


L078C:
	mov	a,b
	ana	a
	jnz	L0796
	xra	a
	sta	$4443
	ret


L0796:
	lda	$4443
	cpi	018h
	rnz
	jmp	L0D1A


L079F:				;should be code to select Mono mode, and turn all notes off
	mov	b,a		;next byte should select the number of channels
	inr	a
	sta	$461D		;seems to be number of valid MIDI In channels, starting with base

	lxi	h,L06FF
	shld	$410F		;we jump based on this address after grabbing a non-status MIDI byte
	lxi	h,0270Dh
	push	h
	mov	a,b
	ana	a
	jz	L0CA5		;writes 0 to 4133 mode, clears transpose bit, jumps based on 4133
	inr	a
	cpi	002h
	jz	L0CA5		;writes 2 to 4133 mode, clears transpose bit, jumps based on 4133
	mvi	a,003h
	jmp	L0CA5		;writes 3 to 4133 mode, clears transpose bit, jumps based on 4133


L07BE:
	cpi	01Dh		;is controller # >= 28?
	jnc	L07FD		;if so, jump
	lxi	h,L07D9		;start of offset table
	mov	e,a		;controller number
	mvi	d,000h
	dad	d		;add offset to start addr
	mov	a,m		;grab table offset
	sta	$410D		;save it here
	inr	a
	jz	L07FD		;if table value is FF, jump
	lxi	h,00813h
	shld	$410F
	ret

			;looks like table of offsets vs MIDI controller numbers 
L07D9:			;these are used as index into a jump table later
	.db	0FFh	;0 -
	.db	017h	;1 Bend Depth
	.db	0FFh	;2 -
	.db	016h	;3 Glide Interval
	.db	018h	;4 "Change"
	.db	000h	;5 Glide Time
	.db	0FFh	;6 -
	.db	0FFh	;7 -
	.db	002h	;8 Modulation Depth
	.db	003h	;9 Modulation Rate
	.db	004h	;10 Tune
	.db	005h	;11 Detune
	.db	008h	;12 Wave Form
	.db	014h	;13 Chord Voice 1
	.db	015h	;14 Chord Voice 2
	.db	006h	;15 DCA Rate 1
	.db	007h	;16 DCA Rate 2
	.db	00Bh	;17 DCA Rate 3
	.db	00Ah	;18 DCA Level 2
	.db	009h	;19 DCA Level 1
	.db	011h	;20 Filter Rate 1
	.db	012h	;21 Filter Rate 2
	.db	013h	;22 Filter Rate 3
	.db	00Eh	;23 Filter Level 2
	.db	00Dh	;24 Filter Level 1
	.db	00Fh	;25 Filter Level 3
	.db	00Ch	;26 Noise Level
	.db	010h	;27 Resonance
	.db	001h	;28 Tempo

L07F6:
	lxi	h,L07FD
	shld	$410F
	ret


L07FD:				;controller number is > 28
	lxi	h,L06FF
	shld	$410F
	ret


L0804:
	cpi	04Dh
	jp	L07FD
	sta	$410D
	lxi	h,L0813
	shld	$410F
	ret


L0813:
	lxi	h,L06FF
	shld	$410F
	sta	$410E

	lxi	d,$410D		;read table byte we saved before
	ldax	d
	cpi	019h		;is it less than 25d?
	jc	0D256h		;if so, jump here, DS8
	jmp	L1C05		;execute MIDI handlers for controllers 68-76


L0828:				;Cn program change
	call	L069A
	rz
	lxi	h,L1E84
	shld	$410F
	jmp	L1E26

L0835:				;En pitch wheel change
	call	L069A
	rz
	lxi	h,L0840
	shld	$410F
	ret


L0840:
	lxi	h,L0847
	shld	$410F
	ret


L0847:
	lxi	h,L0840
	shld	$410F
	mov	c,a
	jmp	L1A0C

L0851:
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	002h		;check MIDI OUT bit
	jnz	L0873
				;could be part of note assign code
L0859:				;we jump here when we get note on/off MIDI message			
	ldax	d		;read status byte		
	ani	00Fh		;keep MIDI channel
	rlc
	rlc			;times 4
	mov	b,a		;save in b
	rlc			;and times 8
	add	b		;so now we have channel times 12 in b
	adi	020h		
	mov	l,a
	mvi	h,042h		;offset into array at 4220h
	shld	$4111		;save it here

	mov	c,m		;read from memory into c
	mov	a,c
	inr	l		;inc address
	mov	b,m		;read from memory into b
	ora	b
	ana	a
	rz			;return if bc table address is 0000
	mov	l,c		;otherwise jump to it
	mov	h,b
	pchl			;INFO: index jump

L0873:
	push	d
	lxi	h,008A1h
	push	h
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	mov	b,a
	ani	00Ch		;check KB2, KB1 bits
	rz

	lxi	h,04100h	;this seems to be where we build small MIDI strings to send out
	ldax	d
	mov	m,a
	ani	00Fh
	inr	a
	add	a
	add	a
	ana	b
	rz
	inx	d
	ldax	d
	sui	00Ch
	inx	h
	mov	m,a
	inx	d
	ldax	d
	inx	h
	mov	m,a
	mvi	b,003h		;we just wrote three bytes
	lxi	d,04100h	;this seems to be where we build small MIDI strings to send out
	lxi	h,008A0h
	jmp	L0582

L08A0:
	.db	$00		;nop
L08A1:
	pop	d		;not sure if this is executed, but it looks like code
	jmp	L0859

L08A5:
	xchg
	mov	a,m
	inx	h
	mov	d,m
	inx	h
	mov	c,m
	ani	070h
	jz	L08CB
	cpi	010h
	rnz
	mov	a,c
	ana	a
	jz	L08CB
	lda	$441C		;LED row 1 shadow
	ani	001h
	jz	0D79Ah		;DS8
	lda	$4420		;LED row 5 shadow
	ani	00Ch
	jnz	0D897h		;DS8
	jmp	0DAC2h		;DS8

L08CB:
	lda	$4420		;LED row 5 shadow
	ani	00Ch		;check ARP up and dn LED's
	jnz	0D7D2h		;DS8
	jmp	0DACAh		;DS8

	xchg
	mov	a,m
	inx	h
	mov	d,m
	inx	h
	mov	c,m
	ani	070h
	jz	L092A
	cpi	010h
	rnz
	mov	a,c
	ana	a
	jz	L092A

	lda	$4707		;get sequencer status
	ana	a
	cm	0DCDBh		;if "waiting to play" call DS8

	lda	$441E		;LED row 3 shadow
	ani	010h		;check port enab bit 
	jz	L0909
	lda	$4202
	ana	a
	jz	L0901
	sub	d
	add	a
L0901:
	push	d
	call	0D5A7h		;DS8
	call	L147B
	pop	d
L0909:
	mov	a,d
	sta	$4202
L090D:
	mvi	a,0FCh
L090F:
	adi	004h
	mov	e,a
	push	d
	rrc
	rrc
	adi	040h
	sta	$4223
	call	L0A4E
	pop	d
	mov	a,e
	cpi	01Ch
	jc	L090F
	mvi	a,040h
	sta	$4223
	ret


L092A:
	lxi	h,$4202
	mov	a,m
	cmp	d
	rnz
	mvi	m,000h
L0932:
	lxi	h,04054h
	mvi	b,008h
L0937:
	mov	a,m
	cpi	042h
	jz	L093F
	mvi	m,0FFh
L093F:
	mvi	l,05Ch
	mov	a,m
	ana	a
	jnz	L0948
	mvi	m,0FFh
L0948:
	mvi	l,054h
	inr	h
	dcr	b
	jnz	L0937
	ret

L0950:				;seem like MIDI code jumps here if note on/off rec'd for channels 1,2
	xchg			;when arpeggiator is active
	mov	a,m
	inx	h
	mov	d,m
	inx	h
	mov	c,m
	ani	070h
	jz	L09D8
	cpi	010h
	rnz
	mov	a,c
	ana	a
	jz	L09D8

	lda	$4707		;check sequencer state
	ana	a
	cm	0DCDBh		;if waiting to play, call DS8

	mvi	e,0FFh
	lhld	$4111
	mov	a,l
	adi	004h
	mov	l,a
	mov	c,a
	cmp	m
	jz	L0987
L0978:
	mov	l,m
	mov	e,l
	inr	l
	inr	l
	mov	a,d
	cmp	m
	jz	L0995
	mov	l,e
	mov	a,c
	cmp	m
	jnz	L0978
L0987:
	inr	c
	inr	c
	mov	l,c
	mov	a,c
	cmp	m
	jz	L0997
	mov	e,m
	inr	c
	inr	c
	jmp	L09A2

L0995:
	inr	c
	inr	c
L0997:
	inr	c
	inr	c
	mov	a,e
	cpi	0FFh
	jnz	L09A2
	mov	l,c
	inr	l
	mov	e,m
L09A2:
	call	L09AC
	mov	l,e
	inr	l
	inr	l
	mov	m,d		;this was writing MIDI note number to voice array at 4200h
	jmp	L0A4E

L09AC:
	mov	l,e
	mov	a,m
	inr	l
	mov	b,m
	mov	l,a
	inr	l
	mov	m,b
	mov	l,b
	mov	m,a
	mov	l,c
	mov	a,m
	mov	m,e
	mov	l,a
	inr	l
	mov	m,e
	mov	l,e
	mov	m,a
	inr	l
	mov	m,c
	ret

L09C0:
	lxi	h,02428h
L09C3:
	push	h
L09C4:
	pop	h
	mov	c,h
	mvi	h,042h
	mov	a,m
	cmp	l
	rz
	dcx	sp
	dcx	sp
	mov	l,a
	mov	e,l
	call	L09AC
	call	L09F9
	jmp	L09C4

L09D8:
	lhld	$4111
	mov	a,l
	adi	008h
	mov	c,a
	mov	l,a
	cmp	m
	rz
L09E2:
	mov	l,m
	mov	e,l
	inr	l
	inr	l
	mov	a,d
	cmp	m
	jz	L09F2
	mov	l,e
	mov	a,c
	cmp	m
	jnz	L09E2
	ret


L09F2:
	mov	a,c
	sui	004h
	mov	c,a
	call	L09AC
L09F9:
	mov	a,e
	rrc
	rrc
	lxi	h,04054h
	add	h
	mov	h,a
	mov	a,m
	ana	a
	jnz	L0A0C
	inr	e
	mov	m,e
	mvi	l,05Ch
	mvi	m,0FFh
L0A0C:
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	mov	b,a
	ani	002h		;check MIDI OUT bit
	rz			;return if not enabled

	lhld	$4111
	mov	a,l
	adi	008h
	mov	l,a
	mov	a,m
	cmp	l
	rnz
	mov	a,l
	ani	010h
	rrc
	rrc
	adi	004h
	ana	b
	rz
	rrc
	rrc
	dcr	a
	ori	0B0h
	lxi	h,04101h
	mvi	m,07Bh
	dcx	h
	mov	m,a
	xchg
	mvi	b,002h
	lxi	h,008A0h
	jmp	L0582

L0A3B:
	mvi	h,042h
	dcr	d
	mov	a,d
	adi	002h
	rz
	mov	l,a
	mvi	m,000h
	inr	l
	mov	a,m
	adi	006h
	mov	c,a
	mov	e,d
	jmp	L09AC

L0A4E:
	mov	a,d
	sui	030h
	mov	l,a
	mvi	h,000h
	dad	h
	dad	h
	dad	h
	dad	h
	dad	h
	xchg
	mov	a,l
	rrc
	rrc
	adi	040h
	mov	h,a
	mvi	l,06Ah
	mov	m,e
	inx	h
	mov	m,d
	mvi	l,076h
	mov	a,e
	cma
	mov	m,a
	mov	a,d
	cma
	inx	h
	mov	m,a
	mov	b,h
	lhld	$4111
	inx	h
	inx	h
	inx	h
	mov	h,m
	mov	c,h
	mvi	l,0B0h
	mov	e,m
	mvi	d,000h

	lxi	h,02796h	;start of a table in DS7
	dad	d		;add in offset
	xchg			;start sum in de
	mvi	l,05Dh
	mov	h,b
	ldax	d		;read a table byte
	mov	m,a		;move to RAM
	inx	h		;bump RAM ptr
	inx	d		;bump table ptr
	ldax	d		;read second table byte
	mov	m,a		;move to RAM
	inx	h		;bump RAM ptr
	mvi	m,0A6h
	inx	h
	mov	m,c
	inx	h
	mvi	m,000h
	mvi	l,069h
	mov	m,c
	mvi	l,079h
	mov	m,c
	mvi	l,046h
	lxi	d,013E0h
	mov	m,e
	inx	h
	mov	m,d
	inx	h
	mvi	m,0B1h
	inx	h
	mov	m,c
	mvi	l,04Dh
	xchg
	lhld	$4441
	xchg
	mov	m,e
	inx	h
	mov	m,d
	inx	h
	mvi	m,0B7h
	inx	h
	mov	m,c
	mvi	l,055h
	lxi	d,014B9h
	mov	m,e
	inx	h
	mov	m,d
	inx	h
	mvi	m,0CFh
	inx	h
	mov	m,c
	mvi	l,05Ch
	mvi	m,000h
	ret


L0AC6:				;this is the last call in the init code
	mvi	a,008h
	sta	$4135		;switch second fcn mask?

	call	02579h		;DS7 code
	lxi	h,$4220
	shld	$4111
	call	L0CE9		;returns the address of current patch in hl and at $4130, reads Patch if Patch Read enabled
	mvi	c,001h
	mvi	a,002h
L0ADB:
	sta	$422A
	mov	b,a
	push	b
	lhld	$4130
	mov	a,c
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	call	L0D1A
	pop	b
	inr	c
	mov	a,b
	rlc
	jnc	L0ADB

	mvi	a,0FFh
	sta	$4133
	xra	a		;clear acc
	call	L0CA5		;writes acc to 4133 mode, clears transpose bit, jumps based on 4133
	xra	a
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	lhld	$4130
	call	L0D1A
	call	L0EB4
	lxi	h,01549h
	shld	$4441
	mvi	d,072h
	call	L090D
	lxi	h,01498h
	shld	$4441
	lhld	$4640
	mov	a,l
	ani	0FDh
	rnz

	shld	$412E
	mov	a,l
	ana	a
	jz	L1ECC

	mvi	a,030h		;set Bank A/Bend, B/Pedal bits
	sta	$441F		;LED row 4 shadow
	out	05Ch		;update LED row 4
	mov	a,h
	call	0DF3Ah		;DS8, formats acc (0-7) for display in Prog Sel (or Prog Grp), in de
	xchg
	shld	$441C		;LED row 1 shadow
	mov	a,d
	rrc
	rrc
	rrc
	call	0DF3Ah		;DS8, formats acc (0-7) for display in Prog Sel (or Prog Grp), in de
	mov	a,e
	out	05Dh		;update LED row 5
	mvi	c,00Ah
	call	0DE1Fh		;DS8
	jmp	L1ECC


L0B48:
	mov	a,m
	ani	003h
	push	h
	call	L0CA5		;writes acc to 4133 mode, clears transpose bit, jumps based on 4133

	lda	$4133		;get mode
	ana	a
	jnz	L0B74		;jump if not poly

	lxi	h,$4220
	shld	$4111
	pop	h
	push	h
	inx	h
	mov	a,m
	call	L0CEC
	xra	a
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	call	L0D1A
	pop	h
	shld	$4142
	call	L0E60
	jmp	L0EB4

L0B74:			
	cpi	001h		;split mode?
	jnz	L0B7F
	call	L0C26
	jmp	L0B87

L0B7F:
	cpi	002h		;dual mode?
	jnz	L0BD2
	call	L0C2B
L0B87:
	lxi	h,$4220
	shld	$4111
	pop	h
	push	h
	inx	h
	mov	a,m
	call	L0CEC
	xra	a
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	call	L0D1A
	pop	h
	shld	$4142
	call	L0E60
	push	h
	xchg
	lxi	h,0422Ch
	shld	$4111
	xchg
	inx	h
	mov	a,m
	call	L0CEC
	mvi	a,001h
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	call	L0D1A
	pop	h
	shld	$4142
	call	L0E60
	lda	$4133
	dcr	a
	jnz	L0BCB
	inx	h
	mov	a,m
	sta	$4114		;set split point:MIDI number of note just below the keyboard split point
L0BCB:
	xra	a
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	jmp	L0EB4


L0BD2:				;must be mono mode
	call	L0C67
	pop	h
	xra	a
L0BD7:
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	push	h
	inx	h
	mov	a,m
	call	L0CEC
	call	L0D1A
	pop	h
	shld	$4142
	call	L0E52
	lda	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	inr	a
	cpi	008h
	jc	L0BD7
	xra	a
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	jmp	L0EB4



L0BFA:				;we jump here when switching to poly mode
	mvi	b,000h
	call	L0493		;seems to be forming a MIDI message, but doesn't send it

	lxi	h,00010h	;writing 01 to Prog Sel mode bits
	call	L0C8C

	mvi	a,02Ah
	sta	$4180

	lxi	d,0DF86h
	lxi	h,04200h
	mvi	b,020h		;byte count = 32 (4 bytes for each voice)
	call	0DF09h		;DS8, copies from [de] to [hl], incs both ptrs, uses b as byte ctr

	lxi	h,03434h
	shld	$4234

	lxi	d,027A0h
	lxi	h,$4220
	mvi	b,00Bh
	jmp	0DF09h		;DS8, copies from [de] to [hl], incs both ptrs, uses b as byte ctr



L0C26:				;we jump here when switching to split mode
	mvi	b,001h
	jmp	L0C2D

L0C2B:				;we jump here when switching to dual mode
	mvi	b,002h
L0C2D:
	call	L0493		;seems to be forming a MIDI message, but doesn't send it

	lxi	h,00030h	;writing 03 to Prog Sel mode bits	
	call	L0C8C

	mvi	a,036h
	sta	$4180

	lxi	d,0DFA6h
	lxi	h,04200h
	mvi	b,020h		;byte count = 32 (4 bytes for each voice)
	call	0DF09h		;DS8, copies from [de] to [hl], incs both ptrs, uses b as byte ctr

	lxi	d,027ABh
	lxi	h,$4220
	mvi	b,017h
	jmp	0DF09h		;DS8, copies from [de] to [hl], incs both ptrs, uses b as byte ctr


				;called when we start arpeggiator
L0C51:				;copies 32 bytes from DFC6 to 4200, and 35 bytes from 27C2 to 4220
	lxi	d,0DFC6h
	lxi	h,04200h
	mvi	b,020h		;byte count = 32 (4 bytes for each voice)
	call	0DF09h		;DS8, copies from [de] to [hl], incs both ptrs, uses b as byte ctr

	lxi	d,027C2h
	lxi	h,$4220
	mvi	b,023h
	jmp	0DF09h		;DS8, copies from [de] to [hl], incs both ptrs, uses b as byte ctr



L0C67:				;we jump here when switching to mono mode
	lxi	h,0F0F0h	;writing FF to Prog Sel mode bits
	call	L0C8C

	mvi	b,000h		;seems to be forming a MIDI message, but doesn't send it
	call	L0493

	mvi	a,02Ah
	sta	$4180
	xra	a
	sta	$4202
	lxi	h,008D6h
	shld	$4220
	lxi	h,$4220
	shld	$4111
	xra	a
	sta	$422A
	ret


L0C8C:
	shld	$4136
	shld	$413A		;row 1,2 mode bits 
	xchg
	lxi	h,00010h
	shld	$413C
	lda	$4422		;LED row 7 shadow
	ani	010h		;check Edit bit
	rz
	lhld	$441C		;LED row 1 shadow
	jmp	0DEDCh		;DS8 code, OR d and e upper nibbles into hl, write to prog select LEDs



L0CA5:				;writes acc to 4133 mode, clears transpose bit, jumps based on 4133
	mov	b,a
	lda	$4133		
	cmp	b		;~~~this doesn't seem to be needed
	mov	a,b
	sta	$4133		;update mode value

	lda	$441C		;LED row 1 shadow
	ani	0F7h		;clear transpose bit
	sta	$441C		;LED row 1 shadow
	out	059h

	call	022E1h		;DS7 code, if 461A D6=0 (Panel), set mode with 4133 0-3 value
	lda	$4133
	dcr	a
	cnz	0DDACh		;if new mode is not split call this, DS8
				;this will turn off arpeggiator if it's on, so maybe it requires split mode? 
	call	L0932

	lda	$4133		;get mode
	add	a		;shift acc left 1
	mov	c,a
	mvi	b,000h
	lxi	h,00CD5h
	dad	b		;get address from jump table based on mode
	mov	a,m
	inx	h
	mov	h,m
	mov	l,a
	pchl			;and jump to it

L0CD5:				;a little jump table:
	.dw	L0BFA		;poly
	.dw	L0C26		;split
	.dw	L0C2B		;dual
	.dw	L0C67		;mono


				;write start of voice ram for current voice (in 4134) to 443F
L0CDD:				;ld hl with 4080, add 4134 contents to h, store hl at 443F
	lda	$4134
	lxi	h,04080h
	add	h
	mov	h,a
	shld	$443F		;start of voice ram for current voice
	ret



L0CE9:				;returns the address of current patch in hl and at $4130, reads Patch if Patch Read enabled
	lda	$412F		;seems to contain current prog number, from 0-255, including the bank info
L0CEC:
	mov	b,a		;this is computing the addr of a particular program, returned in hl and at $4130 if Patch Read not enabled
	ani	0C0h		;top 2 bits of b
	rlc
	rlc			;in low 2 bits of acc
	mov	e,a		;move to e reg
	mvi	d,000h
	lxi	h,$4700		;start of table of bank upper address bytes		
	dad	d		;index into the table
	mov	c,m		;this addr contained 0xCC, upper byte of current bank addr

	mov	a,b
	ani	03Fh
	add	a		;b low 6 bits times 2
	add	a		;times 4
	mov	e,a		;save in e reg

	xchg
	dad	h
	mov	e,l
	mov	d,h
	dad	h
	dad	d
	mov	a,h
	add	c
	mov	h,a
	shld	$4130		;save program address here

	lda	$4422		;LED row 7 shadow
	ani	020h		;check Patch Read Mode bit
	rz

	xchg
	lxi	h,$4600		;patch buffer
	mvi	b,018h		;24 bytes is one patch
	jmp	0DF09h		;DS8, copies from [de] to [hl], incs both ptrs, uses b as byte ctr
				;this code was loading a patch from EPROM

L0D1A:
	call	L0CDD		;calculate start of voice ram for current voice (in 4134)
	lda	$4600		;start of patch buffer
	mov	c,a
	call	0D29Ch		;DS8
	lda	$4601
	add	a
	call	0D5A7h		;DS8
	lxi	h,$0000
	shld	$4430
	lda	$4602
	call	0D2E3h		;DS8
	lda	$4603
	call	0D33Fh		;DS8
	lda	$4604
	mov	b,a
	lxi	d,00067h
	lhld	$443F				;start of voice ram for current voice
	xchg
	dad	d
	mov	m,b
	mov	c,b
	mvi	b,008h
L0D4D:
	rlc
	jc	L0D56
	dcr	b
	dcr	b
	jnz	L0D4D
L0D56:
	lxi	h,00030h
	dad	d
	mov	m,b
	lhld	$443F		;start of voice ram for current voice
	lxi	b,00004h
	dad	b
	lda	$4605
	ani	03Fh
	mov	m,a
	inx	h
	lda	$4606
	ani	03Fh
	mov	m,a
	inx	h
	lda	$4607
	ani	03Fh
	mov	m,a
	inx	h
	lda	$4608
	ani	03Fh
	mov	m,a
	call	0D392h		;DS8

	lda	$4605		;vce 1 patch, offset 5
	ani	0C0h
	rlc
	rlc
	rlc
	mov	e,a
	jnz	L0D8E
	mvi	e,001h
L0D8E:
	call	023BDh		;DS7 code
	lda	$4606		;vce 1 patch, offset 6
	rrc
	rrc
	rrc
	rrc
	ani	00Ch
	mov	e,a
	call	02031h		;DS7 code

	lda	$4607		;vce 1 patch, offset 7
	ani	0C0h
	rlc
	rlc
	rlc
	jnz	L0DAB
	mvi	a,001h
L0DAB:
	call	023E7h		;DS7 code

	lda	$4608		;vce 1 patch, offset 8
	ani	040h
	rrc
	lhld	$443F		;start of voice ram for current voice
	lxi	d,0007Bh
	dad	d
	mov	m,a

	lxi	d,0006Ch
	lda	$4609		;vce 1 patch, offset 9
	call	0D49Eh		;DS8

	lda	$460A		;vce 1 patch, offset A
	mov	c,a
	call	0D457h		;DS8

	lda	$460B		;vce 1 patch, offset B
	mov	c,a
	call	0D419h		;DS8

	lda	$460C		;vce 1 patch, offset C
	mov	c,a
	call	0D42Eh		;DS8

	lda	$460D		;vce 1 patch, offset D
	mov	c,a
	call	0D501h		;DS8

	lda	$460E		;vce 1 patch, offset E
	mov	c,a
	call	0D4AFh		;DS8

	lda	$460F		;vce 1 patch, offset F
	mov	c,a
	call	0D4E8h		;DS8

	lda	$4610		;vce 1 patch, offset 10
	mov	c,a
	call	0D50Eh		;DS8

	lda	$4611		;vce 1 patch, offset 11
	mov	c,a
	call	0D567h		;DS8

	lda	$4612		;vce 1 patch, offset 12
	mov	c,a
	call	0D574h		;DS8

	lda	$4613		;vce 1 patch, offset 13
	mov	c,a
	call	0D55Eh		;DS8

	lda	$4614		;vce 1 patch, offset 14
	mov	c,a
	call	0D513h		;DS8

	lda	$4615		;vce 1 patch, offset 15
	mov	c,a
	call	0D52Ch		;DS8

	lda	$4616		;vce 1 patch, offset 16
	mov	c,a
	call	0D545h		;DS8

	lda	$4617		;vce 1 patch, offset 17
	mov	c,a
	call	0D55Eh		;DS8

	lhld	$443F		;start of voice ram for current voice
	lxi	b,00003h
	dad	b
	lda	$412F		;seems to contain current prog number, from 0-255, including the bank info
	mov	m,a
	xra	a
	lxi	b,00065h
	dad	b
	mov	m,a
	lxi	b,00014h
	dad	b
	mov	m,a
	inx	h
	mov	m,a
	inx	h
	mov	m,a
	inx	h
	mov	m,a
L0E43:
	lhld	$4244
	mov	a,h
	add	l
	jz	L0E51
	call	L11D4
	jmp	L0E43
L0E51:
	ret



L0E52:
	lda	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	ana	a
	jz	L0E60
	dcx	h
	lda	$40E8
	jmp	L0E61

L0E60:
	mov	a,m
L0E61:
	xchg
	lhld	$443F		;start of voice ram for current voice
	lxi	b,00068h
	dad	b
	ani	0FCh
	mov	m,a
	inx	d
	lxi	b,0FF9Bh
	dad	b
	xchg
	mov	a,m
	stax	d
	inx	h
	shld	$4142
	mov	a,m
	xchg
	lxi	d,00079h
	dad	d
	call	L0E9B
	lhld	$4142
	inx	h
	mov	a,m
	shld	$4142
	lhld	$443F		;start of voice ram for current voice
	lxi	d,0007Eh
	dad	d
	call	L0E9B
	lhld	$4142
	inx	h
	shld	$4142
	ret


L0E9B:
	mov	c,a
	rrc
	rrc
	rrc
	rrc
	ani	0F0h
	mov	m,a
	inx	h
	mov	a,c
	add	a
	sbb	a
	ani	00Fh
	mov	b,a
	mov	a,c
	ani	0F0h
	ora	b
	rrc
	rrc
	rrc
	rrc
	mov	m,a
	ret


L0EB4:
	lda	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	mov	c,a
	inr	c
	lda	$4133		;get mode
	ana	a
	jz	L0ED7		;if poly, jump

	cpi	003h		;if mono, jump
	mvi	a,001h
	jz	L0ECF

	dcr	c
	add	c
	add	a
	add	a
	add	a
	jmp	L0ED9

L0ECF:
	dcr	c
	jz	L0ED9
	add	a
	jmp	L0ECF



L0ED7:				;reads values from a voice RAM area and uses them to set LEDs
	mvi	a,001h
L0ED9:
	sta	$4434
	lda	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	call	L0CDD		;calculate start of voice RAM for current voice (in 4134), leave in hl
	xchg			;put voice RAM start in de
	lxi	h,00067h
	dad	d
	mov	a,m
	mov	b,a
	ani	00Fh		;offset 67 low 4 bits are for LFO destination
	mov	c,a

	lda	$4421		;LED row 6 shadow
	ani	0F0h		;clear LFO dest bits
	ora	c
	sta	$4421		;LED row 6 shadow
	out	05Eh		;update LED row 6

	mov	a,b
	rrc
	rrc
	rrc
	rrc
	ani	00Fh		;offset 67 upper 4 bits are for LFO waveshape
	mov	c,a

	lda	$441D		;LED row 2 shadow
	ani	0F0h		;clear LFO waveshape bits
	ora	c
	sta	$441D		;LED row 2 shadow
	out	05Ah		;update LED row 2

	call	L1FFA
	lda	$441E		;LED row 3 shadow
	ani	003h		;check mode and select bits
	ora	c
	lxi	h,0007Bh
	dad	d
	ora	m
	mov	b,a
	lxi	h,00068h
	dad	d
	mov	a,m
	ani	0C0h
	ora	b
	sta	$441E		;LED row 3 shadow
	out	05Bh
	mov	a,m
	ani	03Ch
	rrc
	rrc
	mov	b,a
	lda	$441F		;LED row 4 shadow
	ani	0F0h
	ora	b
	sta	$441F		;LED row 4 shadow
	out	05Ch
	ani	008h
	jz	L0F42
	lda	$4419
	sta	$442F
L0F42:
	call	L1FBF
	call	0D3EFh		;DS8, sets 2'-16' bits based on c reg and bytes at offset 4,6 in vce RAM
	lda	$412E
	ana	a
	rnz
	lhld	$443F		;start of voice ram for current voice
	lxi	d,00003h
	dad	d
	mov	a,m
	sta	$4132
	mov	b,a
	lda	$412E
	ana	a
	jnz	L0F73
	mov	a,b
	ani	0C0h
	mov	b,a
	mvi	c,080h
L0F66:
	mov	a,b
	sui	040h
	jc	L0F75
	mov	b,a
	mov	a,c
	rrc
	mov	c,a
	jmp	L0F66

L0F73:
	mvi	c,030h		;this would set Pedal and Bend bits
L0F75:
	lda	$4135		;sw second fcn mask?
	ani	001h
	lxi	h,$4141		;rows 4 and 7 mode bits: TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	jnz	L0F83
	lxi	h,$441F		;LED row 4 shadow
L0F83:
	mov	a,m
	ani	00Fh		;just keep upper nibble
	ora	c
	mov	m,a

	lda	$4132
	ani	007h
	call	0DF3Ah		;DS8, formats acc (0-7) for display in Prog Sel (or Prog Grp), in de
	lda	$4135		;sw second fcn mask
	ani	008h
	jnz	L0F9F
	xchg
	shld	$4138
	jmp	L0FA5

L0F9F:
	lhld	$441C		;LED row 1 shadow
	call	0DEDCh		;DS8 code, OR d and e upper nibbles into hl, write to prog select LEDs
L0FA5:
	lda	$4132
	ani	038h
	rrc
	rrc
	rrc
	call	0DF3Ah		;DS8, formats acc (0-7) for display in Prog Sel (or Prog Grp), in de

	lda	$4135		;sw second fcn mask
	ani	003h		;clear all but D1,D0
	mov	b,a		;save in b
	ani	001h		;test D0 mode select

	lxi	h,$413F		;row 5 mode bits in upper nibble:D7 Chan, D6:Omni, D5:Sequ, D4:Sync
	jnz	L0FC1		;if Mode is enabled, select mode bits
				;if not, select normal Prog Grp 1-4 data
	lxi	h,$4420		;LED row 5 shadow
L0FC1:
	mov	a,m		;read selected RAM
	ani	00Fh		;clear upper bits
	ora	e		;OR in new data
	mov	m,a		;update RAM 

	mov	a,b		;second fcn mask
	ani	002h		;test D1 mode select
	lxi	h,04140h	;row 6 mode bits in upper nibble:D7 Mono, D6:Dual, D5:Split, D4:Poly
	jnz	L0FD2

	lxi	h,$4421		;LED row 6 shadow
L0FD2:
	mov	a,m		;read selected RAM
	ani	00Fh		;clear upper bits
	ora	d		;OR in new data
	mov	m,a		;update RAM

	lxi	h,$441F		;LED row 4 shadow
	mov	a,m
	out	05Ch		;update LED row 4 from shadow
	inx	h
	mov	a,m
	out	05Dh		;update LED row 5 from shadow
	inx	h
	mov	a,m
	out	05Eh		;update LED row 6 from shadow
	ret


				;this code reads values from selected voice RAM buffer into the patch buffer
L0FE6:				;it's called right before we store a patch in RAM	
	lhld	$443F		;start of voice ram for current voice
	lxi	d,0000Dh
	call	L1175
	sta	$4600		;patch buffer offset 0

	lhld	$443F		;start of voice ram for current voice
	lxi	b,00034h
	dad	b
	mov	a,m
	inx	h
	ora	m
	rlc
	rlc
	rlc
	sta	$4601

	lhld	$443F		;start of voice ram for current voice
	lxi	b,00001h
	dad	b
	mov	a,m
	sta	$4602

	lhld	$443F		;start of voice ram for current voice
	lxi	b,00002h
	dad	b
	mov	a,m
	sta	$4603

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00067h
	dad	d
	mov	a,m
	sta	$4604

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00004h
	dad	d
	xchg
	ldax	d
	sta	$4605
	inx	d
	ldax	d
	sta	$4606
	inx	d
	ldax	d
	sta	$4607
	inx	d
	ldax	d
	sta	$4608

	lhld	$443F		;start of voice ram for current voice
	xchg
	lxi	h,0006Bh
	dad	d
	mov	a,m
	rrc
	rrc
	rrc
	ani	0C0h
	lxi	h,$4605
	ora	m
	mov	m,a
	call	02013h		;DS7 code
	mvi	c,000h
	lhld	$4341
	mov	a,l
	ana	b
	jz	L1060
	mvi	c,040h
L1060:
	mov	a,h
	ana	b
	mov	a,c
	jz	L1068
	ori	080h
L1068:
	lxi	h,$4606
	ora	m
	mov	m,a
	xchg
	lhld	$443F		;start of voice ram for current voice
	lxi	b,00072h
	dad	b
	mov	a,m
	rrc
	rrc
	rrc
	ani	0C0h
	xchg
	inx	h
	ora	m
	mov	m,a
	xchg

	lhld	$443F		;start of voice ram for current voice
	lxi	b,0007Bh
	dad	b
	mov	a,m
	rlc
	xchg
	inx	h
	ora	m
	mov	m,a

	lhld	$443F		;start of voice ram for current voice
	lxi	d,0006Ch
	call	L1161
	call	L1170
	sta	$4609

	lhld	$443F		;start of voice ram for current voice
	xchg
	lxi	h,00072h
	dad	d
	mov	a,m
	cpi	002h		;depending on this voice RAM bit, 460A patch data comes from one of two places
	jz	L10B9
	lhld	$443F		;start of voice ram for current voice
	lxi	d,00073h
	call	L1161
	call	L1170
	jmp	L10C5

L10B9:
	lhld	$443F		;start of voice ram for current voice
	lxi	d,00077h
	dad	d
	mov	a,m
	inx	h
	ora	m
	rrc
	rrc
L10C5:
	sta	$460A

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00011h
	call	L117C
	sta	$460B

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00015h
	call	L117C
	sta	$460C

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00018h
	call	L117C
	sta	$460D

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00010h
	dad	d
	mov	a,m
	cma
	call	L117E
	sta	$460E

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00014h
	call	L117C
	sta	$460F
	lda	$4432
	sta	$4610

	lhld	$443F		;start of voice ram for current voice
	lxi	d,0001Ch
	call	L117C
	sta	$4611

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00020h
	call	L117C
	sta	$4612

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00024h
	call	L117C
	sta	$4613

	lhld	$443F		;start of voice ram for current voice
	lxi	d,0001Bh
	call	L117C
	sta	$4614

	lhld	$443F		;start of voice ram for current voice
	lxi	d,0001Fh
	call	L117C
	sta	$4615

	lhld	$443F		;start of voice ram for current voice
	lxi	d,00023h
	call	L117C
	sta	$4616

	lhld	$443F		;start of voice ram for current voice
	lxi	d,0007Ah
	dad	d
	mov	a,m
	sta	$4617		;patch resonance value
	ret



L1161:
	dad	d
	mov	a,m
	cma
	mov	c,a
	inx	h
	mov	a,m
	cma
	mov	b,a
	inx	b
	mov	a,b
	ani	00Fh
	ora	c
	ret


	rrc
L1170:
	rrc
	rrc
	rrc
	dcr	a
	ret


L1175:
	dad	d
	mov	a,m
	inx	h
	ora	m
	jmp	L117E

L117C:
	dad	d
	mov	a,m
L117E:
	rlc
	rlc
	rlc
	rlc
	ret


L1183:
	lda	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	ana	a
	jz	L1197
	lhld	$4142
	xchg
	lhld	$443F		;start of voice ram for current voice
	lxi	b,00003h
	jmp	L11AB

L1197:
	lhld	$4142
	xchg
	lhld	$443F		;start of voice ram for current voice
	lxi	b,00068h
	dad	b
	ldax	d
	ora	m
	xchg
	mov	m,a
	inx	h
	xchg
	lxi	b,0FF9Bh
L11AB:
	dad	b
	mov	a,m
	xchg
	mov	m,a
	shld	$4142
	xchg
	lxi	b,00079h
	dad	b
	call	L11C1
	lhld	$443F		;start of voice ram for current voice
	lxi	d,0007Eh
	dad	d
L11C1:
	mov	e,m
	inx	h
	mov	a,m
	ani	00Fh
	ora	e
	rlc
	rlc
	rlc
	rlc
	lhld	$4142
	inx	h
	mov	m,a
	shld	$4142
	ret


L11D4:
	ei
	nop
	di
	lhld	$4244
	mov	a,l
	ana	a
	jnz	L11E5
	mov	a,h
	ana	a
	rz
	jmp	L1389

L11E5:
	di
	mov	b,a
	mov	c,h
	lxi	h,$0000
	dad	sp
	shld	$4535
	lhld	$443F		;start of voice ram for current voice
	xchg
	rar
	jc	L1212
	rar
	jc	L1225
	rar
	jc	L1236
	rar
	jc	L1258
	rar
	jc	L1264
	rar
	jc	L1275
	rar
	jc	L129B
	jmp	L1286

L1212:
	mov	a,b
	ani	0FEh
	sta	$4244
	lxi	h,00010h
	mvi	b,001h
	dad	d
	sphl
	lxi	h,00300h
	jmp	L124B

L1225:
	mov	a,b
	ani	0FCh
	mov	l,a
	mov	a,c
	ori	001h
	mov	h,a
	shld	$4244
	lxi	h,00013h
	jmp	L12B9

L1236:
	mov	a,b
	ani	0F8h
	mov	l,a
	mov	a,c
	ori	001h
	mov	h,a
	shld	$4244
	lxi	h,00017h
	mvi	b,002h
	dad	d
	sphl
	lxi	h,00600h
L124B:
	pop	d
	mov	a,d
	ani	0F0h
	mov	e,a
	mov	a,d
	ani	00Fh
	mov	d,a
	dad	d
	jmp	L12E5

L1258:
	mov	a,b
	ani	0F0h
	sta	$4244
	lxi	h,0001Ah
	jmp	L12B9

L1264:
	mov	a,b
	ani	0E0h
	mov	l,a
	mov	a,c
	ori	002h
	mov	h,a
	shld	$4244
	lxi	h,0001Eh
	jmp	L12B9

L1275:
	mov	a,b
	ani	0C0h
	mov	l,a
	mov	a,c
	ori	002h
	mov	h,a
	shld	$4244
	lxi	h,00022h
	jmp	L12B9

L1286:
	xra	a
	sta	$4244
	lxi	h,00008h
	dad	d
	sphl
	pop	h
	pop	b
	dad	b
	lxi	b,00300h
	dad	b
	mvi	b,003h
	jmp	L12E5

L129B:
	mov	a,b
	ani	080h
	sta	$4244
	lxi	h,00035h
	dad	d
	mov	a,m
	rlc
	mvi	a,000h
	ral
	inr	a
	mov	b,a
	lxi	h,0000Dh
	dad	d
	sphl
	pop	h
	lxi	d,00600h
	dad	d
	jmp	L12E5

L12B9:
	dad	d
	sphl
	pop	d
	mov	a,e
	ori	0F0h
	mov	h,a
	mov	a,e
	ani	0F0h
	mov	l,a
	mov	a,d
	ani	0F0h
	mov	e,a
	mov	a,d
	ani	00Fh
	mov	d,a
	dad	d
	mov	a,h
	mvi	e,002h
	ana	a
	jm	L12D6
	mvi	e,001h
L12D6:
	pop	b
	dcx	sp
	mov	a,c
	ani	00Fh
	mov	b,a
	mov	a,c
	ani	0F0h
	mov	c,a
	lxi	h,00600h
	dad	b
	mov	b,e
L12E5:
	dad	h
	jc	L1348
	mov	a,h
	adi	028h
	mov	h,a
	cpi	040h
	jm	L1328
	jz	L1317
	cpi	058h
	jm	L131C
	jz	L1305
	cpi	070h
	jm	L130A
	jmp	L1340

L1305:
	mov	a,l
	ana	a
	jz	L1338
L130A:
	mov	a,h
	sui	030h
	mov	h,a
	inx	h
	mov	e,m
	mvi	d,000h
	mvi	c,000h
	jmp	L134D

L1317:
	mov	a,l
	ana	a
	jz	L1330
L131C:
	mov	a,h
	sui	018h
	mov	h,a
	mov	e,m
	mvi	c,000h
	inx	h
	mov	d,m
	jmp	L134D

L1328:
	mov	d,m
	inx	h
	mov	c,m
	mvi	e,000h
	jmp	L134D

L1330:
	lxi	d,$0000
	mvi	c,001h
	jmp	L134D

L1338:
	lxi	d,00100h
	mvi	c,000h
	jmp	L134D

L1340:
	lxi	d,00001h
	mvi	c,000h
	jmp	L134D

L1348:
	lxi	d,0FF00h
	mvi	c,0FFh
L134D:
	mov	h,c
	mov	l,d
	shld	$0000
	dcx	sp
	pop	psw
	mvi	h,000h
	mov	l,a
	dad	sp
	dcr	b
	jz	L1367
	mov	m,e
	inx	h
	mov	m,d
	inx	h
	mov	m,c
	inx	h
	xra	a
	dcr	b
	jz	L1378
L1367:
	mvi	a,000h
	sub	e
	mov	m,a
	mvi	a,000h
	sbb	d
	inx	h
	mov	m,a
	inx	h
	mvi	a,000h
	sbb	c
	mov	m,a
	inx	h
	mvi	a,080h
L1378:
	dcr	b
	jz	L1384
	mov	b,a
	inx	h
	inx	h
	mov	a,m
	ani	07Fh
	ora	b
	mov	m,a
L1384:
	lhld	$4535
	sphl
	ret



L1389:
	lhld	$443F		;start of voice ram for current voice
	lxi	b,$0000
	mov	e,a
	rar
	mvi	d,001h
	jc	L139B
	mvi	d,002h
	lxi	b,00018h
L139B:
	dad	b
	mov	b,h
	mov	c,l
	mov	a,e
	xra	d
	sta	$4245
	lxi	h,00044h
	dad	b
	mov	a,m
	rlc
	jnc	L13C4
	lxi	h,00040h
	dad	b
	xchg
	lxi	h,00048h
	dad	b
	ldax	d
	sub	m
	jc	L13CA
	jnz	L13C4
	inx	d
	inx	h
	ldax	d
	sub	m
	jc	L13CA
L13C4:
	lxi	d,04810h
	jmp	L13CD

L13CA:
	lxi	d,00008h
L13CD:
	lxi	h,0003Ch
	dad	b
	mov	a,m
	ani	0E7h
	ora	e
	mov	m,a
	lxi	h,00044h
	dad	b
	mov	a,m
	ani	0A7h
	ora	d
	mov	m,a
	ret


L13E0:
	pop	h
	inx	h
	inx	h
	inx	h
	mov	c,m
	inx	h
	mov	b,m
	mov	a,c
	ora	b
	jz	L1404
	lxi	h,$0000
	dad	sp
	mvi	m,000h
	dcx	h
	dcx	h
	dcx	h
	mvi	m,014h
	dcx	h
	mvi	m,022h
	inx	sp
	pop	h
	push	b
	pop	h
	shld	$4439
	jmp	L01CD

L1404:
	lxi	h,$0000
	shld	$4439
	dad	sp
	mvi	m,000h
	inx	h
	mvi	m,000h
	inx	h
	mvi	m,000h
	lxi	d,0FFFAh
	dad	d
	lxi	d,01448h
	mov	m,e
	inx	h
	mov	m,d
	pop	h
	inx	sp
	jmp	L01CD

	pop	h
	pop	b
	mov	a,c
	add	m
	mov	c,a
	push	b
	inx	sp
	pop	b
	inx	h
	mov	a,m
	adc	c
	mov	c,a
	inx	h
	mov	a,m
	adc	b
	mov	b,a
	push	b
	mov	a,b
	inx	h
	inx	h
	inx	h
	xra	m
	jm	L143F
	dcx	sp
	jmp	L1404

L143F:
	pop	b
	mov	l,c
	mov	h,b
	shld	$4439
	jmp	L01CD

	lxi	h,$0000
	shld	$4439
	lxi	h,00005h
	dad	sp
	sphl
	jmp	L01CD

L1456:
	xra	a
	sta	$4435
	lda	$4440
	mov	d,a
	lxi	h,040B1h
	mvi	b,008h
L1463:
	mvi	e,0B1h
	mov	l,e
	ldax	d
	mov	m,a
	inr	e
	mov	l,e
	ldax	d
	mov	m,a
	inr	e
	mov	l,e
	ldax	d
	mov	m,a
	mvi	e,0B6h
	mov	l,e
	ldax	d
	mov	m,a
	inr	h
	dcr	b
	jnz	L1463
	ret

L147B:
	lda	$4440
	mov	d,a
	lxi	h,040B4h
	mvi	b,008h
L1484:
	mvi	e,0B4h
	mov	l,e
	ldax	d
	mov	m,a
	inr	e
	mov	l,e
	ldax	d
	mov	m,a
	inr	h
	dcr	b
	jnz	L1484
	mvi	a,001h
	sta	$4435
	ret

	lxi	h,014D3h
	push	h
	pop	h
	pop	h
	inx	sp
	pop	b
	pop	d
	mvi	e,000h
	push	d
	inr	b
	jz	L14AE
	push	b
	pop	h
	inx	sp
	jmp	L01CD

L14AE:
	lxi	b,00AFFh
	push	b
	inx	sp
	lxi	b,0FF00h
	jmp	L14D5

	lxi	h,014D3h
	push	h
	pop	h
	pop	h
	lxi	b,00016h
	dad	b
	pop	b
	mvi	c,000h
	mov	b,m
	inx	h
	push	b
	pop	b
	pop	b
	mov	c,m
	mvi	b,000h
	push	b
	pop	b
	jmp	L01CD

	pop	h
	pop	b
L14D5:
	mov	a,c
	add	m
	mov	c,a
	push	b
	inx	sp
	pop	b
	inx	h
	mov	a,m
	adc	c
	mov	c,a
	inx	h
	mov	a,m
	adc	b
	mov	b,a
	push	b
	inx	h
	mov	a,m
	add	c
	inx	h
	mov	a,m
	adc	b
	inx	h
	nop
	xra	m
	jp	L1508
	inx	sp
	pop	psw
	ana	m
	jz	L01CD
	in	070h
	rrc
	jnc	L01CD
	mov	a,m
	ani	018h
	lxi	h,0FFFAh
	dad	sp
	add	m
	mov	m,a
	jmp	L01CD

L1508:
	mov	a,m
	mov	d,a
	inx	h
	mov	c,m
	inx	h
	mov	b,m
	inx	sp
	inx	sp
	push	b
	inx	sp
	mov	b,c
	mvi	c,000h
	push	b
	inx	h
	push	h
	mov	a,d
	ani	004h
	jz	L1523
	lxi	b,01549h
	push	b
	pop	b
L1523:
	lxi	h,00006h
	dad	sp
	sphl
	mov	a,d
	ani	002h
	jz	L01CD
	dcx	h
	mov	c,m
	mvi	m,042h
	mov	a,d
	ani	020h
	jnz	L01CD
	mov	d,c
	call	L0A3B
	lxi	h,042FFh
	lxi	d,$0000
	push	h
	push	d
	pop	h
	pop	h
	jmp	L01CD

	pop	h
	pop	d
	pop	b
	mov	a,b
	ana	a
	jz	L1569
	cpi	042h
	jz	L1574

	in	070h
	rrc
	jnc	L01CD		

	lxi	h,0FFF8h
	dad	sp
	lxi	d,014D3h
	mov	m,e
	inx	h
	mov	m,d
	jmp	L01CD

L1569:
	dcx	h
	mov	c,m
	dcx	h
	mov	d,m
	push	b
	push	d
	pop	b
	pop	d
	jmp	L01CD

L1574:
	lxi	h,$0000
	dad	sp
	mvi	l,05Dh
	sphl
	jmp	L01CD

L157E:
	lxi	b,$0000
	lxi	h,00009h
	dad	sp
	sphl
	jmp	L16E9

L1589:
	lxi	d,015E7h
L158C:
	lxi	h,015D4h
	push	h
	pop	h
	pop	h
	mvi	l,0A6h
	push	h
	pop	h
	pop	b
	lxi	b,$0000
	push	b
	pop	h
	pop	h
	push	b
	pop	b
	pop	h
	push	d
	pop	d
	inx	sp
	jmp	L16E7

L15A6:
	lxi	d,01635h
	lxi	h,015D4h
	push	h
	pop	h
	pop	h
	mvi	l,0A9h
	push	h
	pop	h
	pop	b
	lxi	b,00001h
	push	b
	pop	b
	pop	b
	mvi	l,0ACh
	mov	c,m
	inx	h
	mov	b,m
	push	b
	pop	b
	pop	h
	push	d
	pop	d
	inx	sp
	jmp	L16E7

L15C8:
	lxi	d,01662h
	jmp	L158C

L15CE:
	lxi	d,016B1h
	jmp	L158C

L15D4:
	pop	h
	pop	d
	mov	a,d
	add	m
	mov	d,a
	push	d
	pop	d
	pop	d
	inx	h
	mov	a,m
	adc	e
	mov	e,a
	inx	h
	mov	a,m
	adc	d
	mov	d,a
	push	d
	pop	b
	ret



L15E7:
	mvi	l,0AEh
	xchg
	dad	h
	jc	L15F6
	ldax	d
	add	l
	inx	d
	ldax	d
	adc	h
	jnc	L1631
L15F6:
	lxi	h,01609h
L15F9:
	push	h
	pop	h
	mvi	e,000h
L15FD:
	pop	h
	dcx	sp
	lda	$4433
	xra	l
	sta	$4433
	jmp	L16E9

L1609:
	mvi	l,0AEh
	xchg
	ldax	d
	add	l
	inx	d
	ldax	d
	adc	h
	jnc	L1631
	lxi	d,01589h
L1617:
	lxi	h,0FFF6h
	dad	sp
	mov	m,e
	inx	h
	mov	m,d
	pop	h
	dcx	sp
	lda	$4433
	xra	l
	sta	$4433
	jmp	L16E7

L162A:
	mov	b,a
	dcx	sp
	dcx	sp
	push	b
	pop	b
	inx	sp
	inx	sp
L1631:
	inx	sp
	jmp	L16E7

L1635:
	mvi	l,0AEh
	mov	a,m
	cmp	b
	jc	L162A
	inx	h
	xchg
	dad	h
	jc	L1631
	ldax	d
	add	l
	inx	d
	ldax	d
	adc	h
	jc	L1631
	lxi	h,01650h
	jmp	L15F9

L1650:
	mov	a,b
	ana	a
	jm	L1659
	ora	c
	jnz	L1631
L1659:
	lxi	d,015A6h
	lxi	b,$0000
	jmp	L1617

L1662:
	xchg
	dad	h
	mov	c,l
	mov	b,h
	xchg
	mov	a,b
	ana	a
	jm	L168C
	mvi	l,0AEh
	xchg
	dad	h
	jc	L167B
	ldax	d
	add	l
	inx	d
	ldax	d
	adc	h
	jnc	L1631
L167B:
	lxi	h,01692h
	mvi	a,0A9h
	mvi	e,000h
L1682:
	push	h
	pop	h
	lxi	h,0FFF8h
	dad	sp
	mov	m,a
	jmp	L15FD

L168C:
	inx	sp
	mvi	e,0FFh
	jmp	L16E9

L1692:
	xchg
	dad	h
	mov	c,l
	mov	b,h
	xchg
	mov	a,b
	ana	a
	jp	L1631
	inx	h
	xchg
	dad	h
	ldax	d
	add	l
	inx	d
	ldax	d
	adc	h
	jc	L168C
	lxi	h,01662h
	mvi	a,0A6h
	mvi	e,0FFh
	jmp	L1682

L16B1:
	mvi	l,0AEh
	xchg
	dad	h
	ldax	d
	add	l
	inx	d
	ldax	d
	adc	h
	jnc	L16D2
	pop	h
	dcx	sp
	lda	$4433
	xra	l
	sta	$4433
	lxi	h,0FFF5h
	dad	sp
	mvi	m,0CEh
	inx	h
	mvi	m,015h
	jmp	L16D7

L16D2:
	pop	h
	dcx	sp
	lda	$4433
L16D7:
	ana	l
	jnz	L16E4
	xchg
	dcx	h
	dcx	h
	mov	b,m
	dcx	h
	mov	c,m
	jmp	L16E7

L16E4:
	lxi	b,$0000
L16E7:
	mvi	e,000h
L16E9:
	lxi	h,$0000
	dad	sp
	shld	$4537
	lxi	sp,04FFFh
	push	b
	push	d
	ei
	nop
	di
	pop	d
	pop	b
	lhld	$4537
	sphl
	pop	h
	mov	a,m
	sta	$4436
	xchg
	mov	h,b
	mov	b,l
	mov	l,c
	mov	c,h
	ani	001h
	mov	a,b
	jnz	L1711
	lxi	b,$0000
L1711:
	dad	h
	adc	a
	dad	h
	adc	a
	dad	h
	adc	a
	mov	l,h
	cma
	mov	h,a
	mov	a,l
	cma
	mov	l,a
	inx	h
	shld	$4437
	lhld	$4439
	dad	b
	pop	b
	dad	b
	mov	c,l
	mov	b,h
	lxi	h,$0000
	dad	sp
	shld	$4535
	xchg
	sphl
	xchg
	lhld	$442D
	dad	b
	pop	psw
	ani	004h
	jz	L1742
	xchg
	lhld	$442B
	dad	d
L1742:
	shld	$443B
	lxi	h,$0000
	dad	sp
	shld	$4537
	lxi	sp,04FFFh
	ei
	nop
	di
	lhld	$4537
	sphl
	lhld	$443B
	pop	d
	dad	d
	shld	$443B
	mvi	a,080h
	sub	l
	mov	l,a
	mvi	a,00Bh
	sbb	h
	mov	h,a
	pop	d
	dcx	sp
	dcr	e
	jnz	L1771
	inr	h
	inr	h
	shld	$443D
L1771:
	pop	b
	dad	b
	dad	h
	jc	L179B
	mov	a,h
	adi	028h
	mov	h,a
	cpi	040h
	jp	L1786
	mov	c,m
	inx	h
	mov	b,m
	jmp	L179E

L1786:
	cpi	058h
	jp	L1795
	sui	018h
	mov	h,a
	inx	h
	mov	c,m
	mvi	b,000h
	jmp	L179E

L1795:
	lxi	b,$0000
	jmp	L179E

L179B:
	lxi	b,0FE00h
L179E:
	mov	l,c
	mov	h,b
	shld	$5252		;write to DAC regs

	mov	a,e
	ana	a
	jz	L17AB
	shld	$443D
L17AB:
	lhld	$4535
	mov	a,m
	out	054h		;update DAC, select S&H chan

	lxi	h,$0000
	dad	sp
	shld	$4537
	lxi	sp,04FFFh
	push	d
	ei
	nop
	di
	pop	d
	lhld	$4537
	sphl
	lhld	$443B
	dad	h
	jc	L17EF
	mov	a,h
	adi	028h
	mov	h,a
	cpi	040h
	jp	L17DA
	mov	c,m
	inx	h
	mov	b,m
	jmp	L17F2

L17DA:
	cpi	058h
	jp	L17E9
	sui	018h
	mov	h,a
	inx	h
	mov	c,m
	mvi	b,000h
	jmp	L17F2

L17E9:
	lxi	b,$0000
	jmp	L17F2

L17EF:
	lxi	b,0FE00h
L17F2:
	lhld	$4535
	inx	h
	mov	h,m
	mov	l,h
	mov	m,c
	mov	m,b
	mov	a,e
	ana	a
	jnz	L1834
	lhld	$443D
	lxi	b,0F800h
	dad	b
	dad	h
	jc	L182E
	mov	a,h
	adi	028h
	mov	h,a
	cpi	040h
	jp	L1819
	mov	c,m
	inx	h
	mov	b,m
	jmp	L183D

L1819:
	cpi	058h
	jp	L1828
	sui	018h
	mov	h,a
	inx	h
	mov	c,m
	mvi	b,000h
	jmp	L183D

L1828:
	lxi	b,$0000
	jmp	L183D

L182E:
	lxi	b,0FE00h
	jmp	L183D

L1834:
	lhld	$443D
	shld	$5252		;write to DAC regs
	jmp	L1842

L183D:
	mov	l,c
	mov	h,b
	shld	$5252
L1842:
	lhld	$4535
	inx	h
	inx	h
	mov	a,m
	out	054h		;update DAC, select S&H chan
	inx	h
	shld	$4535
	ret

	lxi	h,$0000
	dad	sp
	shld	$4537
	lxi	sp,04FFFh
	push	d
	ei
	nop
	di
	pop	d
	lhld	$4537
	sphl
	lhld	$443B
	pop	b
	dad	b
	mov	a,e
	ana	a
	jz	L1880
	lxi	b,00180h
	dad	b
	lda	$4436
	ani	002h
	jz	L1888
	xchg
	lhld	$4437
	dad	d
	jmp	L1888

L1880:
	mov	a,h
	rar
	ana	a
	rar
	cma
	inr	a
	add	h
	mov	h,a
L1888:
	dad	h
	jc	L18B0
	mov	a,h
	adi	028h
	mov	h,a
	cpi	040h
	jp	L189B
	mov	c,m
	inx	h
	mov	b,m
	jmp	L18B3

L189B:
	cpi	058h
	jp	L18AA
	sui	018h
	mov	h,a
	inx	h
	mov	c,m
	mvi	b,000h
	jmp	L18B3

L18AA:
	lxi	b,$0000
	jmp	L18B3

L18B0:
	lxi	b,0FE00h
L18B3:
	lhld	$4535
	mov	a,m
	xchg
	mov	h,a
	mov	l,a
	mov	m,c
	mov	m,b
	pop	h
	shld	$5252		;write to DAC regs

	inx	d
	ldax	d
	out	054h		;update DAC, select S&H channel

	inx	d
	xchg
	shld	$4537
	lxi	sp,04FFFh
	ei
	nop
	di
	lhld	$4537
	sphl
	pop	h
	mov	e,m
	inx	h
	mov	d,m
	lda	$4436
	ani	004h
	jz	L18E4
	lhld	$4437
	dad	d
	xchg
L18E4:
	pop	b
	pop	h
	mov	a,m
	ana	a
	jz	L18EE
	xchg
	dad	b
	xchg
L18EE:
	inx	h
	mov	c,m
	inx	h
	mov	b,m
	xchg
	dad	b
	dad	h
	jc	L192F
	mov	a,h
	adi	028h
	mov	h,a
	cpi	040h
	jm	L191C
	jz	L190C
	cpi	046h
	jm	L1911
	jmp	L1929

L190C:
	mov	a,l
	ana	a
	jz	L1923
L1911:
	mov	a,h
	sui	018h
	mov	h,a
	inx	h
	mov	l,m
	mvi	h,000h
	jmp	L1932

L191C:
	mov	a,m
	inx	h
	mov	h,m
	mov	l,a
	jmp	L1932

L1923:
	lxi	h,00100h
	jmp	L1932

L1929:
	lxi	h,00030h
	jmp	L1932

L192F:
	lxi	h,0FFC0h
L1932:
	shld	$5252		;write to DAC regs
	dcx	sp
	pop	psw
	out	054h		;update DAC< select S&H chan
	lxi	h,$0000
	dad	sp
	shld	$4537
	lxi	sp,04FFFh
	ei
	nop
	di
	lhld	$4537
	sphl
	pop	h
	mov	c,m
	inx	h
	mov	b,m
	mov	a,b
	inr	a
	jz	L199C
	xchg
	inx	h
	mov	e,m
	inx	h
	mov	d,m
	xchg
	dad	b
	lda	$4436
	ani	008h
	jz	L1967
	xchg
	lhld	$4437
	dad	d
L1967:
	dad	h
	jc	L19A2
	mov	a,h
	adi	028h
	mov	h,a
	cpi	040h
	jm	L198F
	jz	L197F
	cpi	058h
	jm	L1984
	jmp	L199C

L197F:
	mov	a,l
	ana	a
	jz	L1996
L1984:
	mov	a,h
	sui	018h
	mov	h,a
	inx	h
	mov	l,m
	mvi	h,000h
L198C:
	jmp	L19A5

L198F:
	mov	a,m
	inx	h
	mov	h,m
	mov	l,a
	jmp	L19A5

L1996:
	lxi	h,00100h
	jmp	L19A5

L199C:
	lxi	h,$0000
	jmp	L19A5

L19A2:
	lxi	h,0FFFFh
L19A5:
	shld	$5252		;write to DAC regs
	dcx	sp
	pop	psw
	out	054h		;update DAC, select S&h chan
	ret



L19AD:
	mvi	a,01Ah
	out	050h
	in	051h
	out	051h
	mov	c,a
	lda	$4418
	sub	c
	rz
	jnc	L19C0
	inr	a
	rz
L19C0:
	mvi	a,018h
	sta	$453A
	mov	a,c
	sta	$4418
	ana	a
	jp	L19D2
	cpi	0A0h
	jp	L19E3
L19D2:
	cpi	040h
	jm	L19EA
	cpi	060h
	jm	L19E8
	sui	020h
	cpi	080h
	jm	L19EA
L19E3:
	mvi	a,07Fh
	jmp	L19EA

L19E8:
	mvi	a,040h
L19EA:
	mov	c,a
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	010h		;check Bend bit
	jz	L1A0C

	push	b		;Bend bit is set
	lxi	h,04102h
	mov	m,c
	dcx	h
	mov	a,c
	add	a
	jm	L19FF
	xra	a
L19FF:
	ani	07Eh
	mov	m,a
	dcx	h
	mvi	m,0E0h		;En is MIDI pitch wheel change
	mvi	b,003h
	xchg
	call	L057F
	pop	b
L1A0C:
	lxi	h,0FFC0h
	mvi	b,000h
	dad	b
	dad	h
	mov	a,h
	ana	a
	jm	L1A21
	mov	a,l
	adi	002h
	rlc
	rlc
	ani	003h
	add	l
	mov	l,a
L1A21:
	mov	e,l
	mov	d,h
	dad	h
	dad	d
	shld	$442B
	ret



L1A29:
	mvi	a,019h		;select the mod wheel next
	out	050h
	in	051h		;read previous conversion
	out	051h
	mov	c,a
	lda	$441A		;previous result for conversion before mod wheel
	mov	l,a
	sub	c
	rz
	jnc	L1A3D
	inr	a
	rz
L1A3D:
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	020h		;check Pedal bit
	jz	L1A50

	push	b
	mov	a,c
	ana	a
	rar
	mov	e,a
	mvi	d,004h		;"Change" is controller #4
	call	L0564		;sends MIDI controller, called with controller # in d, value in e
	pop	b
L1A50:
	lxi	h,$441A
	jmp	0D635h		;DS8


L1A56:
	lhld	$4400		;pot select code address
	xchg
	lhld	$4402
	xchg
	shld	$4402
	xchg
	mov	a,h
	ana	a
	jz	L1A6D
	dcr	a
	mov	h,a
	mov	a,l
	jmp	L1A7A

L1A6D:
	mov	a,l
	ana	a
	jnz	L1A74
	mvi	a,014h
L1A74:
	dcr	a
	mov	l,a
	cmp	e
	jz	L1A6D
L1A7A:
	shld	$4400
	out	050h
	in	051h
	cma
	out	051h
	mov	c,a
	lda	$4419
	mov	l,a
	sub	c
	rz
	jnc	L1A90
	inr	a
	rz
L1A90:
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	020h		;check Pedal bit
	jz	L1AA3

	push	b
	mov	a,c
	ana	a
	rar
	mov	e,a
	mvi	d,001h		;Bend depth is controller #1
	call	L0564		;sends MIDI controller, called with controller # in d, value in e
	pop	b
L1AA3:
	lxi	h,$4419
	jmp	0D5D8h		;DS8


				
L1AA9:				;this is probably the pot code
	mvi	a,018h		;select the pitch wheel next?		
	out	050h		;select next pot to convert
	in	051h		;read previous result
	cma
	out	051h		;kick off next conversion
	mov	c,a		;save value (inverted) in c

	lda	$4400		;pot select code 
	lxi	h,04404h	;pot values array start
	mov	e,a		;select code in e
	mvi	d,000h
	dad	d		;add de to array start
	mov	b,m		;get previous value
	mov	a,b		;into a and b
	cmp	c		;same as new value?
	rz			;if so, return

	lda	$4401		;ctr to keep us on a pot that's changing
	ana	a		;is it 0?
	jnz	L1AD5		;no, jump
		
	mov	a,b		;get prev value		
	sub	c		;a = prev - new value
	jp	L1ACF		;dif is pos, jmp
	cma
	inr	a		;otherwise, negate to make it pos
L1ACF:
	cpi	003h		;flags = |a| - 3
	rc			;return if difference is < 3
	jmp	L1ADC

L1AD5:
	mov	a,b
	sub	c
	jnc	L1ADC
	inr	a
	rz
L1ADC:
	mvi	a,010h
	sta	$4401		;set ctr to 16
	mov	m,c		
	lda	$4400		;get pot select code
	sta	$453A

	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	040h		;check Panel bit
	jz	0D25Eh		;DS8

	mov	d,c
	push	d
	mvi	d,000h
	lxi	h,01AFBh
	push	h
	jmp	0D25Eh		;DS8

	pop	d
	mvi	b,000h
	mov	c,e		;pot select code
	lxi	h,01B0Bh	;point to table
	dad	b		;bc as index
	mov	a,d
	ana	a
	rar
	mov	e,a
	mov	d,m
	jmp	L0564		;sends MIDI controller, called with controller # in d, value in e


L1B0B:			;table of controller numbers, index is pot select code
	.db	005h	;0 glide time
	.db	01Ch	;1 tempo
	.db	008h	;2 LFO/mod depth
	.db	009h	;3 LFO/mod rate
	.db	00Ah	;4 Tune
	.db	00Bh	;5 De-tune
	.db	00Fh	;6 VCA attack rate
	.db	010h	;7 VCA decay rate
	.db	00Ch	;8 WaveForm (Shape)
	.db	013h	;9 VCA attack final level
	.db	012h	;10 VCA sustain level
	.db	011h	;11 VCA release rate
	.db	01Ah	;12 Noise level
	.db	018h	;13 Filter attack final level
	.db	017h	;14 Filter sustain level
	.db	019h	;15 Filter idle level
	.db	01Bh	;16 Filter resonance
	.db	014h	;17 Filter attack rate
	.db	015h	;18 Filter decay rate
	.db	016h	;19 Filter release rate


L1B1F:				;switch code, incs de on each row
	lxi	b,050F8h	;the switches are read at 50F8-50FF
	lxi	h,04423h	;switch row previous data array
L1B25:
	ldax	b		;read switch row
	xra	m		;compare with previous value we read
	jnz	L1B31		;jump if it has changed
	inx	h
	inx	d
	inr	c
	jnz	L1B25		;read with c value = F8-FF (8 rows of switches!)
L1B30:
	ret

L1B31:
	mvi	b,000h
L1B33:
	rrc			;rotate non-zero xor result right
	jc	L1B3B		;to find right-most 1 bit
	inr	b		;so b is bit pos of first sw that has changed
	jmp	L1B33

L1B3B:
	mov	d,b		;save sw bit pos in d
	mvi	a,001h
L1B3E:
	rlc
	dcr	b
	jnz	L1B3E		;now we create a mask for sw that has changed, using b value

	mov	e,a		;save mask in e reg
	xra	m		;get previous data array byte into acc, with the one bit flipped
	mov	m,a		;update the byte in memory
	mov	a,e		;get the mask back into acc
	ana	m		;look at just that one bit in memory
	jz	L1B75		;jump if switch is now pressed
	mov	a,c
	cpi	0FFh		;is changed switch in row 7?
	jnz	L1B5E

	mov	a,e		;sw is in row 7
	ani	040h		;is it Patch store?
	jnz	0264Eh		;DS7 code
	mov	a,e
	ani	003h		;is it Edit Waveform Rise Time or Fall Time (also MIDI IN, OUT) sw?
	jnz	0251Fh		;DS7 code
	ret


L1B5E:
	cpi	0FCh		;is switch in row 4?
	rnz
	mov	a,e
	ani	080h		;is it Bank D/"Tembre" sw?
	rz
	lda	$441E		;LED row 3 shadow
	ani	001h		;check mode bit
	rz

	lxi	h,$441F		;LED row 4 shadow
	mov	a,m
	ani	07Fh		;clear Bank D/"Tembre" bit
	mov	m,a
	out	05Ch		;update LED row 4
	ret


L1B75:
	lxi	h,01B05h	;presumably switch handlers jump table
	mov	a,c		;address - 80h
	add	a
	add	a
	add	a
	add	d
	add	a
	mov	c,a
	dad	b
	mov	a,m
	inx	h
	mov	h,m
	mov	l,a
	pchl			;INFO: index jump


L1B85:				;table of 64 switch handler addresses
				;switch row 0:
	.dw	L1B30		;no sw 0, 1B30 is ret inst
	.dw	L1B30		;no sw 1	
	.dw	L1B30		;no sw 2
	.dw	L1B30		;no sw 3
	.dw	L1C2F		;sw 4, 16'
	.dw	L1C2F		;sw 5, 8'
	.dw	L1C2F		;sw 6, 4'
	.dw	L1C2F		;sw 7, 2'

				;switch row 1:
	.dw	0DBB9h		;sw 0, Seq Record
	.dw	0DC4Eh		;sw 1, Seq Step
	.dw	0DC6Ch		;sw 2, Seq Loop
	.dw	L1C88		;sw 3, Playback Transp
	.dw	L1D24		;sw 4, Prog Sel 1
	.dw	L1D24		;sw 5, Prog Sel 2
	.dw	L1D24		;sw 6, Prog Sel 3
	.dw	L1D24		;sw 7, Prog Sel 4

				;switch row 2:
	.dw	L1DBD		;sw 0, LFO Ramp up
	.dw	L1DBD		;sw 1, LFO Ramp dn
	.dw	L1DBD		;sw 2, LFO Tri
	.dw	L1DBD		;sw 3, LFO Square
	.dw	L1DF4		;sw 4, Prog Sel 5	
	.dw	L1DF4		;sw 5, Prog Sel 6	
	.dw	L1DF4		;sw 6, Prog Sel 7	
	.dw	L1DF4		;sw 7, Prog Sel 8	

				;switch row 3:
	.dw	L1F17		;sw 0, Mode
	.dw	L1F35		;sw 1, select	
	.dw	L1F88		;sw 2, "1"
	.dw	L1F88		;sw 3, "2"
	.dw	02055h		;sw 4 Port Enab	
	.dw	020BCh		;sw 5 Filt Key Track
	.dw	020F6h		;sw 6 Filt Ped Enab
	.dw	020F6h		;sw 7 VCA Ped Enab

				;switch row 4:
	.dw	0212Fh		;sw 0, Pitch wh ctl of osc pitch enab
	.dw	0212Fh		;sw 1, Pitch wh ctl of filt cut enab
	.dw	0212Fh		;sw 2, Mod wh ctl of LFO DCO mod amt enab
	.dw	0212Fh		;sw 3, Mod wh ctl of Filt cut mod amt enab
	.dw	02160h		;sw 4, Bank A
	.dw	02160h		;sw 5, Bank B
	.dw	02160h		;sw 6, Bank C
	.dw	02160h		;sw 7, Bank D

				;switch row 5:
	.dw	0DC76h		;sw 0, Play
	.dw	0DD18h		;sw 1, Pause
	.dw	0DD8Dh		;sw 2, ArpUp
	.dw	0DD8Dh		;sw 3, ArpDn
	.dw	02276h		;sw 4, Prog Grp Sel 1
	.dw	02276h		;sw 5, Prog Grp Sel 2
	.dw	02276h		;sw 6, Prog Grp Sel 3
	.dw	02276h		;sw 7, Prog Grp Sel 4

				;switch row 6:
	.dw	0234Dh		;sw 0, LFO freq Mod
	.dw	0234Dh		;sw 1, LFO shape mod
	.dw	0234Dh		;sw 2, LFO filter mod
	.dw	0234Dh		;sw 3, LFO VCA mod
	.dw	022ABh		;sw 4, Prog Grp Sel 5
	.dw	022ABh		;sw 5, Prog Grp Sel 6
	.dw	022ABh		;sw 6, Prog Grp Sel 7
	.dw	022ABh		;sw 7, Prog Grp Sel 8

				;switch row 7:
	.dw	0238Ah		;sw 0, Edit waveform rise time
	.dw	0238Ah		;sw 1, Edit waveform PW
	.dw	0238Ah		;sw 2, Edit waveform fall time
	.dw	02414h		;sw 3, chord
	.dw	02538h		;sw 4, Edit mode
	.dw	02579h		;sw 5, Patch Read Mode
	.dw	02597h		;sw 6, Patch Store
	.dw	00000h		;no sw 7 (reset switch)


L1C05:
	sui	044h		;subtract 68 from MIDI controller number
	add	a		;shift left one for table of words
	mov	c,a
	mvi	b,000h
	lxi	h,L1C17		;jump table start address
	dad	b

	inx	d		;bump byte ptr
	ldax	d		;grab next MIDI byte
	mov	e,a		;and put it in e

	mov	a,m		;read address from table and...
	inx	h
	mov	h,m
	mov	l,a
	pchl			;jump to it


				;a small jump table
L1C17:				;seems to be related to MIDI controllers
				;looks like e has MIDI data byte value at this pt			
	.dw	L1DB2		;68		
	.dw	0233Fh		;69 looks like LFO mods enab code
	.dw	L1F7E		;70
	.dw	02375h		;71
	.dw	L1C29		;72 looks like 16'-2' bits code
	.dw	021DBh		;73
	.dw	020B0h		;74 looks like Filter key track bit code
	.dw	02126h		;75 looks like pitch and mod wheel enabs code
	.dw	020EAh		;76 looks like pedal enables code

L1C29:
	mov	a,e		;start of code after table
	add	a
	mov	e,a
	jmp	L1C41


L1C2F:				;handler for 16'-2' switches
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	040h		;check Panel bit
	jz	L1C41		;skip if not enabled

	push	d		;save d
	mov	a,e		;e should be change bit mask
	rrc			;rotate right one pos
	mov	e,a
	mvi	d,048h		;controller number for "register" is 72 (48h)
	call	L0564		;sends MIDI controller, called with controller # in d, value in e
	pop	d		;restore d
L1C41:
	lda	$441B		;LED row 0 shadow
	mov	d,a
	ani	00Fh		;clear 16'-2' bits
	ora	e
	sta	$441B		;LED row 0 shadow
	out	058h		;update LED row 0
	mov	a,d
	ani	0F0h
	mov	d,a
	cmp	e
	rz
	jnc	L1C66
	lxi	b,00C0Ch
L1C59:
	rlc
	cmp	e
	jz	L1C76
	mov	d,a
	mov	a,b
	add	c
	mov	b,a
	mov	a,d
	jmp	L1C59

L1C66:
	lxi	b,0F4F4h
L1C69:
	rrc
	cmp	e
	jz	L1C76
	mov	d,a
	mov	a,b
	add	c
	mov	b,a
	mov	a,d
	jmp	L1C69

L1C76:
	lhld	$443F		;start of voice ram for current voice
	lxi	d,00004h
	dad	d
	mov	a,m
	add	b
	mov	m,a
	inx	h
	inx	h
	mov	a,m
	add	b
	mov	m,a
	jmp	0D392h		;DS8


L1C88:				;handler for playback transpose key
	lda	$441C		;LED row 1 shadow
	mov	b,a
	xra	e		;toggle bit
	sta	$441C		;LED row 1 shadow
	out	059h		;update row 1 LEDs

	ana	e
	jz	L1D00
	mov	a,b
	ani	001h		;if Seq rec LED is not lit
	jz	L1CA3		;jump down
				;otherwise,
	mov	a,b		;put row 1 back to previous value
	sta	$441C		;LED row 1 shadow
	out	059h
	ret

L1CA3:
	lda	$4420		;LED row 5 shadow
	ani	00Fh		;check Play,Pause,ARPup,ARPdn bits
	jnz	L1CB3

	lxi	d,L1D0F		;a code address
	mvi	b,070h
	jmp	L0493		;if b=70h, store de at 412A and return


L1CB3:				;one of them is pressed
	lxi	d,L1CBB		;a code address
	mvi	b,070h
	jmp	L0493		;if b=70h, store de at 412A and return

				;possible address at 412a
L1CBB:				;seems like we jump here after a new key is logged as pressed				
	lda	$4133		;get mode
	dcr	a
	jnz	L1CC9		;if not split, skip

	lda	$4114		;MIDI number of note just below the split point
	cmp	d		;if d key is below split point, then 
	jc	L043A		;jump
L1CC9:
	mov	a,d		;MIDI note number for key just pressed?
	sui	030h		;subtract MIDI offset
	sta	$4710		;save result as tranpose offset

	lda	$4420		;LED row 5 shadow
	ani	0FDh		;clear Pause bit
	ori	001h		;set Play bit
	sta	$4420		;LED row 5 shadow
	out	05Dh		;update LED row 5

	ani	00Ch		;check ARP Up and Dn LEDs
	jz	L1CE8		;if neither is on, jump

	mvi	a,01Fh
	sta	$4531
	jmp	L046F


L1CE8:
	push	b
	push	d

	lda	$4707		;get sequencer status
	ani	001h		;is it playing?
	jnz	L1CF8		;if not, jump

	call	0DCDBh		;DS8
	jmp	L1CFB


L1CF8:
	call	L0932
L1CFB:
	pop	d
	pop	b
	jmp	L046F


L1D00:
	lda	$441C		;LED row 1 shadow
	ani	0F7h		;clear playback transpose bit
	sta	$441C		;LED row 1 shadow
	out	059h		;update LED row 1

	mvi	b,071h
	jmp	L0493		;seems to be forming a MIDI message, but doesn't send it

L1D0F:
	push	b
	lda	$441C		;LED row 1 shadow
	ani	0F7h		;clear playback transpose bit
	sta	$441C		;LED row 1 shadow
	out	059h

	mvi	b,021h		;if b == 21,
	call	L0493		;this sets the split point at just below the note

	pop	b
	jmp	L046F
	ret


				
L1D24:				;handler for prog sel 1-4 switches				
	lda	$441E		;LED row 3 shadow
	ani	001h		;check mode bit
	jnz	L1D4D

	lda	$4422		;LED row 7 shadow
	ani	010h		;check Edit bit
	jz	L1D54
	lda	$441E		;LED row 3 shadow
	ani	002h		;check select bit
	jnz	L1D66
	lhld	$4136
	mov	a,l
	ana	e
	rz
	mov	a,d
	ani	003h
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	mvi	d,000h
	jmp	L1E19


L1D4D:				;mode LED is lit
	mov	a,d		;bit pos of pressed sw
	ani	003h		;make it 0-3
	mov	d,a
	jmp	L1E51


L1D54:
	mov	a,d
	ani	003h
	mov	b,a
	lda	$412F		;seems to contain current prog number, from 0-255, including the bank info
	ani	0F8h		;clear low 3 bits
	ora	b		;OR in new value
	sta	$412F		;seems to contain current prog number, from 0-255, including the bank info
	mvi	d,000h
	jmp	L1EA6


L1D66:
	lda	$4133		;get mode
	ana	a
	rz			;return if poly

	cpi	003h
	jnz	L1D92		;jump if not mono
	mov	a,e
	rar
	rar
	rar
	rar
	mov	b,a
	cma
	mov	c,a
	lda	$4345
	ana	c
	mov	c,a
	lda	$441C		;LED row 1 shadow
	xra	e
	sta	$441C		;LED row 1 shadow
	out	059h
	ana	e
	mov	a,c
	jz	L1D8C
	ora	b
L1D8C:
	sta	$4345
	jmp	L0255


L1D92:
	mov	a,e
	ani	030h
	rz
	mvi	c,00Fh
	cpi	010h
	jz	L1D9F
	mvi	c,0F0h
L1D9F:
	lda	$4345
	xra	c
	sta	$4345
	lda	$441C		;LED row 1 shadow
	xra	e
	sta	$441C		;LED row 1 shadow
	out	059h
	jmp	L0255


L1DB2:
	mov	a,e
	mvi	d,000h
L1DB5:
	rrc
	jc	L1DCC
	inr	d		;form bit pos in d of rightmost 1 bit in e reg
	jmp	L1DB5

L1DBD:				;handler for LFO waveform switches
	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	040h		;check "Panel" bit
	jz	L1DCC

	push	d
	mvi	d,044h		;LFO waveform is controller #68
	call	L0564		;sends MIDI controller, called with controller # in d, value in e
	pop	d
L1DCC:
	lda	$441D		;get LED row 2 shadow
	ani	0F0h		;clear LFO waveshape bits
	ora	e		;OR in new value
	sta	$441D		;update LED row 2 shadow
	out	05Ah

	mov	c,d
	mov	a,e
	rlc
	rlc
	rlc
	rlc
	mov	b,a
	lhld	$443F		;start of voice ram for current voice
	xchg
	lxi	h,00067h
	dad	d
	mov	a,m
	ani	00Fh
	ora	b
	mov	m,a
	lxi	h,00030h
	dad	d
	mov	a,c
	inr	a
	add	a
	mov	m,a
	ret


L1DF4:				;handler for prog sel 5-8 switches
	lda	$441E		;LED row 3 shadow
	ani	001h		;check mode bit
	jnz	L1E50

	lda	$4422		;LED row 7 shadow
	ani	010h		;check Edit bit
	jz	L1E99
	lda	$441E		;LED row 3 shadow
	ani	002h		;check select bit
	jnz	L1EF3
	lhld	$4136
	mov	a,h
	ana	e
	rz
	mov	a,d
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	mov	d,e
	mvi	e,000h
L1E19:
	xchg
	shld	$413C
	lhld	$441C		;LED rows 1,2 shadows
	call	0DEDCh		;DS8 code, OR d and e upper nibbles into hl, write to prog select LEDs
	jmp	L0EB4


L1E26:
	ani	007h
	sta	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	mov	b,a
	ani	003h
	inr	a
	mov	c,a
	mov	a,b
	ani	004h
	mov	b,a
	mvi	a,010h
L1E36:
	dcr	c
	jz	L1E3E
	add	a
	jmp	L1E36


L1E3E:
	mov	d,a
	mvi	e,000h
	mov	a,b
	ana	a
	jnz	L1E49
	mov	e,d
	mvi	d,000h
L1E49:
	xchg
	shld	$413C
	jmp	L0EB4


L1E50:				;Prog sel 5-8 code, mode bit is set
	mov	a,d
L1E51:				;Prog sel 1-4 handler jumps here as well, if mode set
	lda	$461B		;save area equiv of addr 413F, row 5 mode bits
	ani	080h		;just keep "Channel" bit
	rrc
	rrc
	rrc
	rrc			;rotate it right four places, so its value is 8
	add	d		;add bit pos of pressed Prog sel sw
	mov	d,a

	lda	$442A		;get state of switch row 7
	cma			;complement it (doesn't affect flags!)
	ana	a		;so set them
	rz			;if no sw is pressed, return
				;seems like we are looking for MIDI In or Out or KB1 or KB2 pressed
	mov	c,a		;save sw row 7 state
	dcr	a
	jnz	L1E6D		;jump if MIDI In not pressed

				:MIDI In pressed
	lxi	h,$461C		;MIDI In channel info?		
	jmp	L1E72


L1E6D:				;MIDI In not pressed
	dcr	a		;check for MIDI Out pressed
	rnz			;return if not pressed
	lxi	h,$4103		;MIDI out channel info?
L1E72:
	lda	$4420		;LED row 5 shadow
	ani	080h		;keep only Prog Grp Sel 4 bit
	rrc
	rrc
	rrc
	rrc			;rotate it right four places, so its value is 8
	ora	d		;OR it in with bit pos of pressed Prog sel sw	
	mov	m,a		;save result at 461C or 4103, depending on which sw is pressed 
	mov	a,c		;retrieve sw row 7 state
	call	024F0h		;DS7 code
	jmp	0270Dh		;DS7 code


L1E84:
	mov	c,a
	lda	$412F		;seems to contain current prog number, from 0-255, including the bank info
	ani	0C0h		;only save bank info
	ora	c		;OR in the lower part
	sta	$412F		;seems to contain current prog number, from 0-255, including the bank info
	lda	$4422		;LED row 7 shadow
	ani	020h		;check Patch Read Mode bit
	cz	02579h		;DS7 code
	jmp	L1ECC


L1E99:
	mov	a,d
	lda	$412F
	ani	0F8h
	ora	d
	sta	$412F
	mov	d,e
	mvi	e,000h
L1EA6:
	lhld	$441C		;LED row 1 shadow
	call	0DEDCh		;DS8 code, OR d and e upper nibbles into hl, write to prog select LEDs

	lda	$461A		;save area for rows 4,7 mode bits TEMBRE/PANEL/PEDAL/BEND/KB2/KB1/OUT/IN
	ani	040h		;check "Panel" bit
	jz	L1EC6

	lxi	d,04101h
	lda	$412F		;seems to contain current prog number, from 0-255, including the bank info
	ani	03Fh		;limit value to 0-63
	stax	d		;write it to 4101
	dcx	d
	mvi	a,0C0h		;status byte is 0C0h, Program change
	stax	d		;write it to 4100
	mvi	b,002h		;byte count is 2
	call	L057F		;send MIDI bytes
L1EC6:
	lda	$4422		;LED row 7 shadow
	ani	020h		;check Patch Read mode bit
	rz
L1ECC:
	lda	$412E
	ana	a
	jnz	L1EE4
	call	L0CE9		;returns the address of current patch in hl and at $4130, reads Patch if Patch Read enabled
	call	L0D1A
	call	L0EB4
	lda	$4134		;seems like index of current voice when we are accessing its RAM area (0-7)
	ana	a
	rnz
	jmp	L1EEA


L1EE4:
	call	02656h		;DS7 code
	call	L0B48
L1EEA:
	lhld	$412E
	shld	$4640
	jmp	0270Dh		;DS7 code


L1EF3:
	lda	$4133		;get mode
	cpi	003h
	rnz			;return if not mono

	mov	a,e
	mov	b,a
	cma
	mov	c,a
	lda	$4345
	ana	c
	mov	c,a
	lda	$441D		;LED row 2 shadow
	xra	e
	sta	$441D		;LED row 2 shadow
	out	05Ah
	ana	e
	mov	a,c
	jz	L1F11
	ora	b
L1F11:
	sta	$4345
	jmp	L0255


L1F17:				;handler for Mode switch
	lda	$4422		;LED row 7 shadow
	ani	010h		;check Edit bit
	cnz	02538h		;DS7 code

	lda	$441E		;LED row 3 shadow
	xri	001h		;toggle mode bit
	sta	$441E		;LED row 3 shadow
	out	05Bh		;update LED row 3

	mvi	c,008h
	ani	001h		;is Mode LED on?
	jz	0DE1Fh		;no, jump here with c=8, DS8
	mvi	c,003h
	jmp	0DE1Fh		;yes, jump here with c=3, DS8


L1F35:				;handler for "Select" switch
	lda	$441E		;LED row 3 shadow
	xra	e
	sta	$441E		;LED row 3 shadow
	out	05Bh
	mov	b,a
	ana	e
	jnz	L1F5D
	mvi	a,0FFh
	sta	$4345
	lda	$4422		;LED row 7 shadow
	ani	010h		;check Edit bit
	jz	L0255
	lhld	$4136
	xchg
	lhld	$441C		;LED row 1 shadow
	call	0DEDCh		;DS8 code, OR d and e upper nibbles into hl, write to prog select LEDs
	jmp	L0255


L1F5D:
	mov	a,b
	ani	0F3h
	mov	d,a
	call	02013h		;DS7 code
	lhld	$4341
	mov	a,l
	ana	b
	jz	L1F70
	mov	a,d
	ori	004h
	mov	d,a
L1F70:
	mov	a,h
	ana	b
	mov	a,d
	jz	L1F78
	ori	008h
L1F78:
	sta	$441E		;LED row 3 shadow
	out	05Bh
	ret


L1F7E:
	lda	$441E		;LED row 3 shadow
	ani	0F1h		;clear Select,1,2 bits
	ora	e
	mov	d,a
	jmp	L1FA0


L1F88:				;handler for "1" and "2" switches
	lda	$441E		;LED row 3 shadow
	xra	e
	mov	d,a

	lda	$461A
	ani	040h
	jz	L1FA0

	push	d
	mov	a,d
	ani	00Eh
	mov	e,a
	mvi	d,046h		;controller 70 is "voice"
	call	L0564		;sends MIDI controller, called with controller # in d, value in e
	pop	d
L1FA0:
	mov	a,d
	ani	002h
	jnz	L1FB5
	call	L1FFA
	mov	a,c
	ori	0F1h
	ana	d
	sta	$441E		;LED row 3 shadow
	out	05Bh		;update LED row 3
	jmp	L1FBF

L1FB5:
	mov	a,d
	sta	$441E		;LED row 3 shadow
	out	05Bh		;update LED row 3
	mov	e,d
	call	02031h		;DS7 code
L1FBF:
	lhld	$443F		;start of voice ram for current voice
	xchg
	lda	$441E		;LED row 3 shadow
	mov	c,a
	ani	004h		;check "1" bit
	mvi	b,000h
	jz	L1FD3
	lxi	h,0006Bh	;get byte at offset 6B into voice RAM
	dad	d
	mov	b,m		;into b reg
L1FD3:
	mov	a,c
	ani	008h		;check "2" bit 
	jz	L1FE0
	lxi	h,00072h	;get byte at offset 72 into voice RAM
	dad	d
	mov	a,m		;into acc
	ora	b
	mov	b,a		;and OR it into b reg
L1FE0:
	mov	a,c
	ani	001h		;check Mode bit
	jnz	L1FF0
				;Mode bit not set
	lda	$4422		;LED row 7 shadow
	ani	0F8h		;clear Shape Edit bits
	ora	b
	sta	$4422		;LED row 7 shadow
	ret

L1FF0:				;Mode bit is set, 
	lda	$4141		;so 4141 holds normal 4,7 bits, not mode bits
	ani	0F8h		;clear row 7 Shape edit bits
	ora	b
	sta	$4141		;update mode storage location	
	ret


L1FFA:
	call	02013h		;DS7 code
	mvi	c,000h

	.db	02Ah		;start of lhld instruction
				;two address bytes are at start of DS7
	.end
