;	Disassembled by:
;		DASMx object code disassembler
;		(c) Copyright 1996-2003   Conquest Consultants
;		Version 1.40 (Oct 18 2003)
;
;	Checksum:	B76F
;	Date:		Tue Oct 13 11:44:20 2015
;	CPU:		Intel 8080 (MCS-80/85 family)

; tasm -85 -g3 ti3ds6.asm ti3ds6.bin
; g0 is Intel Hex
; g3 selects binary

;TI3 has 60 keys (not 61), looks like 60 pb switches, and about 20 pots, plus pitch and mod wheels
;Four banks of 64 presets in EPROM, one in RAM.   Each preset occupies 32 bytes in EPROM.
;It has an arpeggiator and a sequencer as well.

;When doing table lookups in DS7, each 180h values (300h addresses) equals one octave

; 10/13/15	Initial work
; 10/14/15	Figured out RAM init scheme
; 10/16/15 	Added a few comments.  Just backing up what I have.
; 10/18/15  	Found key scan code.   Adding more comments
;		Also found switch and LED code.
; 10/19		Found LFO, identified a bunch of switches, adding LFO comments
; 10/20 	Found code that reads pot values from the front panel.
; 10/22		Using the simulator, I identified most of the pots.   Still a few unknown.
; 10/23		Looking into key assigner operation.   Found mono switch.
; 10/25		Think I found shape select switches, shape control, and tune or detune control
; 10/26 	Looking at portamento operation
; 10/27		Adding comments for switch rows 1 and 5
; 10/29 	Figured out a little about 1 and 2 selections and detune/tune pots
;		Confirmed patch read and store switches
; 10/30		Fixed some switch ID mistakes, confirmed wheels and pedal locations
; 11/2 		Simulating seq record/playback
; 11/4		Added more comments
; 11/7 		Figured out some more of the key processing code
; 11/8		Added more comments
; 11/10 	Figured out and commented envelope variables.   Looked at mono patch save
;		and load code some more.
; 11/11		Added comments.   Got simulator running on my Win7 machine.
; 12/03		Changed patch read code to use patch we point to as the starting pt if mono read
;		This seems to match the way the EPROM mono sets are placed 
;		Implemented optional 50 mSec delay at start before we access SRAM.
; 12/08		Figured out some of the portamento code.
; 12/12		Verified that fixswap is valid.
; 12/13		Working on pot scan order.   TASM32 doesn't fill gaps created using orgs.  We need to fill them.
; 12/19 	Saving this version.   It did filter every other time if wheels and pedal disabled.
; 12/19		Trying to improve on pot scanning rate.
; 12/20		More work on new pot scanning order code.

;Issues:
;	1) Poly mode re-uses voices that may still be sounding, even if there are unused voices
;	2) Freq updates to final value in portamento mode, then starts glide - is this audible?
;	3) Possible code bug at 0x0FB9
;	4) Possible code bug at L1064
;	5) Possible code bug at L149C
;	6) Change pot scan code.  Don't scan wheels or pedal if not enabled.
;	   Move other pots into their place.
;	   Put filter cutoff in place of pedal if pedal not enabled.
;	   Don't scan seq/LFO pots if not in use.
;	7) Add circuity to prevent RAM corruption on power cycling.


;	Add 50 mSec delay at start before we access RAM
	#DEFINE	STRTUPDLY

;	Disable buggy code that was changing Mono patch read starting patch number
	#DEFINE NORDALGN

;	Fix bug that was ORing prog sel bits with the wrong other row bits
	#DEFINE	FIXSWAP

;	Change voice assignment to a fixed rotation to enable long release
	#DEFINE	CHGASS

;	see if we can improve response time for some pots
	#DEFINE CHGPOTSCAN

;	remove calls to pot display debug code, since it's not enabled anyway
;	#DEFINE	POTDISPEN

;I/O addresses used:

;	050h		;out, pot select code to front panel
;	051h		;in, we read pot values at this address
;			;out kicks off pot conversion

;	052h		;same as memory address 5252 DAC low 4 bits
;	053h		;same as memory address 5253 DAC high 8 bits
;	054h		;S&H output mux channel select

;	055h		;latch with a bit for each voice, clearing the bit
;			;changes osc 1 pw to very narrow instead of 50%

;	058h		;same as memory 5058, LED row 0
;	059h		;same as memory 5059, LED row 1
;	05Ah		;same as memory 505A, LED row 2
;	05Bh		;same as memory 505B, LED row 3
;	05Ch		;same as memory 505C, LED row 4
;	05Dh		;same as memory 505D, LED row 5
;	05Eh		;same as memory 505E, LED row 6
;	05Fh		;same as memory 505F, LED row 7

; Voice timers are write-only, with their RDb signal tied high.
; We read from I/O address 68 to execute for POT debug code.

Vce1tmr0	.equ	060h	;8253 timer voice 1
Vce1tmr1	.equ	061h
Vce1tmr2	.equ	062h
Vce1tmrctl	.equ	063h

Vce2tmr0	.equ	064h	;8253 timer voice 2
Vce2tmr1	.equ	065h
Vce2tmr2	.equ	066h
Vce2tmrctl	.equ	067h

Vce3tmr0	.equ	068h	;8253 timer voice 3
Vce3tmr1	.equ	069h
Vce3tmr2	.equ	06Ah
Vce3tmrctl	.equ	06Bh

Vce4tmr0	.equ	06Ch	;8253 timer voice 4
Vce4tmr1	.equ	06Dh
Vce4tmr2	.equ	06Eh
Vce4tmrctl	.equ	06Fh

Vce5tmr0	.equ	070h	;8253 timer voice 5
Vce5tmr1	.equ	071h
Vce5tmr2	.equ	072h
Vce5tmrctl	.equ	073h

Vce6tmr0	.equ	074h	;8253 timer voice 6
Vce6tmr1	.equ	075h
Vce6tmr2	.equ	076h
Vce6tmrctl	.equ	077h

Vce7tmr0	.equ	078h	;8253 timer voice 7
Vce7tmr1	.equ	079h
Vce7tmr2	.equ	07Ah
Vce7tmrctl	.equ	07Bh

Vce8tmr0	.equ	07Ch	;8253 timer voice 8
Vce8tmr1	.equ	07Dh
Vce8tmr2	.equ	07Eh
Vce8tmrctl	.equ	07Fh

systimer0	.equ	0B0h	;8253 timer chip 8
systimer1	.equ	0B1h	;seq/arp rate
systimer2	.equ	0B2h
systimerctl	.equ	0B3h

; Also, there is some memory-mapped hw:

;Switch rows are read at memory addresses 0x50F8-50FF
;DAC seems also mapped at memory address $5252/5253.
;LED rows are also mapped at memory addresses 0x5x58-5x5F
;Timers are also mapped at 6060,6464,6868,etc
;Keyboard rows are read at memory addresses 8000-8007.   0 = key pressed	

;RAM addresses used:

spsave1L	.equ	04000h	;SP save location #1, low byte
spsave1H	.equ	04001h	;high byte
hlsave1L	.equ	04002h	;hl save location #1, low byte
hlsave1H	.equ	04003h	;high byte
hlsave2L	.equ	04004h	;hl save location #1, low byte
hlsave2H	.equ	04005h	;high byte
hlsave3L	.equ	04006h	;hl save location #2, low byte
hlsave3H	.equ	04007h	;high byte
spsave2L	.equ	04008h	;SP save location #2, low byte
spsave2H	.equ	04009h	;high byte

stack1bot	.equ	0400Ah
stack1top	.equ	040F9h	;sp is loaded with this address+1 and goes down

stack2bot	.equ	040FAh
stack2top	.equ	04159h	;sp is loaded with this address+1 and goes down

				;seems to indicate order in which voices were assigned,
				;so that oldest notes are removed first if we run out
				;last-assigned voice holds 7, oldest would be 0
				;voice pointed to by nxtvce always contains 0
				;not sure when this array is used
assordarr0	.equ	0415A	;voice 1 value
assordarr1	.equ	0415B	;voice 2 value
assordarr2	.equ	0415C	;voice 3 value
assordarr3	.equ	0415D	;voice 4 value
assordarr4	.equ	0415E	;voice 5 value
assordarr5	.equ	0415F	;voice 6 value
assordarr6	.equ	04160	;voice 7 value
assordarr7	.equ	04161	;voice 8 value

nxtvce		.equ	04162h	;index of next voice to assign (0-7)
lastvce		.equ	04163h	;init code sets this to 7, not written anywhere else
				;determines where we start searching 
				;in the table (we search backwards)
ctr16L		.equ	04164h	;low byte of a 16-bit value that code increments, but which doesn't seem to be used anywhere
ctr16H		.equ	04165h	;high byte 

				;voice key assignment array,
				;holds key assigned to each voice, keys 1-12 are lowest octave
				;value does not change if key is released, only when assignment changes
VceKey1		.equ	04166h	;voice 1
VceKey2		.equ	04167h	;voice 2
VceKey3		.equ	04168h	;voice 3
VceKey4		.equ	04169h	;voice 4
VceKey5		.equ	0416Ah	;voice 5
VceKey6		.equ	0416Bh	;voice 6
VceKey7		.equ	0416Ch	;voice 7
VceKey8		.equ	0416Dh	;voice 8

mystarr0L	.equ	04170h 	;word array start, possibly 58 entries, one for each table addr
mystarr0H	.equ	04171h
;...
mystarr57L	.equ	041E2h	;end of array
mystarr57H	.equ	041E3h

retaddsav1L	.equ	041E4h	;used to save ret addr temporarily, low byte
retaddsav1H	.equ	041E5h	;high byte

VceMask		.equ	041E6h	;used to enable only certain voices for patch updates
				;when a pot moves or some other change is made, 
				;value is only copied to voices with 1 in this mask

DCOfreqoffL	.equ	041E7h	;16-bit frequency offset, low byte includes tune pot, patch footage, and pitch wheel, if enabled
DCOfreqoffH	.equ	041E8h	;high byte, already scaled for indexing into DS7
LFOfreqamtL	.equ	041E9h	;seems like LFO 16-bit signed amt for freq mod, low byte
LFOfreqamtH	.equ	041EAh	;high byte
LFOshapeamtL	.equ	041EBh	;LFO 16-bit signed amt for shape mod (seems like DCO2 PW only), low byte
LFOshapeamtH	.equ	041ECh	;high byte
freqtempL	.equ	041EDh	;when we update DCO timer/freq this is used to temp store freq value
freqtempH	.equ	041EEh	;high byte

VCAidlelevL	.equ	041EFh	;starting value for VCA envelope attack phase, low byte
VCAidlelevH	.equ	041F0h	;high byte
FiltidlelevL	.equ	041F1h	;starting value for filter envelope attack phase, low byte
FiltidlelevH	.equ	041F2h	;high byte

LFOamplamtL	.equ	041F3h	;seems like LFO 16-bit signed amt for amplitude mod, low byte
LFOamplamtH	.equ	041F4h	;high byte		
LFOfiltamtL	.equ	041F5h	;seems like LFO 16-bit signed amt for filter mod
LFOfiltamtH	.equ	041F6h	;high byte

				;32-byte array, two 16-bit values for each voice:
vcedata10L	.equ	041F7h	;vca pedal value for voice 1, low byte
vcedata10H	.equ	041F8h	;high byte
vcedata11L	.equ	041F9h	;key # assigned to this vce * 32 if key tracking enabled, 
				;plus pedal filter mod value, if enabled, low byte
				;value persists if key is released until vce is reassigned
vcedata11H	.equ	041FAh	;high byte

vcedata20L	.equ	041FBh	;vca pedal value for voice 2, low byte
vcedata20H	.equ	041FCh	;high byte
vcedata21L	.equ	041FDh	;filter kb tracking plus pedal mod value, voice 2, low byte
vcedata21H	.equ	041FEh	;high byte
;...
vcedata80L	.equ	04213h	;voice 8
vcedata80H	.equ	04214h	;voice 8
vcedata81L	.equ	04215h	;same value for voice 8
vcedata81H	.equ	04216h	;high byte

keyflags	.equ	04217h	;D0: set when a new key release is sensed
				;D1: set when a new keypress is sensed
				;also used to indicate a switch has changed state

				;key row data array,
				;holds last value read (complemented) from hw for each row 
				;1 should mean key is down			
KeyRowDat0	.equ	04218h	;row 0 (first row)
KeyRowDat1	.equ	04219h	;1	
KeyRowDat2	.equ	0421Ah	;2
KeyRowDat3	.equ	0421Bh	;3
KeyRowDat4	.equ	0421Ch	;4
KeyRowDat5	.equ	0421Dh	;5
KeyRowDat6	.equ	0421Eh	;6
KeyRowDat7	.equ	0421Fh	;7		

				;key row change data array,
				;lower byte holds mask for any key just pressed in this row
				;upper byte holds mask for any key just released in this row
KeyPressDat0	.equ	04220h	;row 0 (first row) new key presses
KeyRelDat0	.equ	04221h	;row 0 new key releases
KeyPressDat1	.equ	04222h	;row 1 new key presses
KeyRelDat1	.equ	04223h	;row 1 new key releases
;...
KeyPressDat7	.equ	0422Eh	;row 7 new key presses
KeyRelDat7	.equ	0422Fh	;row 7 new key releases

keytemp1	.equ	04230h	;only used by keybd scan code, compl of last row read
keyprsscnt	.equ	04231h	;number of key numbers in keypressarr

spsave3L	.equ	04232h	;SP save location #3, low byte
spsave3H	.equ	04232h	;high byte

keypressarr	.equ	04234h	;array of key numbers, built from key press data
				;possibly 32 bytes allocated for this				

				;key status array:
				;key numbers start at 1, and are used to acess this
				;array, so I guess the first element would not be used
				;array of 61 bytes, one for each key (1-60) plus 0
keystat0	.equ	04255h	;this one is not used,

keystat1	.equ	04256h	;if this key is currently assigned to a voice and pressed,
keystat2	.equ	04257h	;that voice's index (0-7) will be in this array at the key's position
keystat3	.equ	04258h	;when key is released, it immediately changes to 0xFF
keystat4	.equ	04259h	
; ...
keystat59	.equ	04290h
keystat60	.equ	04291h

lpctr1		.equ	04292h	;loop ctr/temp var

bankaddrL	.equ	04293h	;seems like base address of current program bank, low byte
bankaddrH	.equ	04294h	;high byte

keyprarr0	.equ	04295h	;8-byte array that holds either new key presses, or new releases
keyprarr1	.equ	04296h	;used for processing key activity
;...
keyprarr6	.equ	0429Bh
keyprarr7	.equ	0429Ch

keyrelcnt	.equ	0429Dh	;number of key numbers in keyrelarr
keyrelarr	.equ	0429Eh	;array of key numbers, built from key release data				
				;possibly 32 bytes allocated for this	

tempstcktop	.equ	042BEh	;sometimes sp is set to this address
				;and then a call is performed

				;switch row new data array,
				;hold new complemented value, used by switch code
SwNewDat0	.equ	042BFh	;row 0 (first row)
SwNewDat1	.equ	042C0h	;1	
SwNewDat2	.equ	042C1h	;2
SwNewDat3	.equ	042C2h	;3
SwNewDat4	.equ	042C3h	;4
SwNewDat5	.equ	042C4h	;5
SwNewDat6	.equ	042C5h	;6
SwNewDat7	.equ	042C6h	;7


				;switch row last data array,
				;holds complemented last value read from hw for each row
				;1 means switch is pressed 
SwStateRow0	.equ	042C7h	;
				;D0 this maps to Sequencer rate LED, no switch
				;D1 this maps to LFO rate LED, no switch
				;D2
				;D3
				;D4 16'select
				;D5 8' select
				;D6 4' select
				;D7 2' Select

SwStateRow1	.equ	042C8h	;	
				;D0 Sequence Record
				;D1 Sequence Step
				;D2 Sequence Loop
				;D3 Playback Transpose
				;D4 Program Sel 1
				;D5 Program Sel 2
				;D6 Program Sel 3
				;D7 Program Sel 4

SwStateRow2	.equ	042C9h	;
				;D0 Select LFO Ramp Up
				;D1 Select LFO Ramp Dn
				;D2 Select LFO Triangle
				;D3 Select LFO Square
				;D4 Program Sel 5
				;D5 Program Sel 6
				;D6 Program Sel 7
				;D7 Program Sel 8

SwStateRow3	.equ	042CAh	;
				;D0 Mono
				;D1 Select
				;D2 "1"
				;D3 "2"
				;D4 Portamento Enable
				;D5 Filter Keyboard Tracking Enable
				;D6 Filter Pedal Control Enable
				;D7 VCA Pedal Control Enable

SwStateRow4	.equ	042CBh	;
				;D0 Pitch wheel control of osc pitch enable
				;D1 Pitch wheel filter cutoff mod enable
				;D2 Mod Wheel Controls LFO DCO Freq mod amt
				;D3 Mod Wheel Controls LFO Filt cutoff mod amt
				;D4 Bank A
				;D5 Bank B
				;D6 Bank C
				;D7 Bank D

SwStateRow5	.equ	042CCh	;
				;D0 Play
				;D1 Pause
				;D2 ArpUp
				;D3 ArpDn
				;D4 Program Group Sel 1
				;D5 Program Group Sel 2
				;D6 Program Group Sel 3
				;D7 Program Group Sel 4

SwStateRow6	.equ	042CDh	;
				;D0 LFO Freq Mod
				;D1 LFO Shape Mod
				;D2 LFO Filter Mod
				;D3 LFO VCA Mod
				;D4 Program Group Sel 5
				;D5 Program Group Sel 6
				;D6 Program Group Sel 7
				;D7 Program Group Sel 8

SwStateRow7	.equ	042CEh	;
				;D0 Edit Waveform Rise Time
				;D1 Edit Waveform PW
				;D2 Edit Waveform Fall Time
				;D3 Chord
				;D4 Control Panel (pots) Enable
				;D5 Patch Read Mode
				;D6 Patch Store
				;D7

;LED map is the same as the switch map

LEDrow0		.equ	042CFh	;value for LED Row 0 at I/O 058h, or 5858
LEDrow1		.equ	042D0h	;value for LED Row 1 at I/O 059h, or 5859
LEDrow2		.equ	042D1h	;value for LED Row 2 at I/O 05Ah, or 585A
LEDrow3		.equ	042D2h	;value for LED Row 3 at I/O 05Bh, or 585B
LEDrow4		.equ	042D3h	;value for LED Row 4 at I/O 05Ch, or 585C
LEDrow5		.equ	042D4h	;value for LED Row 5 at I/O 05Dh, or 585D
LEDrow6		.equ	042D5h	;value for LED Row 6 at I/O 05Eh, or 585E
LEDrow7		.equ	042D6h	;value for LED Row 7 at I/O 05Fh, or 585F

Potsel0		.equ	042D7h	;these two addresses are used to alternate between pots 0-19 (scanned slower)
Potsel1		.equ	042D8h	;and 24-26 (scanned slower)

	;These are read at a slower rate:
PotVal0		.equ	042D9h	;last value read for pot 0   port step size/rate
PotVal1		.equ	042DAh	;last value read for pot 1   Seq/arpeggiator rate
PotVal2		.equ	042DBh	;last value read for pot 2,  LFO depth
PotVal3		.equ	042DCh	;last value read for pot 3   LFO freq
PotVal4		.equ	042DDh	;last value read for pot 4,  tune control, always affects all
				;oscillators, 80H seems to be the "tuned" actual pot value
PotVal5		.equ	042DEh	;last value read for pot 5,  detune control, 
				;actual pot value=76h seems to be 0 detune 
				;changing detune pot updates value for oscs 
				;enabled by "select 1" or "select 2" combinations  
				;Unselected oscs keep old detune value.
PotVal6		.equ	042DFh	;last value read for pot 6,  VCA attack rate
PotVal7		.equ	042E0h	;last value read for pot 7,  VCA decay rate
PotVal8		.equ	042E1h	;last value read for pot 8,  shape control
PotVal9		.equ	042E2h	;last value read for pot 9,  VCA attack final level
PotVal10	.equ	042E3h	;last value read for pot 10, VCA sustain level
PotVal11	.equ	042E4h	;last value read for pot 11, VCA release rate
PotVal12	.equ	042E5h	;last value read for pot 12, Noise level
PotVal13	.equ	042E6h	;last value read for pot 13, filter attack final level
PotVal14	.equ	042E7h	;last value read for pot 14, filter sustain level
PotVal15	.equ	042E8h	;last value read for pot 15, filter idle level
PotVal16	.equ	042E9h	;last value read for pot 16, filter resonance
PotVal17	.equ	042EAh	;last value read for pot 17, filter attack
PotVal18	.equ	042EBh	;last value read for pot 18, filter decay
PotVal19	.equ	042ECh	;last value read for pot 19, filter release

PossSpare1	.equ	042EDh	;didn't find any ref
PossSpare2	.equ	042EEh	;didn't find any ref
PossSpare3	.equ	042EFh	;didn't find any ref
PossSpare4	.equ	042F0h	;didn't find any ref


	;These three pots are read at a faster rate:
PotVal24	.equ	042F1h	;last value read for pot 24, pitch wheel
PotVal25	.equ	042F2h	;last value read for pot 25, mod wheel
PotVal26	.equ	042F3h	;last value read for pot 26, foot pedal

Potpzctr	.equ	042F4h	;keeps us on the same pot, after it changes, until it
				;reads the same 16 times in a row

monokeyflg	.equ	042F5h	;should be 0 in mono mode if key assigned to voice 0 is not pressed
				;otherwise not 0

spsave4L	.equ	042F6h	;SP save location #4, low byte
spsave4H	.equ	042F7h	;high byte

pedvar1L	.equ	0430Bh	;16-bit value, low part
pedvar1H	.equ	0430Ch	;high part

codeaddr1L	.equ	04313h	;an address is written here
codeaddr1H	.equ	04314h	;and presumably jumped or returned to later

pedvar2		.equ	04316h	;8-bit value
pedvar3L	.equ	04317h	;16-bit value, low part
pedvar3H	.equ	04318h	;high part

modwhlneg	.equ	0431Dh	;mod wheel pot value, negated

pchwhfltmodL	.equ	04321h	;pitch wheel filter cutoff mod, low byte, written at 1742
pchwhfltmodH	.equ	04322h	;high byte

pedfltmodL	.equ	04323h	;pedal filter cutoff mod, low byte
pedfltmodH	.equ	04324h	;high byte

keycnt		.equ	04326h	;seems to be a count of new key presses or releases for seq

keyarr2		.equ	04328h	;array of new key presses or releases for seq as key numbers

seqvkarr0	.equ	0435Bh	;0 array of key row bits used by sequencer, 
seqvkarr1	.equ	0435Ch	;1, guessing this is the sequencer "virtual keyboard" array
seqvkarr2	.equ	0435Dh	;seems to be used for recording, maybe not for playback
seqvkarr3	.equ	0435Eh	;row 3 bits
seqvkarr4	.equ	0435Fh	;row 4 bits
seqvkarr5	.equ	04360h	;row 5 bits
seqvkarr6	.equ	04361h	;row 6 bits
seqvkarr7	.equ	04362h	;row 7 bits

osc1detuneL	.equ	0437Bh	;osc 1 detune value, low byte
osc1detuneH	.equ	0437Ch	;high byte

osc2detuneL	.equ	0437Dh	;osc 2 detune value, low byte
osc2detuneH	.equ	0437Eh	;high byte

retaddsav2L	.equ	0437Fh	;used in timer freq update code to save ret addr, low byte
retaddsav2H	.equ	04380h	;high byte

ptchftoffL	.equ	04383h	;16-bit positive freq offset due to patch octave selection, low byte
ptchftoffH	.equ	04384h	;high byte, for 16', it's 0, then we add 180h for each octave

tunoffsetL	.equ	04385h	;signed 16-bit tune pot offset value
tunoffsetH	.equ	04386h	;high byte

seqramptrL	.equ	04387h	;seq ram r/w ptr, low byte
seqramptrH	.equ	04388h	;high byte

				;two vars plus a 16-byte array related to chord mode:
				;these values were copied into vce patch offsets 21d (a) ,22d (b)
chordvar0	.equ	0438Ah	;seemed to hold the number of lowest key pressed while chord enabled	
chordvar1	.equ	0438Bh	;seemed to hold "1" after first key pressed when chord enabled
chordavce1	.equ	0438Ch	;0 in my sim
chordbvce1	.equ	0438Dh	;seemed to hold last minus lowest key numbers pressed when chord enabled
chordavce2	.equ	0438Eh	;0 in my sim
chordbvce2	.equ	0438Fh	;seemed to hold last minus lowest key numbers pressed when chord enabled
chordavce3	.equ	04390h	;0 in my sim
chordbvce3	.equ	04391h	;seemed to hold last minus lowest key numbers pressed when chord enabled
chordavce4	.equ	04392h	;0 in my sim
chordbvce4	.equ	04393h	;seemed to hold last minus lowest key numbers pressed when chord enabled
chordavce5	.equ	04394h	;0 in my sim
chordbvce5	.equ	04395h	;0 in my sim
chordavce6	.equ	04396h	;0 in my sim
chordbvce6	.equ	04397h	;0 in my sim
chordavce7	.equ	04398h	;0 in my sim
chordbvce7	.equ	04399h	;0 in my sim
chordavce8	.equ	0439Ah	;0 in my sim
chordbvce8	.equ	0439Bh	;0 in my sim


transpval	.equ	0439Ch	;sequence playback transpose value (in semi-tones, 0-60)
				;determined by lowest key currently pressed
portfrstky	.equ	0439Dh	;holds either 0 or # of lowest key pressed when "port" sw enabled
				;or first key if no keys pressed when sw is enabled
				;after first key is logged, while switch is enabled,
				;this value-lowest key pressed is used to set initial port offset		

;134-byte voice RAM area format:
;    Offset(dec)	;vce1 RAM off/addr		Function
;	000		;926/439E assigned key number times 32, low byte (written at 255 in code)
;	001		;927/439F high byte, in DS7, 180h words is an octave, 384/12 (32) is a semi-tone

;	002		;928/43A0 seems to be portamento frequency adder, counts from init offset
;	003		;929/43A1 high byte	  (neg if pitch increasing) to 0 for final pitch
;						  (written at 3EF in code)

;	004		;930/43A2 should be DCO2 PW value
;	005		;931/43A3 high byte

;	038		;964/43C4 assigned key number times 32, low byte (written at 471 in code)		
;	039		;965/43C5 high byte
		
;	040		;966/43C6 portamento step size, (written at 44E in the code)
;	041		;967/43C7 high byte

;	042		;968/43C8 seems to be portamento frequency adder, counts from init offset
;	043		;969/43C9 high byte, (written at 3E5 in code) in sim it was same as 929:8

			;VCA attack phase variables:
;	046		;972/43CC looks like VCA attack step size, 
;	047		;973/43CD high byte, added to 43CE value during attack phase
;	048		;974/43CE VCA attack phase env value, low byte, starts are value at $41EF value
;	049		;975/43CF high byte, and has 43CC added to it
;	050		;976/43D0 negation of VCA attack final level, so when this is 
;	051		;977/43D1 high byte, added to above value and we get a carry, attack is done
;	052		;978/43D2 ptr into keyarr for key assigned to this voice is copied here
;	053		;979/43D3 high byte

			;VCA decay phase variables, same format:
;	058		;984/43D8 VCA decay phase (negative) step size, this value is added to
;	059		;985/43D9 high byte, next value during decay phase
;	060		;986/43DA VCA decay phase env value, starts at attack final value
;	061		;987/43DB high byte
;	062		;988/43DC negated VCA sustain level, so when we add 43DA value to this and don't
;	063		;989/43DD high byte,                 get a cy, decay phase is finished
;	064		;990/43DE ptr into keyarr for key assigned to this voice is copied here, low byte
;	065		;991/43DF high byte

;	070		;996/43E4 ptr into keyarr for key assigned to this voice is copied here, low byte
;	071		;997/43E5 high byte

			;VCA release phase variables: same format 
;	078		;1004/43EC VCA release phase (negative) step size, low byte, added to 43EE
;	079		;1005/43ED high byte
;	080		;1006/43EE VCA release phase envelope value
;	081		;1007/43EF high byte
;	082		;1008/43F0 possibly VCA release phase final value, in my sim, this was 0, and 
;	083		;1009/43F1 high byte, starting value for attack phase was 0x800.   Strange
;	084		;1010/43F2 ptr into keyarr for key assigned to this voice is copied here, low byte
;	085		;1011/43F3 high byte

			;filter attack phase variables:
;	090		;1016/43F8 filter attack phase step size, low byte
;	091		;1017/43F9 high byte
;	092		;1018/43FA filter attack phase env value, low byte, starts are value at $41F1 value
;	093		;1019/43FB high byte, and has 43F8 added to it
;	094		;1020/43FC negation of VCA attack final level, so when this is 
;	095		;1021/43FD high byte, added to above value and we get a carry, attack is done
;	096		;1022/43FE ptr into keyarr for key assigned to this voice is copied here, low byte
;	097		;1023/43FF high byte

			;filter decay phase variables:
;	102		;1028/4404 filter decay phase (negative) step size, added to 4406
;	103		;1029/4405 high byte
;	104		;1030/4406 filter decay phase env value, starts at attack final value
;	105		;1031/4407 high byte
;	106		;1032/4408 negated filter sustain level, so when we add 4406 value to this and don't
;	107		;1033/4409 high byte,          get a cy, decay phase is finished
;	108		;1034/440A ptr into keyarr for key assigned to this voice is copied here, low byte
;	109		;1035/440B high byte

;	114		;1040/4410 ptr into keyarr for key assigned to this voice is copied here, low byte
;	115		;1041/4411 high byte

			;filter release phase variables
;	122		;1048/4418 filter release phase step size
;	123		;1049/4419 high byte
;	124		;1050/4420 filter release phase envelope value
;	125		;1051/4421 high byte
;	126		;1052/441C possibly negated filter release phase target value (idle level)
;	127		;1053/441D high byte
;	128		;1054/441E ptr into keyarr for key assigned to this voice is copied here, low byte
;	129		;1055/441F high byte


			;the RAM area for each voice is 134 bytes
;	$439E		;start of vce1 RAM area (RAM address 926dec)	
;	$4424		;start of vce2 RAM area		
;	$44AA		;start of vce3 RAM area		
;	$4530		;start of vce4 RAM area		
;	$45B6		;start of vce5 RAM area		
;	$463C		;start of vce6 RAM area		
;	$46C2		;start of vce7 RAM area		
;	$4748		;start of vce8 RAM area
;	$47CD		;end of voice RAM area

;32-byte voice patch area format:
			;pot values 0-19 are copied to 0-19 bytes for each voice
			;and then updated for voices enabled by the voice mask
			;but values for pots 1,4,5 and 8 are not copied

			;vce 1 addr
;	0		;47CE   pot 0 value, port step size/rate
	
;	1		;47CF	polyphonic portamento glide starting interval (signed)
	
;	2		;47D0   pot 2 value,  LFO depth	
;	3		;47D1   pot 3 value,  LFO freq/rate

;	4		;47D2	detune value for osc 1
;	5		;47D3   detune value for osc 2

;	6		;47D4	pot 6 value,  VCA attack rate
;	7		;47D5	pot 7 value,  VCA decay rate

;	8		;47D6	all 192 EPROM patches have 75h here, maybe not used?

;	9		;47D7   pot 9 value,  VCA attack final level
;	10		;47D8   pot 10 value, VCA sustain level
;	11		;47D9   pot 11 value, VCA release rate
;	12		;47DA   pot 12 value, Noise level
;	13		;47DB   pot 13 value, filter attack final level
;	14		;47DC   pot 14 value, filter sustain level
;	15		;47DD   pot 15 value, filter idle level
;	16		;47DE   pot 16 value, filter resonance
;	17		;47DF   pot 17 value, filter attack
;	18		;47E0   pot 18 value, filter decay
;	19		;47E1   pot 19 value, filter release

;	20		;47E2   osc 1 pw pot value
			;       D7 bits at this address are collected and ANDed with voice mask,
			;	and then written to port 055h to select wide or narrow pw
			;	writing 0 selects narrow, and since pot value is inverted right
			;	after its read, CW gets you narrow, CCW gets 50% duty 

;	21		;47E3   osc 1 chord offset value 
;	22		;47E4   osc 2 chord offset value
;	23		;47E5	EPROM patches have 41h (almost all), 11h (3 progs) or 12h (3 progs)
			;	these values are not used due to code bug, not clear what they were
			;	for as the code is so messed up I can't see what was intended
;	24		;47E6   bits 7-4 used to set 2,1,select,mono
			;	when a patch with D4 set is loaded from RAM, it's put in vce 1
			;	and the next 7 patches are loaded into the next 7 voices
			;	only one patch in the EPROM has bits in 0-3.   Maybe a typo?
;	25		;47E7   bits 7-4 used to set VCA,Filter,Shape,Freq (LFO mod dest)
;				bits 3-0 used to set Square,Tri,RmpDn,Rmpup (LFO wavefrm)
;	26		;47E8   bits 7-4 used to set 2',4',8',16' select bits
			;	bits 3,2 would OR with current pedal enables (0 in all 192 patches)
			;	bits 1,0 would set port and keytrk (all 192 have keytrk, not port) 
;	27		;47E9   osc 2 pw value 
;	28		;47EA   osc 2 fall rate value
;	29		;47EB   osc 2 rise rate value
;	30		;47EC   osc 1 rise rate value
;	31		;47ED   osc 1 fall rate value
	

;	$47CE		;start of vce 1 patch 32 bytes
;	$47EE		;start of vce 2 patch 32 bytes		
;	$480E		;start of vce 3 patch 32 bytes		
;	$482E		;start of vce 4 patch 32 bytes		
;	$484E		;start of vce 5 patch 32 bytes		
;	$486E		;start of vce 6 patch 32 bytes		
;	$488E		;start of vce 7 patch 32 bytes		
;	$48AE		;start of vce 8 patch 32 bytes
;	$48CD		;end of vce patch area

seqaddtab0L	.equ	048CEh	;start of table of addresses used by sequencer
seqaddtab0H	.equ	048CFh	;seems like the table holds 8 addresses
;...
seqaddtab7L	.equ	048DCh
seqaddtab7H	.equ	048DDh	;end of table

seqword1L	.equ	048DEh	;code writes 04FF0 here at one pt
seqword1H	.equ	048DFh	

seqword2L	.equ	048E2h	;possibly an address used by sequencer
seqword2H	.equ	048E3h	;high byte
seqword3L	.equ	048E4h	;possibly an address used by sequencer
seqword3H	.equ	048E5h	;high byte
seqbyte4	.equ	048E6h	;used as sequencer address table index

;	$48E7		;last 16-bit value we read from timer 2 at B2h, low byte
;	$48E8		;high byte (used by the sequencer, and maybe the arpeggiator)

;	$48EB		;start of sequence storage
;	$4FEF		;this seems to be the end of sequence storage

;	1796 bytes, the number of bytes per note depends on the timer value,
;	so at 4 bytes/note this would be 450 notes


	.org	00000h

L0000:
	di			;disable interrupts

	#IFDEF	STRTUPDLY
				;add delay without changing code alignment
	jmp	wt50ms		;will do first out before it jumps back
	nop
stdlyret:

	#ELSE
				;no change to original code
	mvi	a,020h		;set ctr 0 to be mode 0, high byte only
	out	0B3h

	#ENDIF

	mvi	a,0A8h		;load ctr 0
	out	0B0h

	mvi	a,0B6h		;set ctr 2 to be mode 3, low/high
	out	0B3h

	sub	a		;clear acc
	out	0B2h		;clear ctr 2
	out	0B2h
	
	lxi	h,$4000
	lxi	b,007CEh	
L0018:
	mvi	m,000h		;clear RAM from 0x4000 to 47CD (~2K)
	inx	h		;~~~ move reg to mem is 7 instead of 10 cycles
	dcx	b		;could use e reg, for instance
	mov	a,b
	ora	c
	jnz	L0018
	
	lxi	b,L1DA7		;point to 8 sets of init data at end
	lxi	d,0439Eh	;dest RAM address
	lxi	sp,L0053	;point to EPROM copy control data array
L002A:
	mvi	a,010h		;set loop ctr to 16
	sta	$4292		;save it

	pop	h		;read EPROM word, inc sp by 2
	mov	a,h
	ora	l		;is it 00? (end of data)
	jz	L06E0		;if so, do more initialization

L0035:
	dad	h		;if not, double EPROM word (same as shift left)
	jc	L003E		;this would check for MSbit set in word
	inx	d
	inx	d		;add two to RAM ptr
	jmp	L0046

L003E:
	ldax	b		;a = [bc]
	stax	d		;[de] = a
	inx	b		;bump EPROM ptr
	inx	d		;bump RAM ptr

	ldax	b		;a = [bc]
	stax	d		;[de] = a
	inx	b		;bump EPROM ptr
	inx	d		;bump RAM ptr
L0046:
	lda	$4292		;read loop ctr
	dcr	a		;dec it
	sta	$4292		;write it back out
	jnz	L0035		;go here if not 0

	jmp	L002A		;always restart loop (reloads loop ctr)

				;this data controls the copy operation
				;each word is checked 16 times
				;if msbit is 0, dest address is incremented by 2
				;if msbit is 1, two bytes of EPROM data is copied to RAM
				;after each check, control word is shifted left one
				;after 16 checks, a new control word is read from EPROM
L0053:				;34 control words should walk through 544 pairs of bytes, 
				;or 1088 (0x440) RAM locations
				;so addresses 0x439E to 0x47DD
				;8 x 134 = 1072 so we are in the right ballpark 
				;for initialization of voice RAM areas
	.dw	$1555		;0
	.dw	$6218		;1
	.dw	$6618		;2
	.dw	$6198		;3
	.dw	$62AA		;4
	.dw	$AC43		;5
	.dw	$0CC3		;6
	.dw	$0C33		;7
;L0063
	.dw	$0C55		;8
	.dw	$5588		;9
	.dw	$6198		;10
	.dw	$6186		;11
	.dw	$618A		;12
	.dw	$AAB1		;13
	.dw	$0C33		;14
	.dw	$0C30		;15
;L0073
	.dw	$CC31		;16
	.dw	$5556		;17
	.dw	$2186		;18
	.dw	$6186		;19
	.dw	$1986		;20
	.dw	$2AAA		;21
	.dw	$C430		;22
	.dw	$CC30		;23
;L0083
	.dw	$C330		;24
	.dw	$C555		;25
	.dw	$5886		;26
	.dw	$1986		;27
	.dw	$1866		;28
	.dw	$18AA		;29
	.dw	$AB10		;30
	.dw	$C330		;31
;L0093
	.dw	$C30C		;32
	.dw	$C300		;33
	.dw	$0000		;34


L0099:				;pop hl,de,bc, and ret
	pop	h
L009A:
	pop	d
	pop	b
	ret


L009D:				;read ctr 0 (set to always read high byte)
	in	0B0h		;counts down, then stops		
	rlc			;check msbit
	jc	L0099		;if set, pop 3 regs and return
	lxi	h,00002h
	dad	sp
	shld	$4008		;otherwise, store sp+2 at 4008
	jmp	L06B1		;and go here



L00AD:				;seems like we come here to jump based on code addrs table
	lxi	h,00000h
	dad	sp
	shld	$4000		;save sp at $4000

	mov	a,c		
	cpi	008h		;is c > 7?
	jp	L00EA		;if so, then it's not a 0-7 voice update
       
				;c <= 7, so it's a voice update
	lxi	h,$4163		
	mov	e,m		;get value at 4163 into e, d=0
	mvi	d,000h		;4163 holds constant 7	

	lxi	h,$415A		;pt hl to start of 8-byte 415A voice assignment table
	dad	b
	mov	b,m		;get voice number at index in c reg on entry into b 

	lxi	h,$415A		;pt hl to start of 8-byte 415A voice assignment table
	dad	d		;add 7 to it to get to last element
L00C9:
	mov	a,m		;get table byte
	cpi	0FFh		;is it 0FFh?
	jz	L00E3		;skip down if so

	cmp	b		;flags = a - b
	jm	L00E3		;skip down if b voice # > table value

	jnz	L00DB		;skip if the two values are not equal

	lda	$4163		;if they are, add 1 to the 4163 value (get 8)
	inr	a
	mov	m,a		;and write it to the table
L00DB:
	dcr	m
	jnz	L00E3

	mov	a,e
	sta	$4162		;next voice to assign?
L00E3:
	dcx	h
	dcr	e
	jp	L00C9
	mvi	b,000h

L00EA:
	lxi	h,$4170		;table in RAM
	dad	b
	dad	b		;add bc x 2 as offset

	mov	e,m		;read 16-bit value from table
	inx	h		;into de pair
	mov	d,m
	inx	h

	mov	a,d
	ora	e
	xchg			;get table ptr+2 into de, table value into hl

	jz	L0115		;jump if table value was 0000
				;de now holds orig table ptr+2
				;hl holds 0000

	sphl			;load sp from hl (table value)
	pop	h		;add 6 to sp
	pop	h
	pop	h
				;if bc contains index of a voice at this pt
				;this code will push code addr 0x02E7, then 
				;the voice index,
				;then a ptr to the RAM storage area for that voice
				;we only jump here from 38 lines down, or from above code 				
L00FD:
	lxi	h,L1CED		;table of 57 code addresses
	dad	b
	dad	b		;add bc x 2 as offset
	mov	e,m		;read low byte from table
	inx	h
	mov	d,m		;read high byte from table
	push	d		;save table 16-bit code address (in de)
	push	b		;save table index as well

	lxi	h,L1D61		;table of ptrs into voice storage areas
	dad	b
	dad	b		;add bc x 2 as offset
	mov	e,m		;read low byte from table				
	inx	h
	mov	d,m		;read high byte from table
	push	d		;save 16-bit pointer read from second table

	lhld	$4000
	sphl			;load sp from $4000 
	ret

				;we only come here from 32 lines up
				;when we come here, de holds 4170 ptr+2
				;4004 seems like a sort of stack ptr, so we are allocating
				;6 locations on it here, and setting 4170 ptr to point to it

				; bc    de     hl    sp  @4000 @4002 @4004 @4006 @4008  @41B2	
L0115:				;0021  41B4   0000  40F2  40F2  4004  40EE  4148  4148   0000
		
	lhld	$4002		;get 4004 into hl	
	sphl			;sp = 4004  
	xchg			;de = 4004, hl= 41B4   
	xthl			;4004,5 = 41B4, hl = 40EE
	xchg			;de = 40EE, hl = 4004
	lxi	h,0FFFAh	; 
	dad	d		;hl = 40E8
	xthl			;4004,5 = 40E8, hl= 41B4 
	sphl			;sp = 41B4 
	lxi	h,0FFFAh	; 
	dad	d		;hl = 40E8
	push	h		;41B2,3 = 40E8
	xchg			;de = 40E8, hl=40EE
	sphl			;sp = 40EE
	jmp	L00FD		
				;0021 ntused ntused 40EE  40F2  4004  40E8  4148  4148  40E8 

				;so bc is unchanged.
				;   hl = value that was in 4004
				;   sp = value that was in 4004
				;   de = (value that was in 4004)-6
				;   4004 = (value that was in 4004)-6
				;   (addr orig in de)-2 now holds (value that was in 4004)-6


				;in mono mode: called on keypresses with c=33, then 8 times with c=8-F
				;              also called on key releases with c=34
				;in poly mode: called on keypresses with c=33, then 1 time with c=8-F
				;              also called on key releases with c=34
L012C:
	mov	a,c		;look at c reg value
	cpi	008h		;is it >= 8?
	jp	L015D		;jump down if so

	lxi	h,$415A		;(probably) voice assign order array in RAM
	dad	b		;use bc as index
	mov	b,m		;load array byte into b reg

	lxi	h,$4163		;init sets this to 7, not written elsewhere
	mov	e,m		;get value 7 into e
	mvi	d,000h
	lxi	h,$415A		
	dad	d		;use it as an index into the same array
L0141:
	mov	a,m
	cpi	0FFh		;is the array value 0FFh?
	jz	L0158		;jump down if so

	cmp	b		;is the array value == array[c]?
	jz	L0152		;if so, set it to 0, and make this the next voice to assign

	jp	L0158		;is the array value >= array[c]?
				;if so, skip
	inr	m		;otherwise increment the array value
	jmp	L0158

L0152:
	mvi	m,000h		;this is the array element we read above, clear it
	mov	a,e		;and
	sta	$4162		;point next voice to assign to this element
L0158:
	dcx	h		;iterate over the whole 415A array
	dcr	e
	jp	L0141		;loop until e goes negative

L015D:
	lxi	h,04170h	;array of RAM pointers, should be one for each table address
	mvi	b,000h
	dad	b		;add bc to hl
	dad	b
		
	mov	e,m		;read ram ptr from array into de
	mvi	m,000h		;and clear those two locations
	inx	h
	mov	d,m
	mvi	m,000h
		
	mov	a,d
	ora	e		;or both bytes together
	jz	L0099		;if result is 0, pop hl,de,bc, and ret

	lxi	h,00000h
	dad	sp
	shld	$4000		;save sp at $4000

	lhld	$4002
	sphl			;load the sp from address 4002
				;before we came here, we saved either 4004 or 4006 at this address

	pop	h
	xchg			;load de pair from [sp]
	push	h

	lxi	h,00006h
	dad	d		;add 6 to the value we just read from [sp]

	xthl			;exchange hl with top of stack, so
				;add 6 to value originally pointed to by sp
				;store it at that address + 2
				;get value that was at that address into hl

	lxi	b,00006h
	dad	b		;add 6 to value in hl

	xchg			;save that in de

	sphl			;sp = value we read initially from 4004 or 4006
	pop	h		;load hl from RAM
	pop	b		;load bc from RAM

	shld	$416E		;save hl value at 416E

	pop	h		;load hl from RAM

	xchg			;save in de, get de into hl
	sphl		

	lhld	$416E		;restore hl we saved above

	push	d		;store de in RAM
	push	b		;store bc in RAM
	push	h		;store hl in RAM

	lxi	h,04171h	;ptr to high bytes of addresses in array
	dad	b
	dad	b		;use bc as word offset 

	mov	a,m		;read a high byte
	dcx	h		;decrement hl ptr
	ora	m		;OR low byte and high byte
	jz	L01AB		;return if 0

	xchg			;save hl in de
	lxi	h,00000h
	dad	sp		;get sp into hl
	xchg			;now sp is in de
	mov	m,e		;write sp value to memory
	inx	h
	mov	m,d

L01AB:
	lhld	$4000		;restore sp from $4000
	sphl
	jmp	L0099		;pop hl,de,bc, and ret


L01B2:
	lxi	h,$4004		;write #4004 to address 4002
	shld	$4002
	jmp	L00AD		;jump to table dispatch code

L01BB:
	lxi	h,$4006		;write #4006 to address 4002
	shld	$4002
	jmp	L00AD		;jump to table dispatch code


L01C4:				;pt hl to 4004, store #$4004 at $4002, jump to L012C
	lxi	h,$4004
	shld	$4002
	jmp	L012C

L01CD:				;pt hl to 4006, store #$4006 at $4002, jump to L012C
	lxi	h,$4006
	shld	$4002
	jmp	L012C


				;key assigner code
				;called when a new key was pressed, 
				;called from several places, with
				;number of new key (1-60) in e
				;also called when sequencer is pressing keys
L01D6:				
	mov	a,e
	ana	a
	rz			;return if key number is 0

	pop	h		;get return address off of the stack
	shld	$41E4		;save it here

	lda	$42D2		;value for LED Row3
	ani	001h		;check D0 (mono mode)
	jz	L0216		;skip down if not mono mode

				;this is mono mode code:
	lxi	h,00100h	;init assignment order array to 0,1,2,3,4,5,6,7
	shld	$415A
	lxi	h,00302h
	shld	$415C
	lxi	h,00504h
	shld	$415E
	lxi	h,00706h
	shld	$4160

	sub	a
	sta	$4162		;clear next voice to assign

	lda	$4166		;read first element in voice key assignments array
	mov	c,a
	mvi	b,000h		;and use it as an index into

	lxi	h,04255h	;key status array
	dad	b
	mov	a,m		;read array element
	cpi	0FFh		;is key pointed to by voice 0 either not pressed, or not assigned?

	jnz	LL0213		;if not, save its voice assignment at 42F5
	mvi	a,000h		
LL0213:
	sta	$42F5		;otherwise, save 0 at 42F5
				;end of mono mode code
L0216:
	mvi	b,000h		;~~~probably this was supposed to be d, but maybe not nec
	lxi	h,04255h	;key status array starting address
	dad	d		;~~~strange that b was cleared, but they are using de pair as index
	mov	a,m		;in the simulator, d was 0 at this pt
	cpi	0FFh		;is new key either not pressed, or not assigned?
	jz	L0228		;if so, jump

	ani	007h		;otherwise, get voice index it's assigned to
	mov	c,a		;save it in c
	jmp	L022C

L0228:
	lda	$4162		;get next voice to assign
	mov	c,a		;in c

L022C:
	mvi	b,000h
	lxi	h,04255h	;key status array starting address
	dad	d		;add new key number offset
	mov	m,c		;put voice index into key array

	lxi	h,$4166		;voice key assignments array start addr
	dad	b		;add voice index
	mov	m,e		;assign key to this voice

	lxi	h,L1D61		;table of starting addresses for each voice's RAM area
	dad	b
	dad	b		;add voice index twice to form table word address
	xchg			;swap de and hl

	lda	$42D0		;value for LED Row 1
	ani	008h		;check playback transpose bit
	jz	L024B		;skip if not enabled

	lda	$439C		;get playback transpose value
	add	l
	mov	l,a		;add it to key number

L024B:				;multiply key number times 32
	dad	h		;x2
	dad	h		;x4
	dad	h		;x8
	dad	h		;x16
	dad	h		;x32
	xchg			;swap de and hl
	mov	a,m
	inx	h		;read 16-bit address from the table into hl (set up before)
	mov	h,m
	mov	l,a		
				;store de at this address (first value in voice RAM area)
	mov	m,e		;this was writing out assigned key number times 32 
	inx	h		;probably part of the frequency lookup address
	mov	m,d

	lda	$42D2		;value for LED Row3
	rlc
	rlc			;check D6, filter cutoff pedal mod enab
	lxi	h,00000h
	jnc	L0266		;skip if not set		
	lhld	$4323		;read pedal filter cutoff mod value
L0266:
	rlc			;check D5, filter keyboard tracking enable
	jc	L026D		;if set, skip
	lxi	d,00000h	;otherwise clear de
L026D:
	dad	d		;if kbtrk enab, d still holds key # times 32 from above
	xchg
				;second element of a table of 
	lxi	h,041F9h	;values based on voice key numbers
	dad	b
	dad	b
	dad	b
	dad	b		;groups of 4 bytes
	mov	m,e
	inx	h		;16-bit value for each voice is just key number * 32
	mov	m,d		;write it out (maybe this is keybd tracking value for this voice?)
				;also has pedal filter cutoff mod value value in it

	call	L01B2		;uses fcn table index, 0-7, ends up at L00AD and uses table
				;of code addresses and table of RAM ptrs
				;four calls per voice, so 32 total, then the pattern repeats

	mov	a,c		;3, for example
	adi	008h
	mov	c,a
	call	L01B2		;use index + 8, 8-15
	mov	a,c		;0Bh for example
	add	a
	mov	c,a
	call	L01B2		;double index, 16h for example
	inx	b		
	call	L01B2		;incr index, 17h, for example

	lda	$42D2		;value for LED Row3
	ani	001h		;check D0 (Mono)
	jz	L02A2		;skip if not mono

	lda	$4162		;next voice to assign
	ana	a		;is it 0?
	lda	$4166		;voice key assignments array first element (voice 1)
	mov	e,a
	mvi	d,000h
	jnz	L0228		;assign same key to all 8 voices, probably

L02A2:
	lhld	$41E4		;retrieve return address that we saved before
	pchl			;move hl to pc and jump to it




				;called a bunch of places
				;called when a key is released
L02A6:				
	mov	a,e		;number of key that was released
	ana	a
	rm			;return if key number > 127

	sui	03Eh		;or if key number >= 62dec
	rp

	lxi	h,04255h	;key status array starting address
	dad	d		;looks like d is cleared before we come here, e holds key #
	mov	a,m		;get key status
	mvi	m,0FFh		;mark it as released

	#IFDEF	CHGASS

	ret

	.FILL	($02E7-*),00h	;fill space with NOPs

	#ELSE

	ana	a
	rm			;return if it was already 0xFF

	cpi	008h		;or if it's assigned voice was >= 8
	rp

	mov	c,a		;get index of voice that this key was assigned to into c
	mvi	b,000h
	lxi	h,$415A		;assignment order array starting address
	dad	b
	mov	b,m		;get assignment order value for voice we are freeing up into b

	lxi	h,$4163		;contains constant 7 in simulation, this determines where we start
	mov	e,m		;searching in the array.   If it's 7, we start at the end.
	mvi	d,000h		;(we walk backwards through the array)
	lxi	h,$415A		;assignment order array starting address
	dad	d

L02CA:
	mov	a,m		;get assignment order array value
	cpi	0FFh
	jz	L02E1		;if it's 0xFF, move to next value

	cmp	b		;is it same as value we read from voice we are freeing up?
	jz	L02DB		;if so, set this element to 0

	jp	L02E1		;if it's not 0xFF, and not the voice we just freed up,
	inr	m		;increment it's array value
	jmp	L02E1		;and continue looping

L02DB:
	mvi	m,000h		;make voice that was used for note that was released 0 in 
				;assignment order array
	mov	a,e		;and make its voice the next one to assign
	sta	$4162		;~~~ we want to change this
L02E1:
	dcx	h
	dcr	e
	jp	L02CA		;loop through array
	ret			;then return

	#ENDIF



				;#0-7 in table of code addrs, one jmp to here as well
				;this seems to update the voice timer load values
L02E7:				;and writes out to a S&H channel			
	lxi	h,00000h	 
	dad	sp
	shld	$4000		;save sp at $4000

	xchg			;swap de/hl
	sphl			;load sp with de reg contents on entry (was 439E for voice 1 in sim, or start of voice ram)

	lhld	$41E7		;16-bit frequency offset, includes tune pot, patch footage sel, and pitch wheel, if enabled
	pop	d		;get 16-bit [entry de++], this was 04A0 for C3 key
	dad	d		;add it to hl
	pop	d		;get 16-bit [entry de++], this should be portamento adder		
	dad	d		;add it to hl 
	xchg			;move sum into de

	lhld	$41E9		;seems like LFO 16-bit signed amt for freq mod
	dad	d		;add in sum
	shld	$41ED		;save it at 41ED, for later use as index into DS7, 
				;after another offset is added
	lxi	h,L0305		;get return address into hl
	jmp	L0345		;jump

L0305:
	lxi	h,L030B		;get return address into hl
	jmp	L0345		;jump

L030B:				;this updates the DCO 2 PW counters (timer 1)
	pop	h		;this should be DCO2 PW value
	dad	d
	xchg
	lxi	h,00180h	;this is one octave, or 50% PW value as starting pt
	dad	d
	xchg
	lhld	$41EB		;LFO 16-bit signed amt for shape mod (seems like DCO2 PW only)
	dad	d
	mov	a,h
	ani	0F0h		;is hl > 0x0FFF?
	jz	L0329		;no, leave it alone
	jp	L0326
	lxi	h,00000h	;if it's negative, set it to 0
	jmp	L0329
L0326:
	lxi	h,00FFFh	;and if it's positive, set it to max value
				;DS7 contains 8K bytes, or 4K words, so 0FFFh would
				;be the highest valid index
L0329:
	lxi	d,02000h	;starting address of DS7
	dad	h		;double hl first, since DS7 contains words
	dad	d		;then add starting address to it

	mov	c,m
	inx	h
	mov	b,m		;read a 16-bit value from DS7 lookup EPROM into bc

	pop	h
	mov	m,c
	mov	m,b		;this writes to timer ctr 1

	pop	h
	shld	$5252		;write a different 16-bit value to the DAC registers

	pop	psw
	out	054h		;strobe all 12-bits into DAC, select S&H channel for this CV

	lhld	$4000		;restore SP from $4000
	sphl

	call	L0099		;pop hl,de,bc, and ret
	jmp	L02E7



L0345:
	shld	$437F		;save (return?) address at $437F

	lhld	$41ED		;load hl pair, this is frequency value we calculated above
	pop	d		;then we add offset to it, this was 0 in simulation
	dad	d		;add top of stack to hl
	mov	a,h
	ani	0F0h
	jz	L035F		;clip value to 12 bits
	jp	L035C
	lxi	h,00000h
	jmp	L035F
L035C:
	lxi	h,00FFFh
L035F:
	lxi	d,02000h	;start of DS7 EPROM
	xchg			;now hl=2000
	dad	d		;add in frequency value (doubled to form word index)
	dad	d
	mov	c,m		;this was reading from DS7, exp lookup EPROM, low byte
	inx	h
	mov	b,m		;this was reading from DS7, exp lookup EPROM, high byte

	pop	h		;this must be the address of the timer
	mov	m,c		;this writes values to voice timers 0 and 2 to set DCO 1 and 2 freqs, low
	mov	m,b		;then high

	pop	h		;read another value
	dad	d

	mvi	a,07Fh		;subtract 0x0D7F from hl pair
	sub	l
	mov	l,a
	mvi	a,00Dh
	sbb	h
	mov	h,a

	jp	L037B
	lxi	h,00000h	;if result is neg, set it to 0
L037B:
	lxi	b,02000h	;start of DS7 EPROM
	dad	h		;double hl value
	dad	b		;then add it to 0x2000

	mov	a,m
	inx	h
	mov	h,m
	mov	l,a		;read 16-bit value into hl from DS7
	shld	$5252		;write it to the DAC registers

	pop	psw
	out	054h		;strobe all 12 bits into DAC and enable S&H channel for this CV

	pop	h
	dad	d

	mvi	a,07Fh		;subtract 0x0D7F from hl pair
	sub	l
	mov	l,a
	mvi	a,00Dh
	sbb	h
	mov	h,a

	jp	LL039A
	lxi	h,00000h	;if result is neg, set it to 0
LL039A:
	dad	h		;double hl value
	dad	b		;then add it to 0x2000

	mov	a,m
	inx	h
	mov	h,m
	mov	l,a		;read 16-bit value into hl from DS7
	shld	$5252		;write it to the DAC registers

	pop	psw
	out	054h		;strobe all 12 bits into DAC and enable S&H channel for this CV

	lhld	$437F
	pchl			;jump to address we saved earlier



L03AA:				;#8-15 in table of code addrs, no other ref 
	lda	$47CE		;should be pot 0 setting (portamento step size)
	cpi	008h
	jnc	L03B8		
				;if pot value is 0-7,
	call	L047E		;clear portamento adder for all 8 voices, only uses hl
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C

L03B8:
	lda	$47CF		;some sort of key interval value, not per voice
	ana	a		;loaded with the patch
	jz	L03C5

	call	L03FD		;this seems to calculate portamento step size
	jmp	L03D7

L03C5:
	lda	$47E6		;should be offset 24 into vce 1 patch area
	ani	010h		;check Mono bit
	cz	L01C4		;if not mono, pt hl to 4004, store #$4004 at $4002, jump to L012C

	call	L0460

	lda	$42F5		;only written in key assigner code
	ana	a
	cz	L01C4		;if 0, pt hl to 4004, store #$4004 at $4002, jump to L012C

L03D7:
	lxi	h,00000h
	dad	sp
	shld	$4000		;save sp at $4000

				;de was 43C6 here
	xchg
	sphl			;load sp with former de value (prde)

	pop	d		;de = [43C7:6], (portamento adder value)
	pop	h		;hl = [43C9:8]
	dad	d		;add de to hl
	mov	a,d
	xra	h		;xor the two top bytes to see if the sign bit changed
	push	h		;save sum at [43C9:8]
	pop	d		;get same sum into de

	pop	h		;load sp from [43CB:A], had address 0x43A2 in it
				;so push d would write to 43A1 and 43A0, (offsets 3 and 2)
				;so this was using an address that's permanently stored in 
				;the voice buffer RAM area.   This address and another appear
				;in the init data array at the end of the EPROM.
	sphl

	jm	L03EF
	lxi	d,00000h
L03EF:
	push	d		;this wrote "final" portamento adder value, at offset 3:2 in voice RAM

	lhld	$4000
	sphl			;load sp from $4000

	cp	L01C4		;if pos, pt hl to 4004, store #$4004 at $4002, jump to L012C
	call	L0099		;pop hl,de,bc, and ret
	jmp	L03D7



L03FD:				;this seems to calculate portamento step size
	lxi	h,00000h	;only called in one place
	dad	sp
	shld	$4000		;save sp at $4000

	xchg
	sphl			;get de into sp

	pop	h
	pop	h
	pop	h
	pop	h		;sp = sp + 8

	lda	$47CF		;offset 1 in voice #1 patch area, some sort of key interval value, either from the patch, 
				;or set when portamento switch is enabled
	ana	a
	mvi	h,000h
	jp	L0415
	mvi	h,0FFh		;sign extend interval value to 16 bits, could use dcr h here
L0415:
	mov	l,a

	dad	h		;multiply signed interval value value times 32
	dad	h
	dad	h
	dad	h
	dad	h
L041B:
	push	h		;save result temporarily

	lda	$47CE		;this should be pot 0 value
	mvi	h,000h
	mov	l,a
	dad	h
	dad	h
	dad	h		;multiply pot 0 value by 8

	lxi	d,00000h
	dad	d		;~~~this seems totally useless!

	pop	d		;retrieve interval value times 32 we saved before
	mov	a,d	
	ana	a		;check sign of this value
	jp	L0437

	mov	a,e		;make it positive if it was negative		
	cma
	mov	e,a		;de = -de
	mov	a,d
	cma
	mov	d,a
	inx	d

	cma			;get orig d value before negation back into acc
L0437:
	dad	d		;add |interval*32| to hl (pot 0 value times 8)
	dad	h		;double hl value, since EPROM values are words
	lxi	d,02001h	;start of DS7 EPROM plus 1 (we only want high byte)
	dad	d
	mov	e,m		;read from EPROM after adding offset
	mvi	d,000h
	inx	d

	xra	d		;~~~ this seems odd, DS7 values are unsigned, FFFFh down to 0 as address increases
	jm	L044C		;I guess it works.   If interval is positive and we are in the first roughly 180h words
				;of the EPROM, the value read will be negative, so we will invert it 

	mov	a,e		
	cma
	mov	e,a		;de = -de
	mov	a,d
	cma
	mov	d,a
	inx	d
L044C:
	dcx	sp		;sp = sp - 2
	dcx	sp
	push	d		;this was updating portamento step size

	lhld	$4000
	lxi	d,0FFFCh
	dad	d
	sphl			;sp = [$4000]-4

	pop	h
	lxi	d,00004h
	dad	d
	push	h
	pop	d
	pop	b
	ret



L0460:
	lxi	h,00000h
	dad	sp
	shld	$4000
	xchg
	sphl
	xchg
	pop	h
	sphl
	pop	h
	xchg
	sphl
	pop	h
	pop	h
	push	d
	mov	a,l
	sub	e
	mov	l,a
	mov	a,h
	sbb	d
	mov	h,a
	pop	d
	pop	d
	pop	d
	jmp	L041B


				;clears the same  value for all 8 voices
L047E:				;this is 16-bit value at offset 2,3 into voice RAM buffer			
	lxi	h,00000h	;seems to be the portamento adder for each voice	
	shld	$43A0
	shld	$4426
	shld	$44AC
	shld	$4532
	shld	$45B8
	shld	$463E
	shld	$46C4
	shld	$474A
	ret


				;#16-31 in table of code addrs, no other ref
				;this code seems to set up some values mixed in
				;with the VCA and filter envelope parameters
				;it's not the actual envelope code
				;in the simulator, it doesn't get called
L049A:				;for envelope updates			
	lxi	h,00000h	
	dad	sp
	shld	$4000		;save sp on entry at $4000

	xchg			;get entry de into hl (ptr to env gen values for this voice)
	sphl			;and into sp
	xchg			;put regs back

	mov	a,c		;c would be table index, or 16-31
	rrc			;even values are for VCA env gen, odd are filter
	lhld	$41EF		;so this var would be used for the VCA
	jnc	L04AF
	lhld	$41F1		;and this one for the filter 

L04AF:
	inx	sp
	inx	sp		;add 2 to sp
	xthl			;save hl value at top of stack location

	lxi	h,$4166		;voice key assignments array start
	mov	a,c		;c would be table index, or 16-31
	rrc			;now a = 8-F
	ani	007h		;make it 0-7
	mov	c,a
	dad	b		;add bc to get table element for this voice
	mov	c,m		;into c reg

	lxi	h,04255h	;key status array starting address
	dad	b		;form ptr to key assigned to this voice
	mov	b,h
	mov	c,l		;and save it in bc

	lxi	h,00006h
	dad	sp		;sp = sp + 6
	sphl

	push	b

	lxi	h,0000Eh
	dad	sp		;sp = sp + 14
	sphl

	push	b

	lxi	h,00008h
	dad	sp		;sp = sp + 8
	sphl

	push	b		

	lxi	h,00010h
	dad	sp		;sp = sp + 16
	sphl

	push	b		;write keyarr value to four locations in voice RAM, for later use

	lhld	$4000		;restore sp from entry
	sphl
	call	L0099		;pop hl,de,bc, and ret, possibly return here later
L04E1:				;just one place jumps here (at 0x0540)
	lxi	h,00000h
	dad	sp
	shld	$4000		;save sp at $4000

	xchg			
	sphl			;get de into sp, 43CC at one pt

	pop	h		;get VCA step size?
	pop	d		;maybe the VCA env current value?
	mov	a,h
	dad	d		;add step to value
	push	h		;seems like this was updating VCA envelope value

	pop	d		;get value we just wrote into de
	pop	h
	dad	d
	xra	h
	pop	h
	rp
	mov	a,m
	ana	a
	rm
	pop	h		;sp = sp+2

L04F9:				;two places jump here
	lxi	h,041D7h	;offset 103 in 4170 array
	dad	b
	dad	b
	mov	a,m		;read l value
	inx	h
	mov	h,m		;read h value
	mov	l,a
	dad	d
	xchg

	lhld	$41F3		;seems like LFO 16-bit signed amt for amplitude mod
	mov	a,c		;this same code must be used to write out both filter cut cv
				;and VCA envelope cv, so here we are figuring out which one it is
	rrc
	jnc	L050F		;jump if it's VCA (c reg lsbit = 0)

	lhld	$41F5		;seems like LFO 16-bit signed amt for filter mod
L050F:
	dad	d
	mov	a,h
	ani	0F0h		;hl > FFF?
	jz	L0522

	jp	L051F	
	lxi	h,00080h	;if so and neg, set it to min value
	jmp	L0522

L051F:
	lxi	h,00FFFh	;if so and pos, set it to max value
L0522:
	dad	h		;add de to hl pair

	mvi	a,0FEh		;now subtract 0x03FFE from hl pair
	sub	l
	mov	l,a
	mvi	a,03Fh
	sbb	h
	mov	h,a
		
	mov	a,m		;read memory pointed to by hl pair

	sui	027h		;subtract 0039h from it
	out	052h		;write out DAC low 4 bits?

	inx	h
	mov	a,m		;read next byte
	sbi	000h		;propagate any borrow
	out	053h		;write out DAC upper 8 bits?

	pop	psw
	out	054h		;enable S&H channel for this CV?
L0539:
	lhld	$4000
	sphl
	call	L0099		;pop hl,de,bc, and ret
	jmp	L04E1


L0543:
	lxi	h,00000h
	dad	sp
	shld	$4000
	xchg
	sphl
	pop	h
	mov	a,m
	ana	a
	pop	d
	rm
	pop	h
	lxi	h,041D7h	;offset 103 into 4170 array of words
	dad	b
	dad	b
	mov	a,m
	inx	h
	mov	h,m
	mov	l,a
	dad	d
	xchg

	lhld	$41F3		;seems like LFO 16-bit signed amt for amplitude mod
	mov	a,c		;this same code must be used to write out both filter cut cv
	rrc			;and VCA envelope cv, so here we are figuring out which one it is
	jnc	L0568
	lhld	$41F5		;seems like LFO 16-bit signed amt for filter mod
L0568:
	dad	d
	mov	a,h
	ani	0F0h		;hl > FFF?
	jz	L057B
	jp	L0578
	lxi	h,00080h	;if so and neg, set it to min value
	jmp	L057B

L0578:
	lxi	h,00FFFh	;if so and pos, set it to max value
L057B:
	dad	h		;add d to hl pair

	mvi	a,0FEh		;subtract 0x03FFE from hl pair
	sub	l
	mov	l,a
	mvi	a,03Fh
	sbb	h
	mov	h,a

	mov	a,m		;read value pointed to by hl pair, this was accessing DS7

	sui	027h		;subtract 0x0039 from it
	out	052h		;write to DAC low 4 bits?
	inx	h
	mov	a,m		;read next byte, this was accessing DS7
	sbi	000h		;propagate cy
	out	053h		;write to DAC upper 8 bits?

	pop	psw
	out	054h		;enable S&H channel for this CV?
L0592:
	lhld	$4000
	sphl
	call	L0099		;pop hl,de,bc, and ret
	jmp	L0543


L059C:				;this address in vce RAM init table at end
	jp	L05BB
	lxi	h,00006h
	dad	sp
	sphl
	pop	h
	mov	a,d
	dad	d
	xra	h
	jm	L05B3
	lxi	h,0FFF8h
	dad	sp
	sphl
	jmp	L05CA

L05B3:
	lxi	h,0000Ch
	dad	sp
	sphl
	jmp	L0606

L05BB:
	lxi	h,0FFFAh
	dad	sp
	sphl
	pop	d

	mov	a,d
	cma
	mov	d,a		;de = -de
	mov	a,e
	cma
	mov	e,a
	inx	d

	pop	h
	pop	h
L05CA:
	pop	h
	pop	h
	pop	h
	push	d
L05CE:
	lxi	h,0FFFEh
	dad	sp
	xchg
	lhld	$4000
	lxi	sp,0FFFCh
	dad	sp
	sphl
	push	d
	jmp	L0539


L05DF:				;this address in vce RAM init table at end
	jm	L04F9		;this is not dead code
	lxi	h,0FFFAh
	dad	sp
	sphl
	pop	d

	mov	a,d
	cma
	mov	d,a		;de = -de
	mov	a,e
	cma
	mov	e,a
	inx	d

	lxi	h,0000Ah
	dad	sp
	sphl
	push	d
	lxi	h,0FFFEh
	dad	sp
	xchg
	lhld	$4000
	lxi	sp,0FFFCh
	dad	sp
	sphl
	push	d
	jmp	L0592

L0606:
	pop	h
	pop	h
	pop	h
	push	d
	jmp	L05CE

	jm	L04F9
	lxi	h,0FFFAh
	dad	sp
	sphl
	pop	d
	lxi	h,03FFEh
	dad	d
	dad	d
	dcx	sp
	dcx	sp
	mov	e,m
	inx	h
	mov	d,m
	lxi	h,0FFD9h
	dad	d
	push	h
	lhld	$4000
	sphl
	mov	a,c
	ani	00Fh
	rar
	mov	c,a
	jc	L0684

	lxi	h,$4166		;voice key assignments array start
	dad	b
	mov	e,m		;get key number for voice # in c
	mvi	m,000h		;clear that voice's key #
	mvi	d,000h

	lxi	h,04255h	;key status array starting address
	dad	d
	mvi	m,0FFh		;set that key's status to 0FFh

	push	b		;save bc
	mov	a,c
	add	a		;voice index * 2
	add	a		;voice index * 4 
	mov	c,a		;put it into b and c
	mov	b,a

	lxi	h,06303h
	dad	b		;hl=6303, 6707, 6B0B, etc, ctl reg of voice timer chips
	mvi	d,036h		;this sets ctr 0 to mode 3, sq wave rate gen
	mvi	e,0B4h		;this sets ctr 2 to mode 2, rate generator

	lda	$42D2		;value for LED Row3
	rrc
	rrc
	jnc	L0662		;check D1, "select", skip if not set

	rrc
	jc	L065C		;and D2, "1"

	mvi	d,03Ah		;this sets ctr 0 to mode 5, "hw triggered strobe"
L065C:
	rrc
	jc	L0662		;and D3, "2"
	mvi	e,0BAh		;this sets ctr 2 to mode 5, "hw triggered strobe"
L0662:
	mvi	m,072h		;this sets ctr 1 to mode 1, "one shot"
	mov	m,e
	mov	m,d
	pop	b
	jmp	L0684


L066A:
	lxi	h,00000h
	dad	sp
	shld	$4000		;store the sp at $4000

	lxi	h,00002h
	dad	d		;add 2 to de pair
	sphl			;move result into sp
	pop	h
	pop	psw
	pop	psw		;add 6 to sp
	pop	psw
	shld	$5252		;write out to the DAC

	pop	psw
	out	054h		;enable S&H channel for this CV?

	lhld	$4000
	sphl			;restore the sp from $4000
L0684:
	call	L0099		;pop hl,de,bc, and ret
	jmp	L066A


L068A:
	lhld	$4164		;read 16-bit value
	inx	h		;incr it
	shld	$4164		;and write it back out
				;can't find any other reference to this

	lhld	$4004
	sphl
	call	L0099		;pop hl,de,bc, and ret


L0698:				;#35 in table of code addrs
	in	0B0h		;read ctr 0 (always high byte)
	rlc
	jnc	L06B1		;if count is below $8000, jump

	lhld	$4008
	sphl
	jmp	L009A


L06A5:				;#36 in table of code addrs, one jump to here (at startup)
	lhld	$4006
	shld	$4008

L06AB:
	in	0B0h		;read ctr 0 (we always read high byte)
	rlc
	jc	L06AB		;wait for ctr to get below 8000h
				;code seems to spend a lot of time in this loop, waiting for
				;the counter to timeout
L06B1:
	mvi	a,020h		;set ctr 0 to mode 0, most sig byte only
	out	0B3h

	mvi	a,0D8h
	out	0B0h		;write to ctr 0 high byte

	mvi	a,080h
	out	0B3h		;latch ctr 2 value

	in	0B2h		;read ctr 2 low byte
	mov	c,a		
	in	0B2h		;read ctr 2 high byte and discard
		
	mov	a,c		
	ani	080h		;save msbit of low byte?
	rlc			;rotate D7 into D0 and cy
	mov	d,a
		
	lda	$42CF		;value for LED Row 0
	ani	0FEh		;clear D0 (Sequencer Rate LED)
	ora	d		;OR d lsbit into 42CF value
	sta	$42CF
	out	058h		;and write it out

	lda	$47DA		;this would be voice 1 patch value at offset #12, starting at 0
	mov	h,a		;not loading l at all

	mvi	a,0C0h
	shld	$5252		;write hl out to the DAC
				;probably just h value is used
 
	out	054h		;send out 0C0h to 54 (enables Noise level S&H, same one for all voices)
	jmp	L068A


				;continuation of init code
				;startup code jumps here after copying
L06E0:				;8 sets of voice data from EPROM to RAM			
	lxi	h,$415A
	mvi	b,008h
	mvi	a,000h
L06E7:
	mov	m,a		;write 0-7 to 415A-4161 array
	inr	a
	inx	h
	dcr	b
	jnz	L06E7

	dcr	a
	inx	h
	mov	m,a		;write 7 to addr 4163

	lxi	h,04255h	;key status array starting address
	mvi	b,03Dh		;loop ctr = 61
L06F6:
	mvi	m,0FFh		;~~~ mov m,r is 7 instead of 10 cycles
	inx	h
	dcr	b
	jnz	L06F6

	mvi	a,0FFh		;enable all 8 voices in
	sta	$41E6		;voice mask

	lxi	sp,04FFFh	;set stack ptr to ram start + 4K bytes

	call	L1A19		;this must be some sort of sequencer init

	lxi	h,040FAh
	shld	$4004		;write #40FA to 4004 address (probably used to load sp at some pt)
 
	lxi	h,$415A		;write #415A to 4006 address (probably used to load sp at some pt)
	shld	$4006

	lxi	b,00023h	;think this will execute routine #35 in code table
	call	L01B2

	lxi	b,00024h	;think this will execute routine #36 in code table
	call	L01BB

	lxi	b,00025h	;think this will execute routine #37 in code table
	call	L01B2

	lxi	b,00026h	;think this will execute routine #38 in code table
	call	L01BB

	lxi	b,00027h	;think this will execute routine #39 in code table
	call	L01BB		;pot conversion code

	lxi	h,00800h
	shld	$41EF		;save 0x800 at $41EF (seems like VCA envelope idle level)

	lxi	h,00000h
	shld	$41F1		;save 0x000 at $41F1 (seems like filter envelope idle level)
	
				;init 8 voice timer chips
	mvi	a,036h		;ctr 0 in mode 3, rd/wr low then high		
	out	063h		
	out	067h
	out	06Bh
	out	06Fh
	out	073h
	out	077h
	out	07Bh
	out	07Fh
	
	mvi	a,0B4h		;ctr 2 in mode 2, rd/wr low then high
	out	063h
	out	067h
	out	06Bh
	out	06Fh
	out	073h
	out	077h
	out	07Bh
	out	07Fh
	
	mvi	a,072h		;ctr 1 in mode 1, rd/wr low then high
	out	063h
	out	067h
	out	06Bh
	out	06Fh
	out	073h
	out	077h
	out	07Bh
	out	07Fh
	
	mvi	a,010h		;set prog sel to "1"
	sta	$42D0		;value for LED Row 1
	out	059h		;out

	sta	$42CC		;sw row 5 complemented states
				;that may set prog grp sel to "1"
	out	05Dh		;out to LEDs

	mvi	a,020h		;turn on "Patch Read Mode" LED
	sta	$42D6		;update LED row 7
	out	05Fh		;out

	mvi	a,080h		;select Bank D (lowest EPROM bank)
	sta	$42D3		;value for LED Row 4
	out	05Ch		;out

	lxi	b,00031h	;think this will execute routine #49 in code table
	call	L01BB		;row 5 switch press handler

	jmp	L06A5


				;#37 in table of code addrs, one jump to here
L0797:				;this is the key scan code			
	sub	a		;clear acc
	sta	$4217		;clear key flags
	lxi	h,0421Fh	;pt to end of byte key row state array starting at 0x4218
	lxi	d,08007h	;keyboard columns are read at 8000-8007, 8000 reads the
				;lowest key of every 8-key group, 8001 is the next higher key, etc
	lxi	b,0422Fh	;pt to end of key change word data array starting at 0x4220
L07A4:
	ldax	d		;read keyboard column data
	cma			;complement to make it active high
	sta	$4230		;store complement of value we read here
	xra	m		;compare to last value we read from this row
	jnz	L07B9		;if any key has changed, jump

	stax	b		;write 16-bit 0000 to b change array value
	dcx	b
	stax	b
	dcx	b
L07B1:
	dcx	h
	dcr	e		;dec loop ctr, hw address
	jp	L07A4
	jmp	L07E2

	
L07B9:				;we jump here if a key has changed state
	ana	m		;AND xor with previous state, that would get us releases
	stax	b		;upper byte in change array is releases
	jz	L07C6		;skip if no releases in this row

	lda	$4217		;set D1 flag on release
	ori	002h
	sta	$4217
L07C6:
	dcx	b		
	lda	$4230		;get complement of value we read
	cma			;pressed keys are active low now (unpressed are 1's)
				;in memory, pressed were 1's
	ora	m		;1's either were pressed before or are unpressed now
				;so 0's were not pressed before and are pressed now				
	cma			;1's were not pressed before and are pressed now			
	ana	a		;set flags
	stax	b		;and store this in lower byte of change array
	jz	L07DA		;skip if no new presses in this row

	lda	$4217		;D0 flag is set to indicate key press
	ori	001h
	sta	$4217
L07DA:
	dcx	b
	lda	$4230		;get complemented column value we saved before
	mov	m,a		;save it in key row state array		
	jmp	L07B1		;loop through all 8 rows


	
				;OK, now we have key flags to indicate if anything changed,
				;and we have key change array loaded with masks for each row
L07E2:				;that indicate any keys that have been pressed or released
	lda	$4217		;check flags
	ani	001h		;any new keys pressed?
	jz	L07F0		;if not, skip

	lxi	b,00021h
	call	L01B2		;call table fcn #33

L07F0:
	lda	$4217		
	ani	002h		;any new keys released?
	jz	L07FE

	lxi	b,00022h	;yes, call table fcn #34
	call	L01B2

L07FE:				;no keys pressed or released, so we are outta here
	call	L0099		;pop hl,de,bc, and ret
	jmp	L0797



				;#33 in table of code addrs, no other ref
L0804:				;called for new key presses				
	lxi	h,00000h
	dad	sp
	shld	$4232		;save sp at $4232

	xchg			;get de value into sp
	sphl			;sp probably points to address 4254 now

	lda	$42D6		;value for LED row 7
	ani	008h		;check bit 3 (chord mode?)
	cnz	L1B11		;if enabled, call this routine

	lda	$42D2		;value for LED Row3
	ani	010h		;is portamento enabled?
	cnz	L1BC8		;if enabled, call this routine, which finds lowest key currently pressed,
				;and either stores it at 439D, or if 439D is not 0, stores 439D value-low key 
				;at voice patch offset 1

	lda	$42D0		;value for LED Row 1
	ani	008h		;check playback transpose bit
	jz	L083A		;skip if not enabled

	lxi	b,00038h
	call	L01BB		;call table fcn #56

LL082B:
	lxi	h,04231h
	mvi	m,000h

	lhld	$4232		;retrieve sp we saved earlier
	sphl

	lxi	b,00021h	;set bc to 33d (that's us)
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C

L083A:
	call	L17E3
	jc	LL082B

	lxi	h,04231h
	mvi	m,000h

	lxi	d,04234h
	lxi	b,04220h	;source starting addr
	call	L08AB		;copy 8 key press bytes into array at 4295, 
				;then jump to 086C which build keypress array
	mvi	a,040h
	call	L197F

	lxi	h,04231h	;get key press count 
	lxi	d,04234h	;point to key press array
L0859:
	ldax	d
	push	h
	push	d
	mov	e,a		;get number of pressed key into de
	mvi	d,000h
	call	L01D6		;call key assigner code
	pop	d
	pop	h
	inx	d
	dcr	m
	jnz	L0859
	jmp	LL082B


				;looks for 1 bits in array at bc, and generates key numbers (1-60)
				;for them which are placed in array at de, and value
				;at hl is incremented for each key added
				;
				;called from four places:
				;1) bc = 4295, which holds new key presses for each row
				;   hl = 4231 and byte at that address was just cleared
				;   de = 4234

				;2) bc = 4295, which holds new key releases for each row
				;   hl = 429D and byte at that address was just cleared
				;   de = 429E
		
				;3) bc = 4218 array that holds compl last value read from hw for each key row
				;   hl = 4326 and byte at that address was just cleared
				;   de = 4328

				;4) bc = 435B array that holds sequencer virtual keyboard data
				;   hl = 4326 and byte at that address was just cleared
				;   de = 4328
L086C:			
	mvi	a,008h		;outer loop ctr = 8 (8 key rows)
	sta	$4292		;save it

	push	b		;save orig bc value

	mov	c,m		;get c from [hl]
	mvi	b,000h

	xchg
	dad	b		;add {00,[hl]} to de
	xchg

	pop	b		;restore orig bc value		

L0879:				;outer loop start
	ldax	b		;get byte at bc (source array) addr
	ana	a
	jz	L089F		;if it's 0, skip to next row

	push	b		;if not, save bc value

	mvi	b,007h		;inner loop ctr = 7 (bit pos)

L0881:				;inner loop start
	add	a		;shift row byte left
	jnc	L0897		;if msbit was not set, skip to next inner lp value

	push	psw		;save acc

	mov	a,b		;get bit pos
	add	a
	add	a
	add	a		;times 8, since there are 8 rows and keys are arranged vertically
	adi	009h		;add 9 to it, so 65,57,49,41,33,25,17,9
	mov	c,a		;save result in c

	lda	$4292		;get outer loop ctr (8-1)
	sub	c		;subtract above result from it

	cma
	inr	a		;negate that value

	stax	d		;and save it in de array
	inx	d
	inr	m		;increment [hl] value

	pop	psw		;restore acc

L0897:
	jz	L089E
	dcr	b
	jp	L0881		;loop

L089E:
	pop	b		;restore bc value we saved above

L089F:
	inx	b
	lda	$4292		;get outer loop ctr
	dcr	a		;dec it
	sta	$4292		;save
	rz			;return if 0
	jmp	L0879		;otherwise, loop



				;this copies 8 key press or key release bytes
				;hl = 429D if we are processing key releases
				;     4231 if we are processing key presses
				;
				;de = 429E if we are processing key releases
				;     4234 if we are processing key presses 
L08AB:				;one for each row, into a byte array at 4295
				;on entry, bc points to source		
	push	d		;save de and hl for the next routine		
	push	h

	lxi	d,04295h	;dest addr
	mvi	h,008h		;loop ctr = 8
L08B2:
	ldax	b		;copy byte at [bc]
	stax	d		;to [de]
	inx	b		;bump source addr twice
	inx	b
	inx	d		;and dest addr once

	dcr	h		;dec lp ctr
	jnz	L08B2

	pop	h
	pop	d
	lxi	b,04295h	;point to dest array
	jmp	L086C		;build key # list at de for keys w/bit set in row array at bc, cnt at hl




				;#34 in table of code addrs, no other ref
L08C3:				;we call this if a new key is released		
	lxi	h,00000h
	dad	sp
	shld	$4000		;save sp at $4000

	xchg			;and load sp from de
	sphl			

	lda	$42D0		;value for LED Row 1
	ani	008h		;check playback transpose bit
	jz	L08E3		;if not enabled, skip

L08D4:
	lxi	h,0429Dh
	mvi	m,000h		;clear byte at 429D

	lhld	$4000
	sphl			;restore sp that we saved

	lxi	b,00022h	;load bc with 34d (that's us!)
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C

L08E3:
	call	L17E3

	lxi	h,0429Dh	;clear byte at 429D
	mvi	m,000h

	lxi	d,0429Eh
	lxi	b,04221h	;source starting addr	
	call	L08AB		;copy 8 key release bytes into array at 4295, 
				;then jump to 086C which populate key release array
	sub	a
	call	L197F

	lxi	h,0429Dh	;get key release count
	lxi	b,0429Eh	;point to key release array of key numbers
	mvi	d,000h
L0900:
	push	h
	push	b
	ldax	b
	mov	e,a		;get key release number into acc
	call	L02A6		;call key release routine
	pop	b
	pop	h
	inx	b
	dcr	m		;decrement key release count
	jnz	L0900		;and loop

	jmp	L08D4



				;#38 in table of code addrs, one jump to here	
L0911:				;switch/LED code		
	mvi	a,000h
	sta	$4217		;clear key/switch flags

	lxi	b,050F8h	;the switches are read at 50F8-50FF
	lxi	d,042BFh	;switch row complemented new value array
	lxi	h,042C7h	;switch row complemented prev value
L091F:
	ldax	b		;read one switch row from hw (0 = pressed)
	cma			;complement it
	cmp	m		;complare to complemented prev value
	jz	L092B		;if no change, jump
				;if change, 
	stax	d		;save complemented switch row value in array
	mvi	a,0FFh
	sta	$4217		;write 0xFF to 4217 to indicate something changed
L092B:
	inx	h		;bump ptrs
	inx	d
	inr	c
	jnz	L091F		;read with c value = F8-FF (8 rows of switches!)

	lda	$4217		;OK, we're done, did anything change?
	ana	a
	jz	L099C		;if not, we're out of here

	mvi	a,008h		;but if so, then...
	lxi	b,042BFh	;switches complemented new value array
	lxi	d,$42CF		;LED states array start
	lxi	h,042C7h	;switch row complemented prev value array
L0943:
	push	psw		;save acc (loop ctr)
	ldax	b		;read complemented new value
	cma			;complement it, so unpressed switches bits will be 1
	ora	m		;OR with complemented prev value (1=pressed sw)
	cma			;complement again, to get only switches that are newly pressed

	xchg			;ptr to LEDs for this row into hl			
	xra	m		;flip LED's if switch is pressed
	mov	m,a		;update LED state
	xchg			;LED states ptr back in de

	ldax	b		;write complemented new value
	mov	m,a		;to complemented prev value 		

	inx	b		;bump our ptrs
	inx	d
	inx	h
	pop	psw		;restore lp ctr
	dcr	a		;dec it
	jnz	L0943

	lxi	b,$42CF		;LED states array start
	lxi	d,042BFh	;switches complemented new value array
	lxi	h,L09A2		;table of 8 bytes

	mvi	a,008h		;loop ctr
L0961:
	push	psw		;save ctr

	ldax	b		;read LED states for this row
	ana	m		;AND it with mask for this row from table
				;this will force off a few LEDs
	stax	b		;store the result back in LED states array

	xchg			;swap de and hl
	ldax	d		;read table byte again
	cma			;complement it
	ana	m		;AND it with the complemented switches value byte
				;this will clear all but a few of the switch value bits to 0
	mov	m,a		;update the complemented switches value byte

	ldax	b		;read LED states for this row
	ora	m		;OR it with the complemented switches value byte
	stax	b		;this will set LED in pos disabled by mask if sw is pressed
	xchg

	inx	b		;bump ptrs
	inx	d
	inx	h

	pop	psw		;restore loop ctr
	dcr	a		;dec it
	jnz	L0961		;loop

	mvi	b,008h
	lxi	h,$42CF		;LED states array start
	lxi	d,05858h	;mem address for LED output row 0
L097E:
	mov	a,m		;read LED row data
	stax	d		;write it to the hw
	inx	h
	inx	d
	dcr	b
	jnz	L097E		;loop

	lxi	b,0002Bh	;start with fcn #43
L0989:
	lxi	h,0429Ch	;0429C + 2B = 42C7, complemented previous value array addr
	dad	b
	mov	a,m		;get array value
	ana	a		;set flags
	inx	b		;start with fcn #44		
	jz	L0996		;if no switches pressed in this row, skip
	call	L01BB		;call fcn based on row with switches pressed
L0996:
	mov	a,c
	cpi	033h		;fcn #51, so we may call fcns 44,45,46,47,48,49,50,and 51
	jnz	L0989
L099C:
	call	L009D
	jmp	L0911

L09A2:
	.db	0FFh		;0 some sort of mask for each LED row
	.db	0FDh		;1 or switch row  (D1 here is Seq step, which is momentary)
	.db	0FFh		;2
	.db	0FFh		;3
	.db	0FFh		;4
	.db	0FFh		;5
	.db	0FFh		;6
	.db	03Fh		;7


				
L09AA:				;#39 in table of code addrs, no other ref				
	lxi	h,0131Ah	;store 0x1A at 42D7, 0x13 at 42D8
	shld	$42D7		;this is set up to read three pots more often,
				;and 20 at a slower rate
				;the fast ones are the two wheels and the pedal input
				;there are 20 pots in the main controls area
L09B0:
	lda	$42D7
	out	050h		;out, select potentiometer to convert
	out	051h		;out, kick off A->D conversion sequence

	call	L009D		;execute main code, then return here later

	lxi	h,042D9h	;pot values array start
	lda	$42D7		;get pot select code (0-13h,18-1Ah)
	mov	e,a		;into e
	mvi	d,000h		;clear d
	dad	d		;add de to array start

	in	051h		;in, read pot value from hw
	mov	b,a		;save value in b
	sub	m		;a = a - m, compare to previous value read
	jnc	LL09CD		;if a > m, jump
	cma			;difference was negative, so			
	inr	a		;negate it
LL09CD:
	cpi	002h		;flags = |a| - 2
	jnc	L09E6		;if |difference| is >= 2, jump

	lda	$42F4		;|difference| is < 2
	ana	a		;has ctr counted down to 0?
	jz	LL09E0		;yes, advance to next pot
	dcr	a		
	sta	$42F4		;no, decrement counter		

	jmp	L09B0		;loop

LL09E0:
	#IFDEF CHGPOTSCAN
		call	nextpot		;select next pot to scan
	#ELSE
		call	L0D18		;decrement 42D7 value, then swap bytes at 42D7,8
	#ENDIF

	jmp	L09B0		;loop

L09E6:				;some pot moved 2 or more counts
	mvi	a,010h		;set 42F4 to 16, we stay on this pot until we read the same
	sta	$42F4		;value 16 times in a row (it stops moving for 180 mSec)
	mov	m,b		;update pot value in memory to new value we read

	lda	$42D6		;value for LED row 7
	ani	010h		;if D4 not set (cp enable bit)
	jz	L09B0		;don't process pot result
				;so even wheels are shut off by this	

	mov	a,e
	cpi	014h		;is pot select code > 20?
	jp	L0A2F		;if so, skip down

	lxi	b,00028h
	cpi	001h
	jnz	L0A0B
L0A02:				;if it's pot #1 (seq rate), call table fcn #40
	call	L01BB

	#IFDEF	POTDISPEN
		call	L0A3E		;call debug pot value display code
	#ENDIF

	jmp	L09B0		;and loop

L0A0B:				;pot sel code is < 20, and not 1
	lxi	b,00029h
	cpi	004h		;if it's pot #4 (tune pot), call table fcn #41
	jz	L0A02

	lxi	b,0002Ah
	cpi	005h		;if it's pot #5 (de-tune pot), call table fcn #42
	jz	L0A02

	lxi	b,0002Bh
	cpi	008h		;if it's pot #8 (shape adjust), call table fcn #43
	jz	L0A02

	call	L0A87		;update this pot's value in patch RAM of voices enabled by voice mask
				;the three pots that are read faster are not copied for each voice
	call	L0AAA		;calls code to convert pots to vce RAM values, once for each voice

	#IFDEF	POTDISPEN
		call	L0A3E		;call debug pot value display code
	#ENDIF

	jmp	L09B0		;and loop

L0A2F:
	mvi	a,01Ch		
	add	e		;add 28 to pot select code
	mov	c,a
	mvi	b,000h		;call table fcn 0?
	call	L01B2

	#IFDEF	POTDISPEN
		call	L0A3E		;call debug pot value display code
	#ENDIF

	jmp	L09B0		;and loop


	#IFNDEF	POTDISPEN
				;keep code from moving
				;somehow just using .org doesn't work, maybe because we are
				;generating a binary output
	.FILL	($0A3E-$),000h

	#ENDIF

				;this looks like debug code
				;it seems to display pot select on Prog Grp LED's in binary
				;and pot value on Prog Sel LED's in binary
L0A3E:				
	in	068h
;	in	070h
	ani	001h		;check D0
	rnz			;return if it's not 0

	lda	$42D7
	mov	c,a		;$42D7 holds pot select code
	ani	00Fh
	rrc
	rrc
	rrc
	rrc
	mov	b,a
	lda	$42D4		;value for LED Row 5
	ani	00Fh
	ora	b
	out	05Dh		;out
	mov	a,c
	ani	0F0h
	mov	b,a

	lda	$42D5		;value for LED Row 6
	ani	00Fh
	ora	b
	out	05Eh		;out

	mvi	b,000h
	lxi	h,042D9h	;pot values array starting address
	dad	b
	mov	a,m		;read value
	cma			;complement it
	mov	c,a		;move to c

	ani	00Fh		;take low 4 bits
	rrc
	rrc
	rrc
	rrc			;shift into high bits
	mov	b,a		;move into b

	lda	$42D0		;value for LED Row 1
	ani	00Fh		;clear top 4 bits of var
	ora	b		;OR in pot value complemented low 4 bits
	out	059h		;out

	mov	a,c		;now take high 4 bits
	ani	0F0h
	mov	b,a		;move to b

	lda	$42D1		;value for LED Row 2
	ani	00Fh
	ora	b
	out	05Ah		;out

	ret


				;update this pot's value for voices enabled by
L0A87:				;41E6 mask.  pot values are complemented				 
	lda	$42D7		;get pot select code
	mov	c,a
	mvi	b,000h
	lxi	h,042D9h	;pot values array
	dad	b		;add offset into array
	mov	a,m		;get pot value
	cma
	mov	d,a		;complement it, and put it in d

	lxi	h,$47CE		;voice 1 patch storage addr 
	dad	b		;add pot select code offset

	lxi	b,00020h	;offset to get to the next voice's patch storage

	lda	$41E6		;voice mask
L0A9E:
	ani	0FFh
	rz			;return when mask is 0
	rar
	jnc	L0AA6
	mov	m,d		;update this pot value in any voice that
				;has its bit set in the voice mask
L0AA6:
	dad	b
	jmp	L0A9E		;loop until mask is all 0's



L0AAA:				;calls code to convert pots to vce RAM values, once for each voice
	lxi	h,00000h
	dad	sp
	shld	$4000		;save SP at $4000

	lxi	sp,042BEh	;possibly just a place for a small temporary stack

	lxi	h,00000h
	lxi	b,00020h

	mvi	a,0FFh		;init mask
L0ABC:
	ani	0FFh		;exit when mask is 0
	jz	L0AC9
	rar			;rotate mask into cy
	cc	L0B27		;call if cy set
	dad	b		;add 20h to hl each time
	jmp	L0ABC		;loop

L0AC9:
	call	L15DB
	call	L047E
	call	L0AD7		;update osc 1 pw control bit for all 8 voices

	lhld	$4000		;restore sp from $4000
	sphl
	ret


				;only called from 8 lines up
				;updates 50% / narrow osc 1 pw bit for all 8 voices
				;based on current osc 1 pw pot setting
				;~~~we may want to invert the bit
				;osc 2 pw is widest with pot turned fully cw
				;osc 1 pw is wide with pot turned ccw, 
				;but changing this would affect the EPROM patches
L0AD7:				
	lxi	h,047E2h	;voice patch offset 20
	lxi	b,00020h
	lxi	d,00008h	;clr d, loop ctr in e

L0AE0:
	mov	a,m		;read voice patch offset 20
	add	a		;shift left, maybe set cy

	mov	a,d
	rar			;rotate cy into d reg msbit
	mov	d,a		;and shift d right one

	dad	b		;add 32 to hl to get to same value 
	dcr	e		;in next voice
	jnz	L0AE0		;loop

				;so d now holds D7 at offset 20 in each voice's patch memory

	lda	$41E6		;get voice mask
	ana	d		;AND it with d voice info
	out	055h		;and send it out
	ret


				;convert pot envelope level setting to a 16-bit value
				;and store it in voice RAM area
				;called with index of pot to convert in bc
				;dest offset in voice RAM for result in de
L0AF1:
	dad	b		;add bc to hl
	mov	l,m		;read pot value from voice patch memory into l
				;read offsets 9 (VCA att final level)
				;             D (filter att final level)
				;             A (VCA sustain level)
				;	      E (filter sustain level)
				;	      F (filter idle level)
	mvi	h,000h
	dad	h		;x2
	dad	h		;x4
	dad	h		;x8
	dad	h		;x16

	mov	a,h
	cma
	mov	h,a		;hl = -hl
	mov	a,l
	cma
	mov	l,a
	inx	h

L0B00:
	xchg			;swap de/hl
				;so de holds level value based on patch level setting

	mov	a,c		;voice number (0-7) in upper 3 bits of c?
	rlc			;not thru cy
	rlc
	rlc
	ani	007h		;vce # in low 3 bits of acc
	push	b		;save bc pair
	lxi	b,00086h	;the size of RAM area for each voice
L0B0B:
	dcr	a
	jm	L0B13
	dad	b		;add 86h to hl in a loop
	jmp	L0B0B

L0B13:
	mov	m,e		;store de level value at address we computed (in voice RAM area)
	inx	h
	mov	m,d
	pop	b		;restore bc pair
	ret


				;used to read voice patch values
				;only called three places, all in one routine
L0B18:				;load hl with (a==0) ? 0000 : {00,[47CE+bc+de+a]}
	ana	a		;set flags
	lxi	h,00000h
	rz			;return if acc = 0
	lxi	d,$47CE
	mov	l,a		;acc was not 0
	dad	b		;add in bc
	dad	d		;add in de
	mov	l,m		;get memory byte into l, was reading from patch voice patch memory
				;read offsets 6 (VCA att),          9 (VCA att final level),
				;            17 (filter att),      13 (filter att final level)
				;            15 (filter idle level),
				;             7 (VCA decay),       10 (VCA sustain), 9 again
				;	     18 (filter decay),    14 (filter sustain level), 13 again
				;	     11 (VCA release)      10,
				;	     19 (filter release),  15, 14
				;
	mvi	h,000h		;and clear h
	ret


				;this routine seems to convert pot values into more
L0B27:				;usable values, and store them in voice RAM area
	push	psw		;Envelope levels are converted one way,
	push	b		;rate values use a different call
	push	h		;when called, hl holds 20h times voice number
	pop	b		;get hl into bc
	push	b

	lxi	d,043D0h	;offset 32h into voice 1 RAM area (dest)
	lxi	h,047D7h	;address of pot 9 in vce 1 patch area, VCA attack final level
	call	L0AF1		;reads a pot level value, converts it, and saves it

	lxi	d,043FCh	;offset 5Eh into voice 1 RAM area (dest)
	lxi	h,047DBh	;address of pot 13 in vce 1 patch area, filter attack final level
	call	L0AF1		;reads a pot level value, converts it, and saves it

	lxi	d,043DCh	;offset 3Eh into voice 1 RAM area (dest)
	lxi	h,047D8h	;address of pot 10 in vce 1 patch area, VCA sustain level
	call	L0AF1		;reads a pot level value, converts it, and saves it

	xchg

	mov	a,h
	cma
	mov	h,a		;hl = -hl
	mov	a,l
	cma
	mov	l,a
	inx	h

	lxi	d,043E6h	;offset 48h into voice 1 RAM area
	call	L0B00

	lxi	d,04408h	;offset 6Ah into voice 1 RAM area (dest)
	lxi	h,047DCh	;address of pot 14 in vce 1 patch area, filter sustain level
	call	L0AF1		;reads a pot level value, converts it, and saves it

	xchg

	mov	a,h
	cma
	mov	h,a		;hl = -hl
	mov	a,l
	cma
	mov	l,a
	inx	h

	lxi	d,04412h	;offset 74h into voice 1 RAM area
	call	L0B00

	lxi	d,0441Ch	;offset 7Eh into voice 1 RAM area (dest)
	lxi	h,047DDh	;address of pot 15 in vce 1 patch area, filter idle level
	call	L0AF1		;reads a pot level value, converts it, and saves it

	mov	a,d
	cma
	mov	d,a		;de = -de
	mov	a,e
	cma
	mov	e,a
	inx	d

	xchg
	shld	$41F1		;seems like filter env idle level

	lxi	d,043F0h	;offset 52h into voice 1 RAM area
	lxi	h,00000h
	call	L0B00

	lxi	d,00009h	;9: VCA att final level
	lxi	h,043CCh	;offset 2Eh into voice 1 RAM area
	mvi	a,006h		;pot 6 is VCA attack
	call	L0CD0		;subtract two levels and store the difference?
				;maybe computing the step size for this interval?

	lxi	d,00F0Dh	;15:filter idle level, 13: filter att final level
	lxi	h,043F8h	;offset 5Ah into voice 1 RAM area
	mvi	a,011h		;pot 17 is filter attack
	call	L0CD0

	lxi	d,0090Ah	;9:VCA att final level, 10: VCA sustain level 
	lxi	h,043D8h	;offset 3Ah into voice 1 RAM area
	mvi	a,007h		;pot 7 is VCA decay
	call	L0CD0

	lxi	d,00D0Eh	;13: filter att final level, 14: filter sustain level	
	lxi	h,04404h	;offset 66h into voice 1 RAM area
	mvi	a,012h		;pot 18 is filter decay
	call	L0CD0

	lxi	d,00A00h	;10: VCA sustain level 
	lxi	h,043ECh	;offset 4Eh into voice 1 RAM area
	mvi	a,00Bh		;pot 11 is VCA release
	call	L0CD0

	lxi	d,00E0Fh	;14: filter sustain level, 15:filter idle level
	lxi	h,04418h	;offset 7Ah into voice 1 RAM area
	mvi	a,013h		;pot 19 must be filter release
	call	L0CD0

	lxi	h,047DEh	;voice patch offset 16, this pot controls noise level cv 
	dad	b
	mov	d,m
	mvi	e,000h
	lxi	h,043BEh
	shld	$4375
	call	L0CFE

	lxi	h,047D2h	;point to detune value for osc 1
	dad	b		;add offset to get to this voice
	mov	a,m		;read osc 1 detune value

	inx	h
	mov	d,m		;and read osc 2 detune value as well

	call	L0C93		;sub acc from 80h, sign ext to 16 bits, then divide by 8, rslt in hl
	shld	$437B		;osc 1 detune value

	mov	a,d
	call	L0C93		;sub acc from 80h, sign ext to 16 bits, then divide by 8, rslt in hl
	shld	$437D		;osc 2 detune value

				;guessing this is where the two chord values are used
	lxi	h,047E3h	;voice patch offset 21	
	dad	b
	mov	e,m		;voice patch offset 21		
	inx	h
	mov	l,m		;voice patch offset 22
	mvi	d,000h
	mvi	h,000h
	dad	h
	dad	h
	dad	h
	dad	h
	dad	h		;multiply hl value by 32 to get semi-tone
	xchg			;swap de and hl
	dad	h
	dad	h
	dad	h
	dad	h
	dad	h		;multiply hl value by 32 to get semi-tone
	push	h
	lhld	$437D		;osc 2 detune value
	dad	d
	xthl
	xchg
	lhld	$437B		;osc 1 detune value
	dad	d
	pop	d
	xchg
	shld	$437D
	xchg
	shld	$437B

	lxi	h,047E9h	;osc 2 pw value
	dad	b		;add offset to get to this voice
	mvi	a,003h
	call	L0CA6
	xchg
	lhld	$437D
	push	h
	xchg
	mvi	a,002h
	call	L0CA6
	lhld	$437B
	push	h

	mov	a,c		;vce # in upper 3 bits
	rlc
	rlc
	rlc
	ani	007h		;vce # in low 3 bits

	lxi	d,00086h	;size of RAM buffer for each voice
	lxi	h,043A2h	;should be address of DCO2 PW 16-bit value
L0C3D:
	dcr	a
	jm	L0C45
	dad	d		;add 86h to hl in loop to get to current voice's RAM buffer
	jmp	L0C3D

L0C45:
	mvi	a,007h		;loop ctr = 7
L0C47:
	pop	d		;this loop reads 7 words using the sp, and writes them to
	mov	m,e		;seven locations in the voice RAM buffer, spaced 4 addresses apart
	inx	h
	mov	m,d		;save de at computed address

	inx	h		;hl = hl + 3
	inx	h
	inx	h
	dcr	a
	jnz	L0C47		;loop

	lda	$47E8		;vce 1 patch offset 26, bits 7-4 used to set 2',4',8',16' select bits
	lxi	h,00000h
	lxi	b,00180h
	rrc
	rrc
	rrc
	rrc			;get them in low 4 bits
L0C5F:
	ani	00Fh
	jz	L0C6C
	rar
	jc	L0C6C		;if 16', we don't add anything, otherwise add 180h each time
	dad	b		;so 384 (180h) must correspond to one octave in DS7
	jmp	L0C5F

L0C6C:
	shld	$4383		;save freq adder due to patch octave selection at 4383
	xchg
	lhld	$4385		;tune pot signed 16-bit offset value
	dad	d

	lda	$42D3		;value for LED Row 4
	ani	001h		;is pitch wheel control of osc pitch enabled?
	jz	L0C8C

	xchg			;move hl into de

	lda	$431E
	mov	l,a
	mvi	h,0FFh		;load hl with new value

	lda	$42F1		;possibly pot 24 value
	mov	c,a
	mvi	b,000h		;and bc with another value

	dad	b		;add bc to hl
	dad	h		;double that result
	dad	d		;and add in original hl value		
L0C8C:
	shld	$41E7		;16-bit frequency offset, includes tune pot, patch footage sel, and pitch wheel, if enabled
	pop	h
	pop	b
	pop	psw
	ret


				;sub acc from 80h, sign ext to 16 bits, then divide by 8, rslt in hl
L0C93:				;called in two places
	cma			;complement acc
	sui	080h		;and subtract 80h from it
	ani	0F8h		;clear low 3 bits
	mvi	h,000h
	jp	L0CA1
	mvi	h,0FFh
	ori	007h
L0CA1:
	rrc
	rrc
	rrc
	mov	l,a
	ret


				;called with hl pointing to a value in voice patch (offsets 27,28,29)
L0CA6:
	dcr	a		;decrement a
	rm			;if it was 0, or 81-FFh return
	mov	e,m		;read first patch value into e
			
	inx	h		;point to next value
	mvi	d,000h
	xchg			;put {00,valueread} into h, next address into de
	dad	h		;multiply value read times 8
	dad	h
	dad	h
	xthl			;exchange this with [sp],[sp+1]
	push	h		;push the tos value
	xchg
	jmp	L0CA6		;loop until acc is 0


L0CB6:				;only called from 30 lines down
	dad	h		;x2
	dad	h		;x4
	dad	h		;x8
	dad	h		;x16
	xchg			;swap de/hl
			
	lxi	h,02000h	;start of exponential lookup EPROM

	dad	d
	dad	d
	mov	a,m
	inx	h
	mov	h,m
	mov	l,a		;load hl with memory value

	sub	a		;clear acc
	dad	h
	adc	a
	dad	h
	adc	a
	dad	h
	adc	a
	dad	h
	adc	a
	mov	l,h
	mov	h,a
	ret


				;best guess is that this computes an envelope step size
				;based on starting and final values, and rate pot setting
L0CD0:				;and writes it to all 8 voice RAM areas	
	shld	$4375		;save hl 
	xchg
	shld	$4377		;save de value here
	call	L0B18		;load hl with (a==0) ? 0000 : {00,[47CE+bc+de+a]}
				;read voice patch values
	call	L0CB6
	shld	$4379

	lda	$4377		;get saved e value
	call	L0B18		;load hl with (a==0) ? 0000 : {00,[47CE+bc+de+a]}
				;read voice patch values
	push	h

	lda	$4378		;get saved d value
	call	L0B18		;load hl with (a==0) ? 0000 : {00,[47CE+bc+de+a]}
				;read voice patch values
	pop	d
	mov	a,e
	sub	l
	lhld	$4379
	xchg
	jnc	L0CFE

	mov	a,d		
	cma
	mov	d,a		;de = -de
	mov	a,e
	cma
	mov	e,a
	inx	d

L0CFE:
	push	d		;save de value

	lhld	$4375		;restore hl voice RAM buffer address we saved on entry
	mov	a,c		;voice # in top 3 bits
	rlc
	rlc
	rlc
	ani	007h		;voice # in low 3 bits
	lxi	d,00086h	;size of RAM buffer for each voice
L0D0B:
	dcr	a
	jm	L0D13
	dad	d		;add 86h to hl pair in a loop to get to correct voice RAM buffer
	jmp	L0D0B

L0D13:
	pop	d		;restore de value

	mov	m,e
	inx	h
	mov	m,d		;save de at computed address
				;this was writing to VCA attack rate value (among others)
	ret


				;walk through pot select values in two ranges, 0-19 and 24-26
				;and we alternate between them, so that 3 pots are read much more
				;often than the others
L0D18:
	lhld	$42D7		;read 16 bit value
	mov	a,l
	ana	a		;is l=0?
	jnz	L0D22
	mvi	l,014h		;yes, set it to 20
L0D22:				
	cpi	018h		;is l=24?
	jnz	L0D29
	mvi	l,01Bh		;yes, set it to 27
L0D29:
	dcr	l		;l=1A, 13, or just l-1
	mov	a,l
	mov	l,h
	mov	h,a		;swap h and l
	shld	$42D7		;write it back out
	ret



L0D31:				;table fcn #40, called to process pot # 1
	lda	$42DA		;pot 1 value (seq and arp rate)
	cma
	mov	l,a		;complement it, and move into l
	mvi	h,000h
	dad	h		;double hl
	dad	h		;x4
	dad	h		;x8
	dad	h		;x16

	lxi	d,02000h	;~~~why is this two operations?
	dad	d		;anyway, we are doing a lookup in exp table EPROM D7
	lxi	d,00FFEh
	dad	d

	mvi	a,076h
	out	0B3h		;set ctr 1 to be mode 3, low byte then high byte

	mov	a,m
	out	0B1h		;update ctr 1 reload register with value read from log EPROM
		
	inx	h		;using scaled pot value as the index

	mov	a,m
	out	0B1h
				;~~~why is there no bc load here?
				;maybe bc value is still there from when we were called?
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C



L0D52:				;this is table fcn #42 entry point
	lda	$42DE		;pot 5 value, detune control
	mov	b,a

	lda	$42D2		;value for LED Row3
	ani	00Ch		;check "1" and "2" selection bits
	jz	L0D86		;skip if neither is set

	mov	c,a		;save row 3 bits in c

	lxi	d,00020h
	lxi	h,047D2h	;addr of osc 1 detune value for voice 1

	ani	004h		;is "1" selected?
	jz	L0D78		;if not, skip
L0D6A:
	lda	$41E6		;voice mask
L0D6D:
	ani	0FFh
	rar
	jnc	L0D74		;if bit is set for this voice in mask
	mov	m,b		;update detune value
L0D74:
	dad	d		;add offset to get to next voice patch storage, only c flag affected
	jnz	L0D6D

L0D78:
	lxi	h,047D3h	;osc 2 detune value for voice 1
	mov	a,c
	ani	008h		;is "2" selected?
	mvi	c,000h		;clear c so we won't loop forever
	jnz	L0D6A		;repeat previous loop updating osc 2 detune instead

	call	L0AAA		;calls code to convert pots to vce RAM values, once for each voice
L0D86:
	lxi	b,0002Ah	;select #42 (that's us)
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C



				;this is table fcn #43 entry point
				;called when shape pot moves
				;uses shape pot to update voice RAM values based on shape edit sw states
L0D8C:				
	lda	$42E1		;pot 8 value? (shape control)
	mov	d,a

	lda	$42D2		;value for LED Row3
	ani	00Ch		;save "2" and "1" bits
	mov	e,a		;in e reg

	lda	$42D6		;value for LED row 7
	rrc
	rrc			;rotate low 4 bits into top 4
	rrc
	rrc
	ani	070h		;keep edit fall time, edit pw, edit rise time
	ora	e		;OR in "2" and "1" bits
	rrc
	rrc			;shift right two, now we have edit fall, edit pw, edit rise ,"2","1"
	mov	c,a		;in the low 5 bits of c register

	mvi	b,000h
	lxi	h,L0E01		;EPROM table of 32 bytes
	dad	b		;use bc as offset to access
	mov	e,m		;table byte

	lda	$41E6		;voice mask
	ani	0FFh
	jz	L0DFB		;jump if all 0's

	push	psw		;save voice mask

	mov	a,e		;get table value into acc
	add	a		;double it
	mov	e,a		;move back into e
				;values with D7 set will generate a cy
	jnc	L0DCE		;skip down if there was no cy

	lxi	b,00020h
	lxi	h,047E2h	;offset 20d into vce 1 patch storage
	pop	psw		;get mask
	push	psw		;save mask
L0DC1:
	ana	a		;check voice mask remaining bits
	jz	L0DCE
	rar
	jnc	L0DCA		;if voice is enabled in mask,
	mov	m,d		;write shape ctl value to voice patch offset 20d		
L0DCA:
	dad	b		;add 20h to dest address in loop
	jmp	L0DC1		;loop

L0DCE:
	lxi	b,047E9h	;offset 27d into vce 1 patch storage, voice 2 PW value
L0DD1:
	pop	psw		;get mask
	ana	a		;check remaining bits
	jz	L0DF8
	rar			;rotate right into cy
	push	psw
	jc	L0DE6		
L0DDB:
	mov	a,c		;add 0020h to bc address
	adi	020h
	mov	c,a
	mvi	a,000h
	adc	b
	mov	b,a

	jmp	L0DD1		;and loop

L0DE6:				;if mask bit was set for this voice, 
	lxi	h,00000h
	dad	b		;get bc addr into hl
	mov	a,e		;move table value we read (doubled) into acc
L0DEB:
	ana	a
	jz	L0DDB		;if doubled value is 0, add 20h to bc address
	add	a		;shift table value left 1
	jnc	L0DF4
	mov	m,d		;write shape ctl value into vce patch area
L0DF4:
	inx	h		;bump address and loop
	jmp	L0DEB

L0DF8:				;28 lines up jumps here			
	call	L0AAA		;calls code to convert pots to vce RAM values, once for each voice

L0DFB:	
	lxi	b,0002Bh	;select #43
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C


;Following table values are shifted left one before using
;if msbit in table is set, vce patch offset 20 gets shape pot value
;after shifting, table values are used as mask to determine which offsets
;in voice patch get shape pot value

L0E01:			;edit fall, edit pw, edit rise ,"2",   "1"
	.db	$00	;     0        0         0       0      0
	.db	$00     ;     0        0         0       0      1
	.db	$00     ;     0        0         0       1      0
	.db	$00     ;     0        0         0       1      1

	.db	$00     ;     0        0         1       0      0
	.db	$08     ;     0        0         1       0      1, write 30
	.db	$10     ;     0        0         1       1      0, write 29
	.db	$18     ;     0        0         1       1      1, write 29 and 30

	.db	$00     ;     0        1         0       0      0
	.db	$80     ;     0        1         0       0      1, write 20
	.db	$40     ;     0        1         0       1      0, write 27
	.db	$C0     ;     0        1         0       1      1, write 20 and 27

	.db	$00     ;     0        1         1       0      0
	.db	$88     ;     0        1         1       0      1, write 20 and 30
	.db	$50     ;     0        1         1       1      0, write 27 and 29
	.db	$D8     ;     0        1         1       1      1, write 20, 27, 29, and 30

	.db	$00     ;     1        0         0       0      0
	.db	$04     ;     1        0         0       0      1, write 31
	.db	$20     ;     1        0         0       1      0, write 28
	.db	$24     ;     1        0         0       1      1, write 28 and 31

	.db	$00     ;     1        0         1       0      0
	.db	$0C     ;     1        0         1       0      1, write 30 and 31
	.db	$30     ;     1        0         1       1      0, write 28 and 29
	.db	$3C     ;     1        0         1       1      1, write 28, 29, 30, and 31

	.db	$00     ;     1        1         0       0      0
	.db	$84     ;     1        1         0       0      1, write 20, 31
	.db	$60     ;     1        1         0       1      0, write 27 and 28
	.db	$E4     ;     1        1         0       1      1, write 20, 27, 28, and 31

	.db	$00     ;     1        1         1       0      0
	.db	$8C     ;     1        1         1       0      1, write 20, 30, and 31
	.db	$70     ;     1        1         1       1      0, write 27, 28, and 29
	.db	$FC     ;     1        1         1       1      1, write 20, 27, 28, 29, 30, and 31


				;fcn table address #44
				;called when a switch is pressed in row 0
L0E21:	lda	$42C7		;switch row 0 states
	ani	0F0h		;check 2'-16' switches
	jz	L0E44		;if none pressed, skip down

				;if a switch is pressed, we update LED states, and LEDs
				;this would turn off any misc LED's in row 0 
	sta	$42CF		;value for LED Row 0
	out	058h		;out

	mov	d,a
	lxi	b,00020h
	lxi	h,$47E8		;vce 1 patch offset 26, bits 7-4 used to set 2',4',8',16' select bits

	mvi	e,008h		;loop ctr
L0E37:
	mov	a,m		;read voice patch byte
	ani	00Fh		;clear upper bits
	ora	d		;insert switch bits into upper bits
	mov	m,a		;update voice patch byte 
	dad	b
	dcr	e
	jnz	L0E37		;do this for all 8 voices

	call	L0AAA		;calls code to convert pots to vce RAM values, once for each voice
L0E44:
	lxi	b,0002Ch	;select #44
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C



				;fcn table address #45
				;called when a switch is pressed in row 1	
L0E4A:	lda	$42C8		;switch row 1 states
	mov	b,a
	lda	$42D0		;value for LED Row 1
	mov	c,a

	lda	$42D4		;value for LED Row 5
	ani	00Ch		;check arp up and arp dn bits
	jz	L0E73		;skip if neither is enabled		

	mov	a,c
	ana	b
	ani	001h		;is sequence record sw pressed, and LED on?
	jz	L0E73		;skip if not both

	lxi	h,00000h
	shld	$435B		;clear 435B array of 8 bytes
	shld	$435D		;guessing this is sequencer virtual keybd rows array
	shld	$435F		;which holds keys played by the sequencer, 
	shld	$4361		;and is OR'd with the real keyboard data
	jmp	L0EF9		;and jump

L0E73:
	mov	a,b		;switch row 1 states
	ani	001h		;is seq record sw pressed?
	jz	L0E9C		;skip down if not

	xra	c		;is seq record LED on?
	ani	001h
	jnz	L0EF9		;if sw pressed and LED off, then jump

	lda	$42D4		;value for LED Row 5
	ani	0FCh		;clear play and pause ctl bits (must be for sequencer)
	sta	$42D4
	out	05Dh		;out

	mvi	a,080h
	out	0B3h		;latch ctr 2 value

	in	0B2h		;read ctr 2 low byte
	mov	l,a
	in	0B2h		;read ctr 2 high byte
	mov	h,a

	shld	$48E7		;save ctr 2 value at $48E7

	call	L1AE6		;maybe sequencer start-up code?		
	jmp	L0EF9

L0E9C:
	mov	a,b		;switch row 1 states
	ani	002h		;is seq step sw pressed?
	jz	L0EC0		;skip if not

	lda	$42D4		;value for LED Row 5
	ani	0FDh		;clear pause bit
	sta	$42D4
	out	05Dh		;out

	call	L1A7F

	lda	$42D4		;value for LED Row 5
	ani	001h		;check play bit
	jz	L0EF9		;skip if not set

	lxi	b,00037h
	call	L01B2		;call table fcn	#55
	jmp	L0EF9

L0EC0:				;17 lines up jumps here (the only way to get here)
	mov	a,b		;switch row 1 states
	ani	0F0h		;check prog sel 1-4 switches
	jz	L0EF9		;if none pressed, skip

	lda	$42D2		;value for LED Row3
	ani	003h
	cpi	003h		;check for Mono and Select bits set

	mvi	c,00Fh		;either way, c = 00Fh
	jnz	L0EDD

	lda	$42D6		;value for LED row 7
	ani	060h		;check for patch read mode or patch store selected
	jnz	L0EDD		;skip if one of these is slected

	lxi	b,000FFh

L0EDD:				;if Mono and select LEDs are both on, b = sw row 1 states
				;if they are not both on, b = FFh 
	lda	$42D0		;value for LED Row 1
	ana	c		;clear prog sel bits 1-4
	ora	b
	sta	$42D0
	out	059h		;out

	lda	$42D1		;value for LED Row 2
	ana	c		;clear prog sel bits 5-8
	sta	$42D1
	out	05Ah		;out

	call	L146D		;reads 1 or 8 patches into all 8 voices, based on 1st patch mono bit
	call	L1064		;if Mono and Select, copy prog sel bits into voice mask
	call	L1010		;turns DCO timers on/off based on "2" and "1" LED bits and vce mask

L0EF9:
	lxi	b,0002Dh	;select #45
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C



				;fcn table address #46
				;called when a switch is pressed in row 2
L0EFF:				
	lda	$42C9		;switch row 2 read address
	mov	b,a
	ani	0F0h		;check for prog sel 8-5 switches pressed
	jz	L0F41		;skip down if none pressed

	lda	$42D2		;value for LED Row3
	ani	003h		;save Mono and Select bits
	cpi	003h		;both set?

	mvi	c,00Fh		;either way, c = 00Fh
	jnz	L0F1F		;if not, skip

	lda	$42D6		;value for LED row 7
	ani	060h		;check for patch read mode or patch store selected
	jnz	L0F1F		;skip if either is selected

	lxi	b,000FFh	;b = 0, c = FF
L0F1F:				;if Mono and select LEDs are not both on, b = sw row 2 states
				;if they are, and patch read or write is selected, b = sw row 2 states
				;if Mono and select LEDs are both on, and patch read and write not selected, b = 0
	lda	$42D1		;value for LED Row 2
	ana	c		;clear prog sel 8-5 bits if Mono and Select not both on, or read or store is enabled
				;otherwise, don't clear them 
	ora	b		;set prog sel 8-5 bits from switches 
	sta	$42D1
	out	05Ah		;out

	lda	$42D0		;value for LED Row 1
	ana	c		;clear prog sel 4-1 bits
	sta	$42D0
	out	059h		;out

	call	L146D		;reads 1 or 8 patches into all 8 voices, based on 1st patch mono bit
	call	L1064		;if Mono and Select, copy prog sel bits into voice mask
	call	L1010		;turns DCO timers on/off based on "2" and "1" LED bits and vce mask

L0F3B:
	lxi	b,0002Eh	;select #46
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C


L0F41:				;35 lines up jumps here, b upper 4 bits must be 0's
	lda	$42D1		;value for LED Row 2
	ani	0F0h		;clear LFO waveform select bits
	ora	b
	sta	$42D1
	out	05Ah		;out

	lda	$47E7		;vce 1 patch storage byte offset 25d
	ani	0F0h		;clear patch LFO waveform select bits
	ora	b		;set them with sw row 2 states
	sta	$47E7

	lda	$42D5		;value for LED Row 6
	ani	00Fh		;check LFO dest bits
	lxi	b,00039h
	cnz	L01B2		;if any are set, this will call table fcn #57, I think
	jmp	L0F3B



				;fcn table address #47
				;called when a switch is pressed in row 3
				;        D7               D6                D5             D4    D3  D2    D1    D0
				;VCA Ped Ctl Enab,Filt Ped Ctl Enab,Filt KeyTrack Enab,Port Enab,"2","1",Select,Mono
L0F63:	
	lda	$42CA		;switch row 3 state
	mov	d,a
	ani	0F0h		;check port enab, keybd tracking, and two pedal enable switches
	jnz	L1C4D		;jump if any are pressed
				
				;so from here down, we are only dealing with the low 4 switches

	call	L1094		;if Mono+Select LEDs, write vce mask to prog sel, swapping nibbles
				;~~~I'm not clear on why we would ever want to do this

	lda	$42D2		;value for LED Row3
	ani	002h		;check "Select" bit
	cnz	L1010		;call if it's set, turns DCO timers on/off using "2" and "1" LED bits and vce mask

	lda	$42CA		;switch row 3 state 
	cpi	001h		;is just mono pressed?
	jnz	LL0F98		;skip if not

	mov	d,a
	lda	$42D2		;value for LED Row3
	ana	d
	ani	001h		;just mono sw pressed and mono LED lit?
	jnz	LL0F98		;skip down if both bits are set

	lda	$42D6		;value for LED row 7
	ani	01Fh		;clear "patch store" and "patch read mode" bits
	ori	020h		;turn on "patch read mode" when we exit mono mode
	sta	$42D6		;LED row 7
	out	05Fh		;out

	call	L146D		;reads 1 or 8 patches into all 8 voices, based on 1st patch mono bit
LL0F98:
	lda	$42D2		;value for LED Row3
	mov	d,a
	mov	a,d		;~~~ duh!
	ani	00Fh		;keep bits for 2,1,select,mono
	rrc
	rrc
	rrc
	rrc
	mov	e,a		;shift to upper 4 and place in e

	lda	$41E6		;voice mask
	ana	a		;set flags
	jz	L100A		;skip down if 00

				;maybe this was supposed to test 2 and 1 LEDs?
	mvi	d,000h
	ani	0C0h		;test voice 8 and 7 bits of mask
	jpe	LL0FE0		;jump parity even (both 0 or both set)

	lxi	h,047E5h	;vce1 patch byte at offset 23d
				;most patches have 41h here, a few have 11h or 12h
	lxi	b,00020h	
				;so the low nibble is always 1 or 2
	mov	a,e
LL0FB9:			
	ani	00Fh		;~~~these bits were cleared above, right?
	jz	LL0FE0		;seems like we will always take this jump
	rar			;maybe we were supposed to be using voice mask here?
	jc	LL0FC6
	dad	b
	jmp	LL0FB9		;loop

LL0FC6:
	mov	b,m		;read voice patch offset 23d byte
	mov	a,e
	ani	080h		;is "2" LED currently lit?
	mov	a,b
	jz	LL0FD2		;skip patch byte rotate if not
	rrc
	rrc
	rrc			;but if it is, rotate voice patch value
	rrc			;low bits into D4-D7
LL0FD2:
	ani	0F0h		;clear low bits
	mov	b,a

	lda	$42D3		;value for LED Row 4
	ani	00Fh		;clear bank bits, ~~~ setting bank bits with patch data?  makes no sense!
				;luckily, this code will never be executed, since above jump will always be taken
	ora	b		;set bank with shifted vce patch bits
	sta	$42D3		;save it, and write it out
	out	05Ch		;out

LL0FE0:
	lxi	h,$47E6		;vce1 patch byte at offset 24d, used to set 2,1,select, and mono
	lxi	b,00020h

	lda	$42D2		;value for LED Row3
	ani	001h		;check D0 (Mono)
	mvi	a,0FFh
	jnz	LL0FF3
	lda	$41E6		;if not mono mode, use voice mask
LL0FF3:				;if mono, use FF as the mask
	ani	0FFh
	jz	L1007		;exit loop when mask is all 0's
	rar
	jnc	L1003

	push	psw		;save mask

	mov	a,e
	mov	m,a		;write e value to vce patch byte
	ani	0EFh		;clear D4
	mov	e,a		;so only the first voice written gets D4 (mono) set
				;since this bit would only be set in mono mode, it's
				;voice 1 that gets mono bit set

	pop	psw		;restore mask
L1003:
	dad	b
	jmp	LL0FF3		;'n loop

L1007:				;this label is called from ~1CA0
	call	L0AAA		;calls code to convert pots to vce RAM values, once for each voice
L100A:
	lxi	b,0002Fh	;select #47
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C



				;turns DCO timers on/off based on "2" and "1" LED bits and vce mask
L1010:				;			
	lda	$42D2		;value for LED Row3
	mov	b,a
	ani	002h		;check D1 (Select)
	rz			;return if not set

	mov	a,b
	ani	001h		;check Mono bit
	mvi	h,0FFh
	jz	L1023
	lda	$41E6		;voice mask
	mov	h,a		;if Mono, use FF as mask, otherwise use voice mask
L1023:
	mov	a,b
	ani	00Ch		;get "2" and "1" LED bits
	rrc
	rrc			;rotate into the low 2 bits
	mov	c,a		;and move into c

				;build a 16-bit mask with "2" and "1" bits
				;if voice mask bit is set, the 2 bits for this voice
				;will be these two.   If it's not set, they will be 0's
				;voice 0 bits are in 1,0 of de pair
	mvi	b,008h		;loop ctr
	lxi	d,00000h
L102E:
	dcr	b
	jm	L1040

	xchg			;get de into hl
	dad	h		;shift left
	dad	h		;shift left
	xchg			;put it back into de

	mov	a,e
	dad	h		;shift mask left
	jnc	L102E		;if msbit was not set, skip
	add	c
	mov	e,a		;otherwise, put "2" and "1" bits into low 2 bits of de
	jmp	L102E		;loop

L1040:				;this loop writes to the control address of all 8 voice timers
				;if "2" mask bit is set, ctr 2 is set to mode 2, if not, mode 5
				;if "1" mask bit is set, ctr 0 is set to mode 3, if not, mode 5
				;ctr 1 is always set to mode 1
	mvi	a,008h
	lxi	b,0FBFCh
L1045:
	lxi	h,07F7Fh	;we start with voice 8
L1048:
	xchg
	dad	h
	xchg
	mvi	m,0B4h		;10110100, select ctr 2, low/high, mode 2 (rate gen)
	jc	L1052
	mvi	m,0BAh		;10111010, select ctr 2, low/high, mode 5 (delayed strobe)
L1052:
	xchg
	dad	h
	xchg

	mvi	m,036h		;00110110, select ctr 0, low/high, mode 3 (sq wave gen)
	jc	L105C
	mvi	m,03Ah		;00111010, select ctr 0, low/high, mode 5 (delayed strobe)
L105C:
	mvi	m,072h		;01110010, select ctr 1, low/high, mode 1 (one-shot)

	dad	b
	dcr	a
	jnz	L1048		;loop
	ret


				;This code sets voice mask in mono mode 
				;using the current program select bits
				;Used to enable different timbres in mono composite sound
L1064:
	lda	$42D2		;value for LED Row3
	ani	003h		;check Mono and Select bits
	cpi	003h
	rnz			;return if low two bits are not both set

	lda	$42D6		;value for LED row 7
	ani	060h		;return if patch read mode or patch store selected
	rnz

	lhld	$42D0		;values for LED Rows 1 and 2
	mov	a,l		;row 1 value
	ani	0F0h		;just keep upper 4 bits (Prog sel 4-1)
	rrc
	rrc
	rrc
	rrc			;rotate into low 4 bits
	mov	l,a		;save in l

	mov	a,h		;row 2 value
	ani	0F0h		;just keep upper 4 bits (Prog sel 8-5)
	ora	l		;add in low 4 prog sel bits from l		
	sta	$41E6		;write current program select bits to voice mask

	mvi	a,008h		;load a with 8
	cpi	008h		;compare to 8		
	rz			;return if 8 = 8!  ~~~no clue why someone would do this, but looks intentional

				;~~~this is probably dead code:
	lda	$42D1		;value for LED Row 2
	ani	00Fh		;clear prog sel 7-4 bits
	sta	$42D1
	out	05Ah		;out
	ret


				;if Mono+Select LEDs on, and not patch read or patch store, 
				;write vce mask to prog sel LEDs, 
				;row 1 and 2 low nibbles are swapped, unless FIXSWAP is defined 
L1094:				
	lda	$42D2		;value for LED Row3
	ani	003h		;save Mono and Select bits
	mov	c,a

	lda	$42D6		;value for LED row 7
	ani	060h		;check for patch read mode or patch store selected
	ora	c
	cpi	003h		;checking for Mono and Select LEDs, and not patch read or patch store LEDs on
	jnz	L10C9		;skip down if we don't have it

	lda	$41E6		;voice mask
	mov	b,a
	ani	00Fh
	rrc
	rrc
	rrc
	rrc
	mov	l,a		;lower 4 bits of mask in l D7-4

	mov	a,b
	ani	0F0h
	mov	h,a		;upper 4 bits of mask in h D7-4

	#IFDEF	FIXSWAP
		lda	$42D1	;value for LED Row 2
	#ELSE
		lda	$42D0	;value for LED Row 1
	#ENDIF

	ani	00Fh		;clear prog sel nibble 
	ora	h		;OR h into row 1 bits (row 2 if we fix bug)
	mov	h,a		;~~~note that row 1 holds low prog sel bits

	#IFDEF	FIXSWAP
		lda	$42D0	;value for LED Row 1
	#ELSE
		lda	$42D1	;value for LED Row 2
	#ENDIF

	ani	00Fh		;clear prog sel nibble

	ora	l		;OR l into row 2 bits (row 1 if we fix bug)
	mov	l,a

	shld	$42D0		;write to values for LED rows 2 and 1
	shld	$5959		;same as writing to I/O addresses 59,5A, so we are updating LEDs too
	ret


L10C9:				;we jumped here because we didn't have (Mono & Select & !PatchRead & !PatchStore) LEDs
				;looks like we are testing for exiting the special mode
	lda	$42D2		;value for LED Row3
	mov	c,a
	lda	$42CA		;switch row 3 states
	xra	c
	xri	003h		;we want Mono and Select without their switches pressed
	ani	003h		;I think ~~~not quite what the code is doing
	rnz			;return if we don't have that

	lda	$42D6		;value for LED row 7
	mov	c,a
	lda	$42CE		;switch row 7 states
	xra	c
	ani	060h		;we don't want patch read mode or patch store selected
	rnz			;not sure why it's different here from other places

	lhld	$42D0		;read values for LED rows 2 and 1
	mov	a,l
	ani	00Fh		;clear Prog Sel 4-1 bits
	ori	010h		;set prog sel 1 bit		
	mov	l,a
	mov	a,h	
	ani	00Fh		;clear Prog Sel 8-5 bits
	mov	h,a
	shld	$42D0		;write to values for LED rows 2 and 1
	shld	$5959		;same as writing to I/O addresses 59,5A, so update LEDs

	lda	$42CA		;switch 3 states
	cpi	001h		;is Mono switch pressed?
	rnz			;if not, return

	mvi	a,0FFh		
	sta	$41E6		;enable all voices in mask

	call	L1010		;turns DCO timers on/off based on "2" and "1" LED bits and vce mask

	lda	$42D6		;value for LED row 7
	ani	01Fh		;clear patch read mode and patch store bits
	ori	020h		;then enable patch read mode
	sta	$42D6		;value for LED row 7
	out	05Fh		;and update LEDs too

	ret


				;#48 in table of code addresses, no other refs
L110F:				;called when a switch is pressed in row 4			
	lda	$42CB		;switch row 4 states
	mov	d,a
	ani	0F0h		;any bank switches pressed?
	jz	L112A		;if not, skip

	mov	e,a
	lda	$42D3		;value for LED Row 4
	ani	00Fh		;clear Bank bits
	ora	e		;OR in new value
	sta	$42D3		;save it
	out	05Ch		;and write it out

L1124:
	lxi	b,00030h	;select #48
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C

L112A:
	mov	a,d		;row 4 switch states
	ani	00Ch		;mod wheel ctl bits set?

	lda	$42D3		;value for LED Row 4
	mov	e,a
	jz	L118F

	ana	d
	jnz	L115E
	mvi	b,0FFh
	lxi	h,00000h
	mov	a,d
	cpi	004h
	jnz	L1148
	shld	$41E9		;seems like LFO 16-bit signed amt for freq mod
	mvi	b,0FEh
L1148:
	cpi	008h
	jnz	L114F
	mvi	b,0FBh		;mask to clear D2 bit
L114F:
	lda	$42D5		;value for LED Row 6
	ana	b
	sta	$42D5
	out	05Eh		;out

	call	L15DB
	jmp	L1124

L115E:				;at least one mod wheel ctl enable is set, 
	jpe	L1124		;jump if both are set
	lda	$42F2		;pot 25 (mod wheel) value
	cma
	inr	a		;negate it
	sta	$431D		;and save it

	lda	$42D5		;value for LED Row 6
	ani	00Fh		;check LFO dest bits
	lxi	b,00039h	;if none are set, this will call table fcn #57
	cz	L01B2

	lda	$42CB		;switch row 4 states
	mvi	b,001h		;mask to set D0 bit, this code looks odd
	cpi	004h		;is mod wheel LFO freq amt ctl switch pressed?
	jz	L1180

	mvi	b,004h		;mask to set D2 bit
L1180:
	lda	$42D5		;value for LED Row 6
	ora	b		;if mod wheel LFO freq amt ctl sw is pressed, enable LFO freq mod
	sta	$42D5		;otherwise, mod wheel LFO cutoff must be pressed, so enable LFO filter cutoff mod
	out	05Eh		;out

	call	L15DB
	jmp	L1124

L118F:				;mod wheel ctl bits not set, 
	ani	001h
	jnz	L119F
	lhld	$4385		;tune pot signed 16-bit offset value
	xchg
	lhld	$4383		;16-bit positive freq offset due to patch octave selection, low byte
	dad	d
	shld	$41E7		;16-bit frequency offset, includes tune pot, patch footage sel, and pitch wheel, if enabled
L119F:
	lda	$42D3		;value for LED Row 4
	ani	002h		;check pitch wheel filter mod enable
	jnz	L11BA		;if enabled, skip next code

	lxi	h,$4321		;pitch wheel filter cutoff mod value

	lda	$42D5		;value for LED Row 6
	ani	004h		;check D2, LFO filter mod enable
	jnz	L11B5		;if mod enabled, clear $4321

				;if mod not enabled, clear this:
	lxi	h,$41F5		;seems like LFO 16-bit signed amt for filter mod
L11B5:
	mvi	m,000h		;clear selected 16-bit value
	inx	h
	mvi	m,000h

L11BA:
	lda	$42F1		;pot 24 value?
	cma
	inr	a
	sta	$431E		;431E = -pot 24 value
	jmp	L1124


				;#49 in table of code addrs, no other ref	
L11C5:				;called when a switch is pressed in row 5				
	lda	$42CC		;sw row 5 complemented states
	mov	b,a
	ani	0F0h		;check prog grp sel 1-4 switches
	jnz	L1291		;jump if any are pressed

	mov	a,b
	ani	00Ch		;check arp up and arp dn switches
	lda	$42D4		;value for LED Row 5
	mov	c,a
	jz	L1202		;jump if neither is set

				;one of the arp switches is pressed
	ani	00Ch		;check arp up and dn LED's		
	lxi	b,00020h
	jz	L11E9		;jump if neither is on

	call	L01B2
L11E3:
	lxi	b,00031h	;select #49
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C

L11E9:
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C
	lda	$4327
	cpi	0FFh
	jz	L11E3
	mov	e,a
	mvi	d,000h
	lxi	h,$4328
	dad	d
	mov	e,m
	call	L02A6		;call key release routine
	jmp	L11E3

L1202:				;we come here if neither arp sw is pressed
	mov	a,c		;get LED states for row 5
	ani	001h		;is play LED on?
	jz	L125F		;skip if it's not

				;play LED is on
	mov	a,b		;get row 5 switch states
	xra	c		
	ani	001h		;is play switch pressed?
	jnz	L1224		;jump if it's not

	lda	$42D0		;value for LED Row 1
	ani	0FEh		;clear D0 bit (seq record)
	sta	$42D0
	sta	$0059

	lda	$42D4		;value for LED Row 5
	ani	0FDh		;clear pause bit
	sta	$42D4
	out	05Dh		;out

L1224:
	mov	a,c		;get LED states for row 5
	ani	00Ch		;check arp up and dn LEDs
	jz	L1241		;skip if neither is on

	call	L1AAC
	lxi	h,00000h
	dad	sp
	shld	$4359
	lxi	sp,04373h
	call	L180D
	lhld	$4359
	sphl
	jmp	L11E3

L1241:
	mov	a,b
	ani	001h
	jz	L125F
	xra	c
	ani	001h
	lxi	b,00037h	;select #55
	jz	L1256
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C
	jmp	L11E3

L1256:
	call	L01B2
	call	L1AE6		;maybe sequencer start-up code?
	jmp	L11E3

L125F:
	mov	a,b
	xra	c
	ani	001h
	jz	L126C
	call	L1AAC
	jmp	L11E3

L126C:
	mov	a,b
	ani	002h
	jz	L11E3

	xra	c
	ani	002h
	jnz	L11E3

	lda	$42D0		;value for LED Row 1
	ani	001h		;check sequence record bit
	jz	L11E3		;jump if not set

	lda	$42D4		;value for LED Row 5
	ani	00Ch		;check arp up and arp dn bits
	jnz	L11E3		;jump if either is set

	call	L198E
	call	L1AC1
	jmp	L11E3

L1291:
	lda	$42D4		;value for LED Row 5
	ani	00Fh		
	ora	b		;update lower 4 bits from b
	sta	$42D4
	out	05Dh		;out

	lda	$42D5		;value for LED Row 6
	ani	00Fh		;clear upper 4 bits
	sta	$42D5
	out	05Eh		;out

	call	L146D		;reads 1 or 8 patches into all 8 voices, based on 1st patch mono bit
	jmp	L11E3


				;#50 in table of code addrs, no other ref
L12AC:				;called when a switch is pressed in row 6			
	lda	$42CD		;get row 6 switch states value
	mov	b,a		;save in b
	mvi	d,0FFh
	ani	005h		;look for LFO freq mod and LFO filter mod both pressed?
	jz	L12CD		;if we get that, jump with d = FF

	lda	$42D5		;value for LED Row 6
	ana	b		;AND it with row 6 switches
	jz	L12CD		;if nothing pressed with its LED on, jump with d = FF		

	mov	a,b		;get row switch state
	cpi	001h		;is just the LFO freq mod switch pressed?
	jnz	L12C6		;if not, skip
	mvi	d,0FBh		;set d to FB
L12C6:
	cpi	004h		;how about just the LFO filter mod sw?
	jnz	L12CD		;if not, skip

	mvi	d,0F7h
L12CD:
	lda	$42D3		;value for LED Row 4 (low 4 bits are pitch wheel and mod wheel enabs)
	ana	d
	sta	$42D3
	out	05Ch		;out

	mov	a,b
	ani	0F0h		;check prog grp sel 5-8 switches
	jz	L12FA		;skip if not set

	lda	$42D5		;value for LED Row 6
	ani	00Fh
	ora	b		;update LFO dest bits from b
	sta	$42D5
	out	05Eh		;out

	lda	$42D4		;value for LED Row 5
	ani	00Fh		;clear prog grp sel 1-4 bits
	sta	$42D4
	out	05Dh		;out

	call	L146D		;reads 1 or 8 patches into all 8 voices, based on 1st patch mono bit
L12F4:
	lxi	b,00032h	;select #50
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C
L12FA:
	lda	$42D5		;value for LED Row 6
	ani	00Fh		;just keep LFO dest bits
	rrc
	rrc
	rrc
	rrc			;rotate them into upper 4 bits
	mov	c,a		;save in C

	lda	$47E7		;voice 1 patch offset #24 byte
	ani	00Fh		;clear upper 4 bits at this address
	ora	c		;insert LFO mod dest bits (this is where pach stores LFO mod bits)
	sta	$47E7		;update var

	mov	a,c		;check LFO dest bits
	ana	a
	jz	L1320		;if none set, skip

	lda	$42D1		;value for LED Row 2
	ani	00Fh		;look at LFO waveshape select bits
	lxi	b,00039h
	cnz	L01B2		;if they are not all 0, this will call table fcn #57 I think
	jmp	L12F4		;jump back

L1320:
	lxi	h,00000h	;clear these four 16-bit locations
	shld	$41F3		;seems like LFO signed amt for VCA mod		
	shld	$41F5		;seems like LFO signed amt for filter mod
	shld	$41E9		;seems like LFO signed amt for freq mod
	shld	$41EB		;LFO 16-bit signed amt for shape mod (seems like DCO2 PW only)

	lxi	b,00039h	;select #57
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C
	jmp	L12F4		;jump back


				;#51 in table of code addrs, no other ref
L1338:				;called when a switch is pressed in row 7	
	lda	$42CE		;sw row 7 states
	mov	e,a		;save switch row state in e
	ani	00Fh		;check three shape edit switches and chord switch
	jz	L1361		;if none are pressed, skip down

	mov	e,a		;ANDed switch row state in e
	ani	008h		;is chord switch pressed?
	jz	L135B		;if not, skip

	lda	$42D6		;value for LED row 7
	ani	008h		;is chord mode currently enabled?
	jz	L135B		;if not, skip

				;seems like if chord sw is pressed, and chord mode is enabled
	lxi	h,$438A		;clear 10 bytes at this address
	mvi	b,00Ah		;seems like two bytes plus first 8 bytes in 16-byte array
				;all 10 are related to chord mode
L1354:
	mvi	m,000h
	inx	h
	dcr	b
	jnz	L1354		;loop

L135B:
	lxi	b,00033h	;select #51
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C
L1361:
	mov	a,e
	cpi	040h		;is just patch store switch pressed?
	jnz	L136F		;if not, skip

	lda	$42D6		;value for LED row 7
	ani	020h		;check patch read mode bit
	cz	L14E1		;write patch to selected program in RAM

L136F:
	call	L1094		;if Mono+Select LEDs, write vce mask to prog sel, swapping nibbles
				;~~~I'm not clear on why we would ever want to do this
	jmp	L135B



				;seems like this code was unpacking bits from a patch 
				;that was just read from EPROM and using them to set
				;LED states (turn features on and off)
				;it's only called in one place
L1375:				
	lxi	h,$47E6		;offset 24 into voice 1 patch storage

	lda	$42D6		;value for LED row 7
	ani	0F0h		;clear low 4 bits (chord mode and shape edit bits)
	sta	$42D6
	out	05Fh		;out

	mov	a,m
	mov	b,a		;~~~ this doesn't seem to be needed
	ani	0F0h		;get upper 4 bits from patch offset 24
	rrc
	rrc
	rrc			;rotate them into low 4 bits
	rrc
	mov	c,a

	lda	$42D2		;value for LED Row3
	ani	0C0h		;only save pedal VCA and filter cutoff mod enables
	ora	c		;use offset 24 bits 7-4 as 2,1,select,mono
	sta	$42D2		;value for LED Row3
	out	05Bh		;out

	inx	h		;point to patch offset 25 byte
	mov	a,m		;read it into acc
	mov	b,a		;save it in b
	ani	0F0h		;get upper 4 bits
	rrc
	rrc
	rrc
	rrc
	mov	c,a		;rotate into the low 4 bits of c

	lda	$42D5		;value for LED Row 6
	ani	0F0h		;clear low 4 bits
	ora	c		;use offset 25 bits 7-4 as VCA,Filter,Shape,Freq (as LFO mod dest)
	sta	$42D5
	out	05Eh		;out

	mov	a,b
	ani	00Fh
	mov	c,a		;get low 4 bits from offset 25 byte into c

	lda	$42D1		;value for LED Row 2
	ani	0F0h
	ora	c		;use offset 25 bits 3-0 as Square,Tri,RmpDn,Rmpup (as LFO wavefrm)
	sta	$42D1
	out	05Ah		;out

	mov	a,b		;check LFO mod dest bits
	ani	0F0h		;are any set?
	jz	L13C6

	lxi	b,00039h	;if so, call table fcn #57
	call	L01B2

L13C6:
	lda	$47E8		;vce 1 patch offset 26, bits 7-4 used to set 2',4',8',16' select bits
	ani	0F0h
	mov	c,a		;get just upper 4 bits into c

	lda	$42CF		;value for LED Row 0
	ani	00Fh		;clear upper 4 bits
	ora	c		;use offset 26 bits 7-4 as 2',4',8',16' select bits
	sta	$42CF		;value for LED Row 0
	out	058h		;out

	lda	$47E8		;re-read offset 26 byte, ~~~ could save in b above and recall
	ani	00Fh		;grab low 4 bits
	rrc
	rrc
	rrc
	rrc
	mov	c,a		;shift into upper 4 and move to c

	lda	$42D2		;value for LED Row3
	ani	0CFh		;this only clears D4,D5 (port enab, keybd trk)
	ora	c		;so we are loading D4 and D5 and ORing with D6 and D7
				;think this is OK.   Pedal enables are not controlled by patch.
				;all EPROM patch offset 26 bytes have "2" as low nibble (keytrk enab)
	sta	$42D2		;value for LED Row3
	out	05Bh		;out

	call	L1010		;turns DCO timers on/off based on "2" and "1" LED bits and vce mask
	ret


				;returns address of selected program, in EPROM or RAM, in hl
L13F0:				;uses Bank, prog grp sel, and prog sel LED values								
	lda	$42D3		;value for LED Row 4
	ani	0F0h		;program bank bits
	mov	b,a
	lxi	h,0C000h	;DS8 EPROM starting address
	lxi	d,00800h	;this is the size of 64 programs
	rlc			;Bank D bit is D7
	jc	L1412		;code selects bank D at startup
	dad	d		;bank D is first in the EPROM
	rlc
	jc	L1412
	dad	d		;then C
	rlc
	jc	L1412
	dad	d		;then B (with all of the Mono groups in it)
	rlc
	jnc	L1412		;and Bank A is the 2Kx8 RAM bank, at 9000h
	lxi	h,09000h
L1412:
	shld	$4293		;save base address of current program bank

	lhld	$42D4		;LED row 5,6 states
	xchg			;row 5 in e, row 6 in d
	mov	a,e
	ani	0F0h		;get upper 4 bits of LED row 5 (four prog grp sel lsbits)
	rrc
	rrc
	rrc
	rrc			;shift them into acc D3-D0
	mov	e,a		;move back into e

	mov	a,d		;LED row 6 state
	ani	0F0h		;just upper 4 bits (four prog grp sel msbits)
	ora	e		;OR those with upper 4 of LED row 5
	jnz	L1435		;jump if prog grp sel value is not 0

	lda	$42D4		;if prog grp sel is all 0's, set it to "1" (first group)
	ori	010h		;set "grp sel 1" bit
	sta	$42D4		;in LED row 5
	out	05Dh		;out

	jmp	L13F0		;jump to start of this routine, with prog grp sel now = 1

L1435:
	mvi	b,008h		;prog grp sel bits are not all 0's
L1437:
	add	a		;shift OR result left until cy is set
	dcr	b		;decrement b each time
	jnc	L1437		;b ends up with bit pos of 1 bit in prg grp sel byte		

L143C:
	lhld	$42D0		;values for LED Rows 1 and 2
	xchg			;row 1 in e, row 2 in d
	mov	a,e
	ani	0F0h		;get upper 4 bits of LED row 1 (four prog sel lsbits)
	rrc
	rrc
	rrc
	rrc			;shift them into acc D3-D0
	mov	e,a		;move back into e

	mov	a,d		;LED row 2 state
	ani	0F0h		;just upper 4 bits (four prog sel msbits)
	ora	e		;OR those into upper 4 of LED row 1
	jnz	L145C		;jump if prog sel value is not 0

	lda	$42D0		;if prog sel is all 0's, set it to "1" (first prog)
	ori	010h		;set "prog sel 1" bit
	sta	$42D0		;in LED row 1
	out	059h		;out

	jmp	L143C		;jump to start of this routine, with prog sel now = 1

L145C:
	mvi	c,008h		;prog sel bits are not all 0's
L145E:
	add	a		;shift OR result left until cy is set
	dcr	c		;decrement c each time
	jnc	L145E		;c ends up with bit pos of 1 bit in prg sel byte

	mov	a,c
	rrc			;rotate right 3 is same as left 5
	rrc			;c = c * 32
	rrc
	mov	c,a

	lhld	$4293		;base address of current program bank
	dad	b		;add bc to hl to form final program address in hl
	ret


				
L146D:				;code to read one or 8 patches from EPROM or RAM
	lda	$42D6		;value for LED row 7
	ani	020h		;is patch read mode enabled?
	rz			;return if not

	lxi	h,00000h
	dad	sp
	shld	$42F6		;save sp at 42F6

	lxi	sp,04308h
	call	L13F0		;returns address of selected program, in EPROM or RAM, in hl
	xchg			;save program address in de
	lxi	h,00018h
	dad	d		;add 24 to patch address in memory
	mov	a,m		;read that byte
	ani	010h		;check D4 bit
	lxi	b,00820h	;b=8, c = $20, so this copies one program to all 8 voices
	jz	L14AC		;jump if it's zero (First patch does not have mono bit set)

				;first patch does have mono bit set:
				;if any prog sel 4-1 bit is set, set prog sel to 1, leave 5-8 bits alone
				;if none of those, set 5 bit
				;then read 8 patches with that as the starting pt

	#IFDEF	NORDALGN
				;don't change starting patch to load on reads
				;so we can just use the address that's already in de 
	lxi	h,$42D0		;value for LED row 1
	mov	a,m
	ani	0F0h		;check prog sel 1-4
	jnz	flshupr		;if any are pressed, flash upper 4 instead
				;we are flashing lower 4:
	mov	a,m		;read row 1 LED bits
	ori	0F0h		;turn on prog sel 1-4
	out	059h
	jmp	skipwrchg	;then read in our 8 patches
flshupr:
	inx	h		;point to LED row 2
	mov	a,m
	ori	0F0h		;turn on prog sel 5-8 LEDs
	out	05Ah
	jmp	skipwrchg	

	#ELSE
				;original code:	
	lxi	h,$42D0		;value for LED Row 1
	lxi	d,$5959		;address of LED row 1 in hw
	mov	a,m
	ani	0F0h		;check prog sel 1-4
	jnz	L149C		;if any are selected, skip incr, so clear all 4 bits,
				;set prog sel 1 bit, and turn on all four Prog Sel 4-1 LEDs

	inx	h		;point to LED row 3 bits
	inx	h		;~~~this was supposed to be "inx d" I think
L149C:				;or if we skipped, we're still at row 1
	mov	a,m		;if row 1, we are clearing prog sel 4-1
	ani	00Fh		;if row 3, we are clearing port,keytrk,and pedal enables
	ori	010h		;and set port bit
	mov	m,a		;write to RAM
	ori	0F0h		;this would flash 
	stax	d		;d still points to Prog Sel 1-4 LEDs
	call	L13F0		;returns address of selected program, in EPROM or RAM, in hl

	#ENDIF

	xchg
skipwrchg:
	lxi	b,$0100		;this would copy eight consecutive programs into the 8 voices!
				;since c is effectively 256
L14AC:
	xchg			;get program address into hl
	lxi	d,$47CE
L14B0:
	mov	a,m		;this was copying the first program into RAM
	stax	d		;from address $C000, to address 47CE
	inx	h
	inx	d
	dcr	c
	jnz	L14B0		;loop

	dcr	b
	jz	L14C4		;then copy it to the other 7 voices
	lxi	h,$47CE
	mvi	c,020h
	jmp	L14B0

L14C4:
	mvi	a,0FFh
	sta	$41E6		;enable all voices in mask

	call	L1010		;turns DCO timers on/off based on "2" and "1" LED bits and vce mask
	call	L1375		;use some of vce1 patch bits to set some LED ctls
	call	L0AAA		;calls code to convert pots to vce RAM values, once for each voice

	lda	$42D3		;value for LED Row 4
	ani	0F3h		;clear D3,D2 (disable pedal filter and VCA control)
	sta	$42D3
	out	05Ch		;out

	lhld	$42F6		;get sp value we saved before
	sphl
	ret


				;write patch to selected program in RAM
L14E1:
	lda	$42D6		;value for LED row 7
	ani	020h		;is patch read mode enabled?
	rnz			;return if it is

	lxi	h,00000h
	dad	sp
	shld	$4000		;save sp at $4000

	lxi	sp,042BEh
	call	L13F0		;returns address of selected program, in EPROM or RAM, in hl

	lxi	b,00020h	;this would write only one patch out to RAM
	lda	$42D2		;value for LED Row3
	ani	001h		;check D0 (Mono)
	jz	L151C		;if we're not in mono mode, skip down

				;mono mode code:
	lxi	h,$42D0		;point hl to value for LED Row 1
	lxi	d,$5959
	mov	a,m
	ani	0F0h		;check prog sel 1-4 bits
	jnz	L150D		;skip if one is set
	inx	h
	inx	d

L150D:				;if one is set, clear upper 4 bits, set D4, and write out
	mov	a,m		;if none is set, do the same operation but to the upper 4 bits		
	ani	00Fh		;seems like mono 8-patch group writes and reads are forced to 4-patch alignment
	ori	010h		;not sure why  (reads are no longer forced, if my chg is enabled)
	mov	m,a
	ori	0F0h		;this flashes 4 prog sel LED's when we write a mono patch group
	stax	d		;probably just to indicate what we are doing, and also to indicate starting alignment

	call	L13F0		;returns address of selected program, in EPROM or RAM, in hl
				;we may have just changed the program select part of the address
	lxi	b,00000h	;this should write all 8 voice patches out to RAM (or EPROM if selected!)

L151C:
	lxi	d,$47CE		;vce1 patch storage
L151F:				;this code was writing to RAM at $9000 to save a patch
	ldax	d		
	mov	m,a	
	inx	h	
	inx	d	
	dcr	c
	jnz	L151F		;loop

	lhld	$4000
	sphl			;load SP from $4000
	ret			;we be gone!



				;this is part of the LFO code
L152C:				;#57 in table of code addresses, no other ref
	call	L15DB		;this routine reads pot 25 value (mod wheel)		
L152F:
	call	L15CA		;copy 8 bytes from $430D to $4315

	lda	$42CF		;value for LED Row 0
	xri	002h		;toggle D1 bit, LFO rate LED
	sta	$42CF		;value for LED Row 0
	out	058h		;out

L153C:
	lxi	h,00000h
	dad	sp
	shld	$4000		;save sp at $4000

	lxi	sp,04315h
	pop	h		;get value at 4316:5 into hl
	pop	d		;get value at 4318:7 into de
	mov	a,h		;save 4316 value in acc
	dad	d		;hl = hl + de
	push	h		;save sum at 4318:17
	pop	d		;then load de with it
	pop	h		;load hl from 431A:19
	dad	d		;add previous sum to it
	xra	h		;exor new high byte with original one from 4316
	rp			;return if pos (~~~sp is pointing at 431B)

	lda	$42D1		;value for LED Row 2
	ani	008h		;check LFO square waveshape bit
	jz	L1562		;skip if not set

	dcx	sp
	dcx	sp
	pop	d

	mov	a,d
	cma
	mov	d,a		;de = -de
	mov	a,e
	cma
	mov	e,a
	inx	d

L1562:
	lhld	$4309
	dad	d
	mov	c,h
	mov	a,h
	ana	a
	mvi	a,000h
	jp	L1570
	mvi	a,0FFh
L1570:
	mov	b,a
	dad	h
	adc	a
	dad	h
	adc	a
	dad	h
	adc	a
	mov	l,h
	mov	h,a

	lda	$42D5		;value for LED Row 6
	ani	004h		;check LFO filter mod enable
	jz	L1592		;if not enabled, don't update filter mod amt

	lda	$42D3		;value for LED Row 4
	ani	002h		;check pitch wheel filter cutoff mod enable
	jz	L158E

	xchg			;if it is, save hl in de
	lhld	$4321		;get pitch wheel filter cutoff mod value
	dad	d		;and add in hl value we saved in de
L158E:
	shld	$41F5		;seems like LFO 16-bit signed amt for filter mod
	xchg
L1592:
	lda	$42D5		;value for LED Row 6
	mov	d,a
	ani	008h		;check LFO ampl mod enable
	jz	L159E
	shld	$41F3		;seems like LFO 16-bit signed amt for amplitude mod
L159E:
	mov	a,d
	lxi	h,00000h
	dad	b
	ani	003h		;look at LFO freq and shape mod enables
	cpi	003h		;are they both set?
	jnz	L15AD
	shld	$41E9		;seems like LFO 16-bit signed amt for freq mod
L15AD:
	cpi	002h
	jnz	L15B5
	shld	$41EB		;LFO 16-bit signed amt for shape mod (seems like DCO2 PW only)
L15B5:
	cpi	001h
	jnz	L15C0
	shld	$41E9		;seems like LFO 16-bit signed amt for freq mod
	shld	$41EB		;LFO 16-bit signed amt for shape mod (seems like DCO2 PW only)
L15C0:
	lhld	$4000
	sphl
	call	L0099		;pop hl,de,bc, and ret
	jmp	L153C



L15CA:				;copy 8 bytes from $430D-4314 to $4315-431C
	lxi	d,04315h
	lxi	h,$430D
	mvi	b,008h		;loop ctr
L15D2:
	mov	a,m
	stax	d
	inx	h		;bump ptrs
	inx	d
	dcr	b
	jnz	L15D2		;and loop

	ret



L15DB:				;part of the LFO code
	lda	$47D0		;voice1 patch offset 2 (LFO depth pot value)
	cma
	mov	l,a
	mvi	h,000h

	lda	$42D3		;value for LED Row 4
	ani	00Ch		;pedal control enables?
	jz	L1606

	lda	$431D		;negated mod wheel value
	mov	e,a
	mvi	d,0FFh
	dad	d

	lda	$42F2		;pot 25 value (mod wheel)
	mov	e,a
	mvi	d,000h
	dad	d

	mov	a,h
	ana	a
	jz	L1606
	lxi	h,000F0h
	jp	L1606
	lxi	h,00000h
L1606:
	mov	a,l
	adi	00Fh
	jnc	L160F
	lxi	h,000F0h
L160F:
	shld	$431F
	lda	$47D1		;voice patch offset 3 (LFO rate pot value?)
	cma
	mov	e,a
	mvi	d,000h
	dad	d
	dad	h
	dad	h
	dad	h
	dad	h
	lxi	d,02001h
	dad	d
	mov	a,m
	dcx	h
	mov	l,m
	mov	h,a
	mvi	a,000h
	dad	h
	adc	a
	dad	h
	adc	a
	dad	h
	adc	a
	dad	h
	adc	a
	mov	l,h
	mov	h,a
	inx	h

	lda	$42D1		;value for LED Row 2
	ani	003h		;check LFO ramp up (D0) and ramp down (D1)
	jnz	L163C		;skip add if one is set

	dad	h
L163C:
	mov	b,h
	mov	c,l
	lhld	$431F
	dad	h
	dad	h
	dad	h
	dad	h
	dad	d
	ana	a
	mov	a,m
	rar
	cma
	dcx	h
	mov	l,m
	mov	h,a
	mov	a,l
	rar
	cma
	mov	l,a
	inx	h
	lxi	d,0FFFFh

	lda	$42D1		;value for LED Row 2
	ani	00Dh		;check LFO Square, tri, and ramp up bits
	jnz	L166C		;skip if one is set

	mov	a,b
	cma
	mov	b,a		;bc = -bc
	mov	a,c
	cma
	mov	c,a
	inx	b

	xchg

	mov	a,d
	cma
	mov	d,a		;de = -de
	mov	a,e
	cma
	mov	e,a
	inx	d

L166C:
	shld	$4311
	xchg
	shld	$430F

	lda	$42D1		;value for LED Row 2
	ani	002h		;check LFO ramp dn bit
	xchg
	jz	L1684		;skip if not set

	xchg

	mov	a,h
	cma
	mov	h,a		;hl = -hl
	mov	a,l
	cma
	mov	l,a
	inx	h

L1684:
	mov	a,h
	ral
	mov	a,h
	rar
	mov	h,a
	mov	a,l
	rar
	mov	l,a
	shld	$4309
	mov	h,b
	mov	l,c
	shld	$430D

	lda	$42D1		;value for LED Row 2
	ani	003h		;check LFO ramp up and ramp dn bits

	lxi	h,L16DA
	jnz	L16A2
	lxi	h,L16A6
L16A2:				;hl = (rampup | rampdn) ? 16DA : 16A6
	shld	$4313		;these are code addresses
	ret


L16A6:				;more of the LFO code
	lhld	$4000
	sphl
	call	L16B0
	jmp	L16DA

L16B0:
	lhld	$430D

	mov	a,h
	cma
	mov	h,a		;hl = -hl
	mov	a,l
	cma
	mov	l,a
	inx	h

	shld	$430D
	lhld	$430F

	mov	a,h
	cma
	mov	h,a		;hl = -hl
	mov	a,l
	cma
	mov	l,a
	inx	h

	xchg
	lhld	$4311

	mov	a,h
	cma
	mov	h,a		;hl = -hl
	mov	a,l
	cma
	mov	l,a
	inx	h

	shld	$430F
	xchg
	shld	$4311
	ret



L16DA:
	lhld	$4000
	sphl

	lda	$42D5		;value for LED Row 6
	ani	00Fh		;check LFO dest enables
	jnz	L152F		;jump if any are set

	lxi	h,00000h
	shld	$41F3		;seems like LFO 16-bit signed amt for amplitude mod
	shld	$41F5		;seems like LFO 16-bit signed amt for filter mod
	shld	$41EB		;LFO 16-bit signed amt for shape mod (seems like DCO2 PW only)
	shld	$41E9		;seems like LFO 16-bit signed amt for freq mod

	lxi	b,00039h	;select #57
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C



				;#52 in table of code refs
L16FB:				;looks like pitch wheel code				
	lda	$42D3		;value for LED Row 4
	ani	003h		;check both pitch wheel enable bits
	jnz	L1709

L1703:
	lxi	b,00034h	;select #52
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C

L1709:
	lhld	$4385		;tune pot signed 16-bit offset value
	xchg
	lhld	$4383		;16-bit positive freq offset due to patch octave selection, low byte
	dad	d
	xchg

	lda	$431E
	mov	l,a
	mvi	h,0FFh

	lda	$42F1		;pot 24 value, pitch wheel
	mov	c,a
	mvi	b,000h
	dad	b
	dad	h

	lda	$42D3		;value for LED Row 4
	mov	b,a
	ani	001h		;check D0
	jz	L172F

	xchg
	dad	d
	shld	$41E7		;16-bit frequency offset, includes tune pot, patch footage sel, and pitch wheel, if enabled
	xchg
L172F:
	dad	h
	dad	h
	dad	h

	lda	$42D3		;value for LED Row 4		
	ani	002h		;pitch wheel filter cutoff mod enable
	jz	L1703

	lda	$42D5		;value for LED Row 6
	ani	004h		;check LFO filter mod enable 
	shld	$4321		;update pitch wheel filter cutoff mod value
	jnz	L1703		;jump if LFO filter mod is enabled

	shld	$41F5		;seems like LFO 16-bit signed amt for filter mod
	jmp	L1703


				;#53 in table of code addrs, no other ref
L174B:				;looks like pedal code				
	lda	$42D3		;value for LED Row 4
	ani	00Ch		;check pedal filter and VCA control bits
	cz	L01C4		;if 0, pt hl to 4004, store #$4004 at $4002, jump to L012C

	lhld	$4317
	shld	$430B		;copy 16-bit value at 4317 to 430B

	call	L15DB

	lda	$42D1		;value for LED Row 2
	ani	00Ch		;check LFO tri and LFO sqare waveform select?
	jz	L176E

	lda	$4316
	ana	a
	jp	L176E
	call	L16B0
L176E:
	call	L15CA		;copy 8 bytes from $430D to $4315

	lhld	$430B		;copy 16-bit value at 430B to 4317
	shld	$4317

	lxi	b,00035h	;load bc with 53d
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C


L177D:				;#32 in table of code addrs
	lxi	h,00000h
	dad	sp
	shld	$4359		;save sp at 4359
	xchg
	sphl
	call	L17E3
	jmp	L17A6

L178C:
	lxi	h,00000h
	dad	sp
	shld	$4359		;save sp at 4359
	xchg
	sphl

	lda	$42CF		;value for LED Row 0
	mov	c,a

	lda	$4325
	xra	c
	ani	001h
	mov	a,c
	sta	$4325

	jnz	L17B0
L17A6:
	lhld	$4359		;restore sp from 4359
	sphl
	call	L0099		;pop hl,de,bc, and ret
	jmp	L178C

L17B0:
	lda	$4328
	ana	a
	jz	L17A6
	lxi	h,$4328
	lxi	d,$4327
	ldax	d
	cpi	0FFh
	jz	L17CD
	mov	c,a
	mvi	d,000h
	mvi	b,000h
	dad	b
	mov	e,m
	call	L02A6		;call key release routine
L17CD:
	call	L1836
	lxi	h,$4327
	mov	c,m
	mvi	b,000h
	lxi	h,$4328
	dad	b
	mov	e,m
	mvi	d,000h
	call	L01D6		;call key assigner code
	jmp	L17A6


L17E3:
	lda	$42D4		;value for LED Row 5
	mov	d,a
	ani	00Ch		;check Arp up and Arp dn enables
	rz			;return if not enabled

	mov	a,d
	ani	003h		;check play and pause bits
	rnz			;return if either of these is set

	sta	$4328		;clear byte at 4328

	lda	$42D0		;value for LED Row 1
	ani	001h		;check sequence record bit
	jnz	L180D		;if enabled, skip down

	lxi	h,$4326
	mvi	m,000h		;clear key cnt at 4326, inc'd by 086C code

	lxi	b,04218h	;pt to array that holds compl last value read from hw for each key row
	lxi	d,$4328
	call	L086C		;build key # list at de for keys w/bit set in row array at bc, cnt at hl
	call	L1888
	jmp	L182F		;exit

L180D:				;we jump here if sequence record bit is set
	lxi	h,04218h	;pt to array that holds compl last value read from hw for each key row
	lxi	d,$435B		;think this is sequencer virtual keyboard data
	mvi	b,008h		;loop ctr, 8 rows
L1815:
	ldax	d		;read byte from 435B array
	ora	m		;set bits for any keys that are currently pressed
	stax	d		;write it back
	inx	h
	inx	d
	dcr	b
	jnz	L1815		;loop

	lxi	h,$4326
	mvi	m,000h		;clear key cnt at 4326, inc'd by 086C code

	lxi	b,$435B		;guessing this is the sequencer virtual keyboard array
	lxi	d,$4328
	call	L086C		;build key # list at de for keys w/bit set in row array at bc, cnt at hl
	call	L1888
L182F:
	mvi	a,0FFh
	sta	$4327
	add	a		;set cy, a = $FE
	ret



L1836:
	lxi	b,$4374
	lxi	d,$4326

	lxi	h,$4327
	mov	a,m
	cpi	0FFh
	jnz	L1859

	lda	$42D4		;value for LED Row 5
	ani	004h		;check arp up bit
	jz	L1853
L184D:
	mvi	m,000h
	mvi	a,001h
	stax	b
	ret


L1853:
	ldax	d
	mov	m,a
	mvi	a,0FFh
	stax	b
	ret


L1859:
	ldax	d
	ana	a
	rz
	rm
	mov	a,m
	ana	a
	jz	L187A
	xchg
	cmp	m
	xchg
	jz	L186C
L1868:
	ldax	b
	add	m
	mov	m,a
	ret


L186C:
	lda	$42D4		;value for LED Row 5
	ani	008h		;check arp dn bit
	jz	L184D		;jump if not enabled

	call	L1853
	jmp	L1868

L187A:
	lda	$42D4		;value for LED Row 5
	ani	004h		;check arp up bit
	jz	L1853		;jump if not enabled

	call	L184D
	jmp	L1868



L1888:
	lxi	b,$4328		;may be array of key numbers that are currently "pressed" by the sequencer
	lxi	d,$4255		;keyarray starting address
	lda	$4326		;count of key numbers in 4328 array
	ana	a
	rz
L1893:
	ldax	b		;get [bc] into acc
	mvi	h,000h
	mov	l,a		;use [bc] value as index into 4255 array
	dad	d
	mvi	m,0F0h		;write 0xF0 to array location
	inx	b		;increment bc ptr

	lxi	h,$4326		;load count
	dcr	m		;decrement it
	jnz	L1893		;and loop til it's 0

	lxi	d,$4328		;array of new key presses or releases for seq as key numbers
	lxi	h,$4256		;key 1 is here (4255 is not actually used, since keys start at 1)
	lxi	b,$3100		;b is loop ctr (49)
L18AB:
	mvi	a,0F0h
	cmp	m		;see if keyarray contents is F0
	mvi	m,0FFh		;and set it to FF in any case
	jnz	L18B9
				;it was 0F0, so 
	inr	c		;increment our 0F0 values counter
	mvi	a,032h		
	sub	b		;subtract b from 50, so first result is 1
	stax	d		;store result in 4328 array
	inx	d
L18B9:	
	inx	h
	dcr	b
	jnz	L18AB		;we look for up to 49 keys that have 0F0 in array, and place
				;their key numbers in the 4328 array
	mov	a,c
	ana	a
	jz	L18C4
	dcr	a
L18C4:
	sta	$4326		;4326 holds number of 0F0's we found minus 1, or 0 if none found
	ret


				;#55 in table of code addresses, also jumped to one place
L18C8:				;sequencer code				
	mvi	a,080h
	out	0B3h		;latch ctr 2 value
	in	0B2h		;read ctr 2 low byte
	sta	$48E9
	in	0B2h		;read ctr 2 high byte
	sta	$48EA		;save ctr 2 value at $48E9,A
L18D6:
	lda	$42D4		;value for LED Row 5
	mov	b,a
	xri	001h		;invert play bit
	ani	00Dh		;check arpup, arpdn, ~play
	jz	L18E7		;if all 0, then skip

	lxi	b,00037h	;select #55
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C

L18E7:
	mov	a,b
	ani	002h		;check pause
	jz	L18F3		;if not set, skip

L18ED:
	call	L0099		;pop hl,de,bc, and ret
	jmp	L18D6


L18F3:
	lhld	$48E9
	mvi	a,080h		;latch ctr 2 value
	out	0B3h
	in	0B2h		;read ctr 2 low byte
	mov	c,a
	in	0B2h		;read ctr 2 high byte
	mov	b,a		;bc=ctr 2 value read
	mov	a,l
	sub	c
	mov	a,h
	sbb	b		;subtract hl from bc
	jm	L18ED
	lhld	$4387		;sequence RAM ptr
	mov	a,m
	add	a
	jc	L191C

	lda	$42D4		;value for LED Row 5
	ori	002h		;set pause bit
	sta	$42D4
	out	05Dh		;out

	jmp	L18ED

L191C:
	add	a
	cma
	mov	e,a
	mvi	d,0FFh
	jnc	L1928
	inx	h
	mov	a,m
	cma
	mov	d,a
L1928:
	xchg
	dad	b
	shld	$48E9
	xchg
L192E:
	inx	h
	shld	$4387		;sequence RAM ptr
	xchg
	lhld	$48E4
	mov	a,e
	sub	l
	mov	a,d
	sbb	h
	xchg
	jm	L1961

	lda	$42D0		;value for LED Row 1
	ani	004h		;check sequence loop bit
	jnz	L195B		;if enabled, skip

	lda	$42D4		;value for LED Row 5
	ori	002h		;set pause bit
	sta	$42D4
	out	05Dh		;out
L1950:
	call	L0099		;pop hl,de,bc, and ret

	lda	$42D4		;value for LED Row 5
	ani	002h		;check pause bit
	jnz	L1950
L195B:
	call	L1AE6		;maybe sequencer start-up code?
	jmp	L18C8		;sequencer code

L1961:
	mov	a,m
	mov	b,a
	ani	03Fh
	mov	e,a
	mvi	d,000h
	mov	a,b
	add	a
	jc	L18ED
	jm	L1976
	call	L02A6		;call key release routine
	jmp	L1979

L1976:
	call	L01D6		;call key assigner code
				;this call was used when the sequencer was pressing keys
L1979:
	lhld	$4387		;sequence RAM ptr
	jmp	L192E


L197F:				;this is some of the sequencer code
	sta	$4389

	lda	$42D0		;value for LED Row 1
	ani	001h		;check sequence record bit
	rz			;return if not enabled

	lda	$42D4		;value for LED Row 5
	ani	00Fh		;check play, pause, arpup and arpdn bits
	rnz			;return if any are set

L198E:
	lhld	$48E7
	mvi	a,080h		;latch ctr #2 count
	out	0B3h
	in	0B2h		;read ctr 2 low byte
	mov	e,a
	cma
	mov	c,a
	in	0B2h		;read ctr 2 high byte
	mov	d,a
	cma
	mov	b,a
	inx	b		;b = negation of value read
				;de = timer value we read

	dad	b		;add bc to hl pair, so hl = hl - timer value

	xchg			;swap de/hl
	shld	$48E7		;save de (timer value we read) at 48E7

	mov	a,e		;de contains old value minus new value
	rrc			;(8253 counters count down)
	rrc
	ani	03Fh
	mov	e,a		;e = e/4

	mov	a,d
	ana	a		;is d=0?
	mvi	a,080h
	jz	L19B4
	mvi	a,0C0h		;a = (d==0) ? 80h : C0h;
L19B4:
	ora	e		;add in e bits
	lhld	$4387		;sequence RAM ptr
	mov	m,a		;write out a value
	inx	h
	ani	040h		;if a bit 5 set
	jz	L19C1
	mov	m,d		;write out d value as well
	inx	h
L19C1:
	shld	$4387		;save ptr
	xchg			;get ptr in de
	lxi	h,0B010h
	dad	d		;hl = ptr + 0xB010
	xchg			;seq ptr back in hl			
	mov	a,d		;when ptr reaches 4FF0, seq RAM is full 
	ana	a
	jm	L19D9		;if not full, skip

				;otherwise, set pause bit to stop recording
	lda	$42D4		;value for LED Row 5
	ori	002h		;set pause bit
	sta	$42D4
	out	05Dh		;out

L19D9:				;seq ptr is in hl
	lxi	d,$4326
	xchg			;seq ptr in de
	mov	c,m		;get byte at $4326 into c
	lxi	h,$4328
L19E1:
	dcr	c		;dec c
	jm	L19EC
	mov	a,m		;get byte from $4328 array into a, should be key code
	stax	d		;store using seq ptr 
	inx	h
	inx	d		;update seq ptr
	jmp	L19E1

L19EC:
	xchg			;seq ptr in hl
	shld	$4387		;save sequence RAM ptr
	lda	$4389	
	mov	b,a
	ani	040h
	lxi	h,0429Dh
	lxi	d,0429Eh
	jz	L1A05
	lxi	h,04231h
	lxi	d,04234h
L1A05:
	mov	c,m
	mov	a,c
	sta	$4326
	ana	a
	rz
	lxi	h,$4328
L1A0F:
	ldax	d
	ora	b
	mov	m,a
	inx	d
	inx	h
	dcr	c
	jnz	L1A0F
	ret



L1A19:				;this must be some sort of sequencer init
	lxi	h,$48E6		;it's called at startup
	mvi	m,000h

	lxi	h,048EBh
	shld	$48CE

	lxi	h,$48CE		;sequencer table of addresses?
	mvi	c,008h		;~~~should this be 7?  how big is the table? 
L1A29:
	mov	a,m		;get first table byte into acc
	inx	h
	mov	b,m		;second byte into b
	inx	h
	sub	m		;subtract third byte from acc
	inx	h
	mov	a,b
	sbb	m		;subtract fourth byte from b value, with borrow
	jp	L1A70		;if result is positive, jump
	dcx	h		;dec is OK, as we inc'd it 3 times in loop
	dcr	c		;dec lp ctr
	jnz	L1A29		;repeat

L1A39:
	lxi	h,$48CE
	lxi	d,04FF0h
	mvi	c,008h		;loop ctr
L1A41:
	mov	a,m		;subtract 0x4FF0 from hl array value
	sub	e		;but discard resulting value
	inx	h
	mov	a,m
	sbb	d
	jp	L1A64		;if array value >= 0x4FF0, jump

	inx	h	
	dcr	c
	jnz	L1A41		;loop over all 8 elements
L1A4E:
	lhld	$48CE
	shld	$48E2
	shld	$4387		;sequence RAM ptr

	lhld	$48D0
	shld	$48E4

	lxi	h,04FF0h
	shld	$48DE
	ret


L1A64:				;we come here if an element is >= 0x4FF0
	dcx	h		;point to low byte of element
L1A65:
	mov	m,e		;set this element to 4FF0
	inx	h
	mov	m,d
	inx	h		
	dcr	c
	jnz	L1A65		;set remaining elements to 0x4FF0
	jmp	L1A4E

L1A70:
	dcx	h
	lxi	d,04FF0h
L1A74:
	mov	m,e
	inx	h
	mov	m,d
	inx	h
	dcr	c
	jnz	L1A74
	jmp	L1A39


				;called when we press step sw, so maybe this
L1A7F:				;advances to the next set of pointers to record a new sequence?			
	lda	$48E6		;this must be the current sequence number
	inr	a
	ani	007h		;limit 48E6 to 0-7
L1A85:
	sta	$48E6		
	mov	c,a
	mvi	b,000h

	lxi	h,$48CE		;table of 8 16-bit values
	dad	b
	dad	b		;add twice bc to get table address

	mov	e,m
	inx	h
	mov	d,m		;read indexed element into de

	inx	h		
	mov	c,m
	inx	h
	mov	b,m		;read next element into bc

	mov	a,e
	sub	c
	mov	a,d		;subtract second element from first one
	sbb	b

	mvi	a,000h
	jp	L1A85		;if first element is larger than second, 
				;set 48E6 to 0, and 
				;redo subtraction starting at index 0
				;~~~ we never wrote anything back out,
				;so how would this loop terminate?
	xchg
	shld	$48E2
	shld	$4387		;sequence RAM ptr
	mov	h,b
	mov	l,c
	shld	$48E4
L1AAC:

	lxi	b,00007h	;array index/loop ctr
L1AAF:
	lxi	h,$4166		;voice key assignments array start
	dad	b		;add index
	mov	e,m		;get key number 
	mvi	d,000h		;and use it to index into
	lxi	h,04255h	;key status array starting address
	dad	d
	mvi	m,0FFh		;write 0xFF to array element
	dcr	c		
	jp	L1AAF		;iterate through all 8 locations of key assignments array
	ret


				;this must be used when recording, since it erases table entries
L1AC1:				;beyond the one we were using			
	lda	$48E6		;possibly the current sequence number
	inr	a		;add 1 to it
	mov	c,a
	mvi	b,000h
	lxi	h,$48CE		;table of sequencer addresses
	dad	b
	dad	b		;and use that to form table word address
	xchg			;save that in de
 
	lhld	$4387		;get sequence RAM ptr
	xchg			;swap that into de

	mov	m,e		;write sequence ptr into table
	inx	h
	mov	m,d
	inx	h

	mvi	a,008h
	sub	c		;subtract 48E6 value + 1 from 8
	mov	c,a		;use result as loop ctr

	lxi	d,04FF0h
L1ADD:
	mov	m,e
	inx	h
	mov	m,d
	inx	h		;fill the rest of the table with 4FF0, the seq RAM end address
	dcr	c
	jp	L1ADD		;loop

	ret


L1AE6:				;maybe sequencer start-up code?
	lda	$48E6		;looks like some address calculations
L1AE9:
	sta	$48E6
	mov	c,a
	mvi	b,000h
	lxi	h,$48CE		;table of 16-bit values
	dad	b
	dad	b
	mov	e,m		;read byte 0 into e
	inx	h
	mov	d,m		;read byte 1 into d

	inx	h
	mov	c,m		;read byte 2 into c
	inx	h
	mov	b,m		;read byte 3 into b

	mov	a,e
	sub	c
	mov	a,d
	sbb	b		;subtract bc from de
	mvi	a,000h
	jp	L1AE9		;if result was positive, store 0 at 48E6 and repeat with index=0

				;when subtraction result is negative, 
	xchg			;get final de value into hl
	shld	$48E2		;and store in two locations
	shld	$4387		;sequence RAM ptr

	mov	h,b
	mov	l,c
	shld	$48E4		;and store bc value at 48E4
	ret



L1B11:
	lxi	h,04218h	;pt to array that holds compl last value read from hw for each key row
	call	L1B98		;find key # of lowest key currently pressed (1-60), or 0 if none
	rz			;return if no keys are pressed

	mov	b,a		;put result in b
	lda	$438A		;get 438A (chord mode lowest key) variable
	ana	a		;set flags		
	mov	c,a		;save it in c
	jnz	L1B26		;if low key value is not zero, skip

	mov	a,b		
	sta	$438A		;put low key we found above into variable
	mov	c,b		;and into c
L1B26:
	mov	a,b
	sub	c		;subtract low key variable from actual low key value
	mov	d,a		;save result
	jp	L1B46		;if variable is lower than current actual low key, skip

	cma			;otherwise, negate subtraction result
	inr	a		;since it was negative
	mov	d,a		;and save it in d

	mov	a,b		;update low key variable with current actual low key
	sta	$438A

	lda	$438B
	mov	e,a		;get 438B into e as loop ctr

	lxi	h,$438C		;start of 16-byte chord mode array, maybe one byte per oscillator
L1B3A:
	mov	a,m
	ana	a
	jz	L1B41		;if array element is 0, skip it
	add	d		;otherwise, increase it by amount we are decreasing low key
	mov	m,a		;and write it back out
L1B41:
	inx	h
	dcr	e
	jp	L1B3A		;loop

L1B46:
	lda	$42D2		;value for LED Row3
	ani	001h		;check D0 (Mono)
	mvi	e,00Fh
	jnz	L1B52
	mvi	e,001h
L1B52:				;e = (mono) ? 0F : 01
	lda	$438B	
	mov	c,a		;get 438B value into c
	mvi	b,000h

	lxi	h,$438C
	dad	b		;use it to index into chord array
	mov	m,d		;write d into array

	lda	$438B
	inr	a		;increment 438B value
	ana	e		;and it with 0F or 01 mask
	jnz	L1B66		;skip if not 0
	inr	a		;if AND result was 0, then set acc to 1
L1B66:
	sta	$438B		;write AND result or 1 to 438B

	mov	a,e
	cpi	001h
	jnz	L1B7B		;skip if mask is not poly one

	lhld	$438C		;copy the first two array bytes
	shld	$438E		;into the next six locations
	shld	$4390
	shld	$4392
L1B7B:
	lxi	b,0001Fh
	lxi	h,047E3h	;voice 1 patch offset 21d
	lxi	d,$438C
	mvi	a,008h		;loop ctr = 8

L1B86:
	push	psw		;save loop ctr
	ldax	d		;load the first byte from chord array
	mov	m,a		;save in voice 1 patch at offset 21
	inx	d		;bump ptrs
	inx	h
	ldax	d		;load second byte from chord array
	mov	m,a		;save in voice 1 patch at offset 22
	inx	d		;bump srce ptr
	dad	b		;add 31d to dest address, since we already bumped it
				;(copy array values to all 8 voices)
	pop	psw		;get loop ctr

	dcr	a		;dec it
	jnz	L1B86		;and loop

	call	L0AAA		;calls code to convert pots to vce RAM values, once for each voice
	ret


				;determine transpose value based on key last values array
L1B98:				;returned value is 1-60, based on lowest key pressed			
	lxi	b,00800h	;load bc starting value
L1B9B:
	mov	a,m		;get key row value (1=pressed)
	ana	a		;if nothing pressed, skip
	jnz	L1BA8		;if something is pressed, find it
	inx	h		;nothing pressed in that row, so
	dcr	b		;decrement loop ctr
	jnz	L1B9B		;and loop
	jmp	L1BB0

L1BA8:
	rrc			;rotate acc right into cy
	jc	L1BB0		;exit if we find a 1 bit
	inr	c		;otherwise bump c ctr
	jmp	L1BA8

				;at this point, bc contains 0 if no keys were pressed
				;or if a key was pressed, b=8-row number(0-7)				
L1BB0:				;and c = bit pos of pressed key (0-7)			
	mov	a,c	
	add	a
	add	a
	add	a		;multiply c times 8, since keys are arranged vertically in rows
	adi	009h		;add 9-b, or 9-(8-row number), or 1 + row number
	sub	b		;seems like lowest key would transpose by 1
	ret			;could just turn transpose off, I guess



L1BB8:				;#56 in table of code addrs, no other ref
	lxi	h,04218h	;pt to array that holds compl last value read from hw for each key row
	call	L1B98		;find key number of lowest key currently pressed
	dcr	a		;decrement to get 0-59 transpose value
	sta	$439C		;update seq playback transpose value

	lxi	b,00038h	;select #56
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C


L1BC8:				;called if port is enabled
	lxi	h,04218h	;pt to array that holds compl last value read from hw for each key row
	call	L1B98		;find key # of lowest key currently pressed (1-60), or 0 if none
	mov	d,a

	lda	$439D		;if 439D value is not 0
	ana	a
	jnz	L1BDB		;jump

	mov	a,d		;if 439D is 0, write low key number to it
	sta	$439D
	ret

L1BDB:
	sub	d		;subtract new low key from 439D value
	mov	d,a
	lxi	h,$47CF		;and write the result to offset 1 in voice patch storage
	lxi	b,00020h
	lda	$41E6		;using voice mask
L1BE6:
	ana	a
	rz			;return when loop is done
	rar
	jnc	L1BED
	mov	m,d
L1BED:
	dad	b
	jmp	L1BE6		;loop


				;#54 in table of code addrs, no other ref
L1BF1:				;pedal code			
	lda	$42D2		;value for LED Row3
	mov	b,a
	ani	0C0h		;check pedal VCA and filter mod enables
	jnz	L1C00		;skip if one is enabled
L1BFA:
	lxi	b,00036h	;select #54
	call	L01C4		;pt hl to 4004, store #$4004 at $4002, jump to L012C

L1C00:
	lxi	h,042F3h	;pot 26 value (pedal)
	mov	e,m		;get pedal value into d
	mvi	d,0FFh		;sign extend into e

	xchg			;move it into hl
	dad	h
	dad	h
	dad	h
	dad	h		;multiply it by 16
	xchg			;back into de

	lhld	$4323		;pedal filter cutoff mod value

	mov	a,e
	sub	l		;hl = hl - de
	mov	l,a
	mov	a,d
	sbb	h
	mov	h,a

	xchg
	shld	$4323		;pedal filter cutoff mod value

	call	L1C1F
	jmp	L1BFA

L1C1F:
	lxi	h,00000h
	dad	sp
	shld	$4000		;save sp at $4000

	mov	a,b		;get LED row 3 value
	add	a		;shift left to test pedal VCA bit
	mvi	a,000h		;set mask to 0, but
	jnc	L1C2F		;if VCA bit was set, change it to AAh
	mvi	a,0AAh		;so first value for each voice must be for VCA pedal amount
				;since mask is shifted left in the loop
L1C2F:
	jp	L1C34		;current D7 is pedal filter mod enable
	ori	055h		;so if it's set, OR in filter locations, second value
L1C34:
	lxi	sp,$41F7	;ptr to array of two 16-bit values for each voice
	mvi	c,010h		;loop ctr=16d
L1C39:
	dcr	c		;dec lp ctr
	jm	L1C48		;exit loop if neg
	rlc			;rotate acc left into cy
	jnc	L1C44
	pop	h		;if bit set, pop hl
	dad	d		;add de to it
	push	h		;push hl
L1C44:
	pop	h		;move to next value
	jmp	L1C39

L1C48:
	lhld	$4000		;load sp from $4000
	sphl
	ret


				;row 3 switch handler jumps here if any of these
				;are set: port, keytrack, pedal filt and pedal VCA	
L1C4D:				;it's the only way we get here			
	mov	a,d		;holds switch row 3 state
	ani	0E0h		;check keytrack, and two pedal switches
	jz	L1C8F		;skip if not set

	lda	$42D2		;value for LED Row3
	ani	0C0h		;check VCA and filter cutoff pedal mod enables
	jnz	L1C75		;skip if either is enabled

	lhld	$4323		;pedal filter cutoff mod value

	mov	a,l
	cma
	mov	e,a
	mov	a,h		;de = -hl
	cma
	mov	d,a
	inx	d

	lxi	h,00000h
	shld	$4323		;write 0000 to 4323, pedal filter cutoff mod value

	lda	$42CA		;switch row 3 state
	mov	b,a
	call	L1C1F
	jmp	L1C8F


L1C75:
	mov	a,d		;holds switch row 3 state
	ani	0C0h		;check VCA and filter cutoff pedal switches
	jz	L1C8F		;skip if not pressed

	lhld	$4323		;pedal filter cutoff mod value

	mov	a,l
	cma
	mov	e,a		;de = -hl
	mov	a,h
	cma
	mov	d,a
	inx	d

	lda	$42D2		;value for LED Row3
	mov	b,a
	call	L1C1F
	jmp	L1C8F		;~~~ jump to next address!


L1C8F:
	lda	$42D2		;value for LED Row3
	ani	0F0h
	mov	e,a
	lxi	h,048C8h	;~~~this should be offset 26 of voice 8 patch area,
				;top 4 bits control 2'-16' selection
				;looks like some kind of bug, but probably would only
				;show up if we were to save in mono mode
				;possibly this code should have been writing these bits
				;to the low nibble at 47E8 instead
				;not clear that patch should save these settings
	mov	a,m
	ani	00Fh		;clear top 4 bits at 48C8
	ora	e		;insert top 4 bits from LED row 3 there
				;(port enab, keytrack, and two pedal enables)
	mov	m,a		;write it back out

	lda	$42CA		;switch row 3 state
	ana	e		;LED row 3 states
	ani	010h		;check for port sw and port enabled
	jz	L1007		;skip if not both

	sub	a		
	sta	$439D		;clear $439D port interval when we first enable port mode

	jmp	L1007

				;table fcn #41
				;calculates a global tuning offset used by all DCO's
				;which includes the tune pot offset, the footage freq adder
				;due to the selected patch, and the pitch wheel if enabled
L1CAD:
	lda	$42DD		;pot value 4, tune pot
	cma			;invert pot value bits
	sui	080h		;looks like this is the center value
	mvi	d,000h
	mov	h,d
	jp	L1CBD
	mvi	d,007h		;d = (subtraction rslt pos) ? 0 : 7
	mvi	h,0FFh		;h = (subtraction rslt pos) ? 0 : 0FFh
L1CBD:
	ani	0F8h		;clear low 3 bits of subtraction result
	ora	d		;OR in d value
	rrc			;d value now becomes high 3 bits
	rrc			;so essentially we divide pot value by 8
	rrc			;and then sign extend low 5 bits to 8 bits				
	mov	l,a		;that becomes l, and h holds extend to 16 bits value
	shld	$4385		;store 16-bit signed tune offset here
	xchg			;and in de reg

	lhld	$4383		;16-bit positive freq offset due to patch octave selection, low byte
	dad	d		;add tune offset to it

	lda	$42D3		;value for LED Row 4
	ani	001h		;is pitch wheel control of osc pitch enabled?
	jz	L1CE4		;if not, skip

	xchg			;save offset in de
	lda	$431E
	mov	l,a
	mvi	h,0FFh
	lda	$42F1		;pot 24 value (pitch wheel)
	mov	c,a
	mvi	b,000h
	dad	b		;add bc value to hl
	dad	h		;double hl value
	dad	d		;add in offset from other sources

L1CE4:
	shld	$41E7		;16-bit frequency offset, includes tune pot, patch footage sel, and pitch wheel, if enabled

	lxi	b,00029h	;select #41
	call	L01CD		;pt hl to 4006, store #$4006 at $4002, jump to L012C



				;table of 58 code addresses, seems like code executes
				;the first 32 entries in this table continually
L1CED:				;but not in order, it does 02E7, then 03AA, then 
				;049A, then 49A again with previous index + 1, so 
				;it's updating an entire voice with each 4 routines							
	.dw	L02E7		;0, TASM will put low byte first, then high byte
	.dw	L02E7
	.dw	L02E7
	.dw	L02E7
	.dw	L02E7
	.dw	L02E7
	.dw	L02E7
	.dw	L02E7		;7
	
	.dw	L03AA		;8
	.dw	L03AA
	.dw	L03AA
	.dw	L03AA
	.dw	L03AA
	.dw	L03AA
	.dw	L03AA
	.dw	L03AA		;15

	.dw	L049A		;16, should be envelope generator code
	.dw	L049A
	.dw	L049A
	.dw	L049A
	.dw	L049A
	.dw	L049A
	.dw	L049A
	.dw	L049A		;23

	.dw	L049A		;24, should be envelope generator code
	.dw	L049A
	.dw	L049A
	.dw	L049A
	.dw	L049A
	.dw	L049A
	.dw	L049A
	.dw	L049A		;31

	.dw	L177D		;32
	.dw	L0804		;33	;called when a key is pressed
	.dw	L08C3		;34	;called when a key is released
	.dw	L0698		;35	;possibly executed at startup
	.dw	L06A5		;36	;possibly executed at startup
	.dw	L0797		;37	;key scan code
	.dw	L0911		;38	;switch scan /LED code
	.dw	L09AA		;39	;resets pot selectors, then reads first pot value from hw (only called at init)

	.dw	L0D31		;40	;called to process pot 1 (seq rate)
	.dw	L1CAD		;41	;called to process pot 4, tune pot, updates global tuning offset (octave,wheel,tune pot)
	.dw	L0D52		;42	;called to process pot 5, de-tune pot
	.dw	L0D8C		;43	;called to process pot 8, shape pot
	.dw	L0E21		;44	;called when a switch is pressed in row 0
	.dw	L0E4A		;45	;called when a switch is pressed in row 1
	.dw	L0EFF		;46	;called when a switch is pressed in row 2
	.dw	L0F63		;47	;called when a switch is pressed in row 3

	.dw	L110F		;48	;called when a switch is pressed in row 4
	.dw	L11C5		;49	;called when a switch is pressed in row 5, and at startup
	.dw	L12AC		;50	;called when a switch is pressed in row 6
	.dw	L1338		;51	;called when a switch is pressed in row 7
	.dw	L16FB		;52	;looks like pitch wheel code
	.dw	L174B		;53	;possibly pedal code
	.dw	L1BF1		;54	;looks like pedal code
	.dw	L18C8		;55	;sequencer code

	.dw	L1BB8		;56	;finds lowest key, among other things
	.dw	L152C		;57	;LFO code


				;another 16-bit table of RAM addresses
				;I think these values are loaded into de when the above
L1D61:				;routines are called				
	.dw	$439E		;0 seems like start of RAM area for each voice
	.dw	$4424		;1 voice 2
	.dw	$44AA		;2 voice 3
	.dw	$4530		;3 voice 4
	.dw	$45B6		;4 voice 5
	.dw	$463C		;5 voice 6
	.dw	$46C2		;6 voice 7
	.dw	$4748		;7 voice 8
;L1D71
	.dw	$43C2		;8  0x24 into voice 1 RAM area
	.dw	$4448		;9  0x24 into voice 2 RAM area
	.dw	$44CE		;10 0x24 into voice 3 RAM area
	.dw	$4554		;11 0x24 into voice 4 RAM area
	.dw	$45DA		;12 0x24 into voice 5 RAM area
	.dw	$4660		;13 0x24 into voice 6 RAM area
	.dw	$46E6		;14 0x24 into voice 7 RAM area
	.dw	$476C		;15 0x24 into voice 8 RAM area
;L1D81
	.dw	$43CC		;16 0x2E into voice 1 RAM area, start of VCA env parms
	.dw	$43F8		;17 0x5A into voice 1 RAM area, start of filter env parms

	.dw	$4452		;18 0x2E into voice 2 RAM area
	.dw	$447E		;19 0x5A into voice 2 RAM area

	.dw	$44D8		;20 0x2E into voice 3 RAM area
	.dw	$4504		;21 0x5A into voice 3 RAM area

	.dw	$455E		;22 0x2E into voice 4 RAM area
	.dw	$458A		;23 0x5A into voice 4 RAM area

	.dw	$45E4		;24 0x2E into voice 5 RAM area
	.dw	$4610		;25 0x5A into voice 5 RAM area

	.dw	$466A		;26 0x2E into voice 6 RAM area
	.dw	$4696		;27 0x5A into voice 6 RAM area

	.dw	$46F0		;28 0x2E into voice 7 RAM area
	.dw	$471C		;29 0x5A into voice 7 RAM area

	.dw	$4776		;30 0x2E into voice 8 RAM area
	.dw	$47A2		;31 0x5A into voice 8 RAM area

;L1DA1
	.dw	$4373		;32 no clue, probably a RAM address
	.dw	$4254		;33 one byte below keystate array at 4255
	.dw	$42BE		;34 one byte below switch new data array at 42BF


				;This is initialization data that's copied to RAM
				;at start-up, 52 bytes for each voice.
L1DA7:				;voice 1/8?
	.db	$60		;0, DCO 1 timer I/O address			
	.db	$60		;1, DCO 1 timer I/O address
	.db	$00		;2
	.db	$00		;3
	.db	$01		;4
	.db	$01		;5
	.db	$62		;6, DCO 2 timer I/O address	
	.db	$62		;7, DCO 2 timer I/O address
	.db	$02		;8
	.db	$02		;9

	.db	$03		;10
	.db	$03		;11
	.db	$61		;12, third voice timer I/O address
	.db	$61		;13, third voice timer I/O address
	.db	$05		;14
	.db	$05		;15
	.dw	$439E		;16, address of start of RAM area for this voice
	.dw	$43A2		;18, used to update final adder portamento with a push instr

	.dw	L059C		;20, $059C is a code address 
	.db	$06		;22
	.db	$06		;23
	.dw	L05DF		;24, $05DF is a code address, stack is pointed to this
	.db	$06		;26
	.db	$06		;27
	.db	$06		;28
	.db	$06		;29

	.db	$06		;30
	.db	$06		;31
	.db	$0D		;32
	.db	$06		;33
	.db	$06		;34
	.db	$06		;35
	.dw	L059C		;36, $059C is a code address
	.db	$04		;38
	.db	$04		;39

	.dw	L05DF		;40, $05DF is a code address, stack is pointed to this
	.db	$04		;42
	.db	$04		;43
	.db	$06		;44
	.db	$06		;45
	.db	$04		;46
	.db	$04		;47
	.db	$0D		;48
	.db	$06		;49

	.db	$04		;50
	.db	$04		;51


L1DDB:				;voice 2/8?
	.db	$64		;0, timer base address?
	.db	$64		; timer base address?
	.db	$08
	.db	$08
	.db	$09
	.db	$09
	.db	$66
	.db	$66
	.db	$0A
	.db	$0A

	.db	$0B		;10
	.db	$0B
	.db	$65
	.db	$65
	.db	$0D
	.db	$0D
	.dw	$4424		;16, address of start of RAM area for this voice
	.dw	$4428		;18 

	.dw	L059C		;20, $059C is a code address 
	.db	$0E
	.db	$0E
	.dw	L05DF		;24, $05DF is a code address, stack is pointed to this
	.db	$0E
	.db	$0E
	.db	$06
	.db	$06

	.db	$0E		;30
	.db	$0E
	.db	$0D
	.db	$06
	.db	$0E
	.db	$0E
	.dw	L059C		;$059C is a code address 
	.db	$0C
	.db	$0C

	.dw	L05DF		;40, $05DF is a code address, stack is pointed to this
	.db	$0C
	.db	$0C
	.db	$06
	.db	$06
	.db	$0C
	.db	$0C
	.db	$0D
	.db	$06

	.db	$0C		;50
	.db	$0C		;51


L1E0F:				;voice 3/8?
	.db	$68		;0 , timer base address?
	.db	$68		; timer base address?
	.db	$10
	.db	$10
	.db	$11
	.db	$11
	.db	$6A
	.db	$6A
	.db	$12
	.db	$12

	.db	$13		;10
	.db	$13
	.db	$69
	.db	$69
	.db	$15
	.db	$15
	.dw	$44AA		;16, address of start of RAM area for this voice
	.dw	$44AE		;18

	.dw	L059C		;20, $059C is a code address 
	.db	$16
	.db	$16
	.dw	L05DF		;24, $05DF is a code address, stack is pointed to this
	.db	$16
	.db	$16
	.db	$06
	.db	$06

	.db	$16		;30
	.db	$16
	.db	$0D
	.db	$06
	.db	$16
	.db	$16
	.dw	L059C		;$059C is a code address 
	.db	$14
	.db	$14

	.dw	L05DF		;40, $05DF is a code address, stack is pointed to this
	.db	$14
	.db	$14
	.db	$06
	.db	$06
	.db	$14
	.db	$14
	.db	$0D
	.db	$06

	.db	$14		;50
	.db	$14		;51


L1E43:				;voice 4/8?
	.db	$6C		;0, timer base address?
	.db	$6C		; timer base address?
	.db	$18
	.db	$18
	.db	$19
	.db	$19
	.db	$6E
	.db	$6E
	.db	$1A
	.db	$1A

	.db	$1B		;10
	.db	$1B
	.db	$6D
	.db	$6D
	.db	$1D
	.db	$1D
	.dw	$4530		;16, address of start of RAM area for this voice
	.dw	$4534		;18

	.dw	L059C		;20, $059C is a code address 
	.db	$1E
	.db	$1E
	.dw	L05DF		;24, $05DF is a code address, stack is pointed to this
	.db	$1E
	.db	$1E
	.db	$06
	.db	$06

	.db	$1E		;30
	.db	$1E
	.db	$0D
	.db	$06
	.db	$1E
	.db	$1E
	.dw	L059C		;$059C is a code address 
	.db	$1C
	.db	$1C

	.dw	L05DF		;40, $05DF is a code address, stack is pointed to this
	.db	$1C
	.db	$1C
	.db	$06
	.db	$06
	.db	$1C
	.db	$1C
	.db	$0D
	.db	$06

	.db	$1C		;50
	.db	$1C		;51


L1E77:				;voice 5/8?
	.db	$70		;0 , timer base address?
	.db	$70		; timer base address?
	.db	$20
	.db	$20
	.db	$21
	.db	$21
	.db	$72
	.db	$72
	.db	$22
	.db	$22

	.db	$23		;10
	.db	$23
	.db	$71
	.db	$71
	.db	$25
	.db	$25
	.dw	$45B6		;16, address of start of RAM area for this voice
	.dw	$45BA		;18

	.dw	L059C		;20, $059C is a code address 
	.db	$26
	.db	$26
	.dw	L05DF		;24, $05DF is a code address, stack is pointed to this
	.db	$26
	.db	$26
	.db	$06
	.db	$06

	.db	$26		;30
	.db	$26
	.db	$0D
	.db	$06
	.db	$26
	.db	$26
	.dw	L059C		;36, $059C is a code address 
	.db	$24
	.db	$24

	.dw	L05DF		;40, $05DF is a code address, stack is pointed to this
	.db	$24
	.db	$24
	.db	$06
	.db	$06
	.db	$24
	.db	$24
	.db	$0D
	.db	$06

	.db	$24		;50
	.db	$24		;51

L1EAA:				;voice 6/8?
	.db	$74		;0, timer base address?
	.db	$74		;timer base address?
	.db	$28
	.db	$28
	.db	$29
	.db	$29
	.db	$76
	.db	$76
	.db	$2A
	.db	$2A

	.db	$2B		;10
	.db	$2B
	.db	$75
	.db	$75
	.db	$2D
	.db	$2D
	.dw	$463C		;16, address of start of RAM area for this voice
	.dw	$4640		;18

	.dw	L059C		;20, $059C is a code address 
	.db	$2E
	.db	$2E
	.dw	L05DF		;24, $05DF is a code address, stack is pointed to this
	.db	$2E
	.db	$2E
	.db	$06
	.db	$06

	.db	$2E		;30
	.db	$2E
	.db	$0D
	.db	$06
	.db	$2E
	.db	$2E
	.dw	L059C		;36, $059C is a code address 
	.db	$2C
	.db	$2C

	.dw	L05DF		;40, $05DF is a code address, stack is pointed to this
	.db	$2C
	.db	$2C
	.db	$06
	.db	$06
	.db	$2C
	.db	$2C
	.db	$0D
	.db	$06

	.db	$2C		;50
	.db	$2C		;51

L1EDF:				;voice 7/8?
	.db	$78		;0, timer base address?
	.db	$78		; timer base address?
	.db	$30
	.db	$30
	.db	$31
	.db	$31
	.db	$7A
	.db	$7A
	.db	$32
	.db	$32

	.db	$33		;10
	.db	$33
	.db	$79
	.db	$79
	.db	$35
	.db	$35
	.dw	$46C2		;16, address of start of RAM area for this voice
	.dw	$46C6

	.dw	L059C		;20, $059C is a code address 
	.db	$36
	.db	$36
	.dw	L05DF		;24, $05DF is a code address, stack is pointed to this
	.db	$36
	.db	$36
	.db	$06
	.db	$06

	.db	$36		;30
	.db	$36
	.db	$0D
	.db	$06
	.db	$36
	.db	$36
	.dw	L059C		;36, $059C is a code address 
	.db	$34
	.db	$34

	.dw	L05DF		;40, $05DF is a code address, stack is pointed to this
	.db	$34
	.db	$34
	.db	$06
	.db	$06
	.db	$34
	.db	$34
	.db	$0D
	.db	$06

	.db	$34		;50
	.db	$34		;51


L1F13:				;voice 8/8?
	.db	$7C		;0, timer base address?
	.db	$7C		; timer base address?
	.db	$38
	.db	$38
	.db	$39
	.db	$39
	.db	$7E
	.db	$7E
	.db	$3A
	.db	$3A

	.db	$3B		;10
	.db	$3B
	.db	$7D
	.db	$7D
	.db	$3D
	.db	$3D
	.dw	$4748		;16, address of start of RAM area for this voice
	.dw	$474C		;18

	.dw	L059C		;20, $059C is a code address 
	.db	$3E
	.db	$3E
	.dw	L05DF		;24, $05DF is a code address, stack is pointed to this
	.db	$3E
	.db	$3E
	.db	$06
	.db	$06

	.db	$3E		;30
	.db	$3E
	.db	$0D
	.db	$06
	.db	$3E
	.db	$3E
	.dw	L059C		;36, $059C is a code address 
	.db	$3C
	.db	$3C

	.dw	L05DF		;40, $05DF is a code address, stack is pointed to this
	.db	$3C
	.db	$3C
	.db	$06
	.db	$06
	.db	$3C
	.db	$3C
	.db	$0D
	.db	$06

	.db	$3C		;50
	.db	$3C		;51

L1F47:
	.db	$00

L1F48:				;look like 180d FF bytes in this EPROM

	#IFDEF	STRTUPDLY

wt50ms:				;delay 50 mSec, to insure SRAM enables are on
	lxi	h,4167
declp:
	dcx	h		;6 states
	mov	a,l		;4 states
	ora	h		;4 states
	jnz	declp		;10
				;24 states or 12 uSec

	mvi	a,020h		;set ctr 0 to be mode 0, high byte only
	out	0B3h

	jmp	stdlyret	;jump back to startup code

	#ENDIF

	
	#IFDEF	CHGPOTSCAN	
				;new code to walk through pot select values in two ranges, 0-19 and 24-26
				;we still alternate between them, but a little differently
				;now we look at next pot to be scanned, incr it, and check for skip
nextpot:
	lhld	$42D7		;read both pot select bytes
				;l holds the last pot that was converted, h holds the one before that,
				;when we exit, l will hold next pot to scan
	mov	a,h		;check what will be the next pot to scan
	cpi	14d		;filter sustain?
	jnz	notptchnxt
	mvi	h,24d		;set up the pitch wheel next
	lda	$42D3		;value for LED Row 4
	ani	003h		;check both pitch wheel enable bits
	jnz	swapnret	;pitch wheel is next, and we need to do it

nxtslow:			;don't swap, 
	dcr	l		;just do next in slow group, decr index 		
	jm	lisneg		;is l=negative?
	mov	a,l
	cpi	14d		;is l=14?
	jnz	lisnot14
	dcr	l		;skip 14 after slow grp dec, since it's in fast group now
lisnot14:
	shld	$42D7		;write l and h back out, no swap
	ret

lisneg:	mvi	l,19d		;yes, wrap it to 19
	shld	$42D7		;write l and h back out, no swap
	ret
	
swapnret:			;we are happy with the next pot to convert
	mov	a,l		;swap h and l	
	mov	l,h		
	mov	h,a		;save next slow pot in h
	shld	$42D7		;write it back out
	ret

notptchnxt:
	cpi	20d		;is it in slow group?
	jc	slownxt		;if so, jump down
				;pot before last one is in fast group and not 14
	cpi	24d		;pitch wheel?
	jnz	notmodnxt
	inr	h		;set up the mod wheel next
	lda	$42D3		;value for LED Row 4
	ani	00Ch		;check both mod wheel enable bits
	jnz	swapnret	;mod wheel is next, and we need to do it
	jmp	nxtslow


notmodnxt:
	cpi	25d		;mod wheel
	jnz	notpednxt
	inr	h		;set up the pedal		
	lda	$42D2		;value for LED Row3
	ani	0C0h		;check pedal VCA and filter mod enables
	jnz	swapnret	;pedal is next, and we need to do it
	jmp	nxtslow

notpednxt:			;must be 26, so
	mvi	h,14d		;do filter sustain next
	jmp	swapnret

slownxt:
	dcr	h		;decrement slow index
	jm	hisneg		;is h negative?
	mov	a,h		
	cpi	14d		;is h = 14?
	jnz	hisnot14
	dcr	a		;skip 14 after slow grp dec, since it's in fast group now
hisnot14:
	mov	h,l
	mov	l,a
	shld	$42D7		;write l and h back out
	ret

hisneg:	mov	h,l
	mvi	l,19d		;yes, wrap it to 19
	shld	$42D7		;write l and h back out
	ret


	#ENDIF


	.FILL	($2000-$),0FFh	

	.end
